pP2PrefsRegistryKey = "HKCU\Software\DND\InDesign_ProMotor\"
'SET THE VERSION HERE:
theVersion = ""
'theVersion = "4"
'theVersion = "CC"
'theVersion = "CC.2014"

if(theVersion = "")then
	'Load the version
	theVersion = ReadPref("ID_Version")
end if


if (theVersion <> "") then

	Set myInDesign = CreateObject("InDesign.Application." & theVersion)

	'Check document is open.
	If myInDesign.Documents.Count <> 0 Then
	
		'Check one element is selected.
		If myInDesign.Selection.Count = 1 Then
			
			set myElem = myInDesign.Selection.Item(1)
			
			'Check selected element is new or type is text.
			if (myElem.ExtractLabel ("type") = "area") OR (myElem.ExtractLabel ("type") = "") then
			
				'Checl selected element is the right type.
				Select Case TypeName(myElem)
				Case "Rectangle", "Text", "TextFrame"
						myDisplayDialog myInDesign, myElem
				Case Else
						MsgBox ("Please select an element.")
				End Select
			else
				MsgBox ("This element has been configured as a " & myElem.ExtractLabel("type") & " elemenet.")
			end if
		Else
			MsgBox ("Please select an element.")
		End If
	Else
		MsgBox ("Please open a document.")
	End If
else
	MsgBox ("Please configure your scripts.")
end if



Function myDisplayDialog(myInDesign, myObject)
	dim setAreaName, setSort, setRows, setCols, setStyleCode
	
	
	if(myObject.Label = "") then
		'Newly configured element
		
		setAreaName = "Area " & getNextSort("area", myInDesign)
		
		'Set the sort
		setSort = getNextSort("area", myInDesign)		
	else
		setAreaName = myObject.Label
		setSort = myObject.ExtractLabel ("sort")
	end if
	
	setRows = myObject.ExtractLabel ("rows")
	setCols = myObject.ExtractLabel ("cols")
	setStyleCode = myObject.ExtractLabel ("styleCode")
	
	
	Set myDialog = myInDesign.Dialogs.Add
	myDialog.Name = "Configure Area"
	
	With myDialog.DialogColumns.Add
		With .BorderPanels.Add
			With .DialogColumns.Add
				With .DialogRows.Add
					With .DialogColumns.Add
						With .StaticTexts.Add
							.staticLabel = "Sort"
						End With
						With .StaticTexts.Add
							.staticLabel = "Rows"
						End With
						With .StaticTexts.Add
							.staticLabel = "Columns"
						End With
						With .StaticTexts.Add
							.staticLabel = "Style Code"
						End With												
					End With
					With .DialogColumns.Add
						Set areaSort = .TextEditboxes.Add
						With areaSort
							.EditContents = setSort
						End With
						Set areaRows = .TextEditboxes.Add
						With areaRows
							.EditContents = setRows
						End With
						Set areaCols = .TextEditboxes.Add
						With areaCols
							.EditContents = setCols
						End With
						Set styleCode = .TextEditboxes.Add
						With styleCode
							.EditContents = setStyleCode
						End With
					End With
				End With
			End With
		End With
		
		With .BorderPanels.Add
			With .DialogColumns.Add
				With .DialogRows.Add
					With .DialogColumns.Add
						With .StaticTexts.Add
							.staticLabel = "CLEAR ALL CONFIGURED DATA?"
						End With
					End With
					With .DialogColumns.Add
						Set clearData = .checkboxControls.Add
						With clearData
							.checkedState = false
						End With
					End With
				End With
			End With
		End With
	End With
	
	
	
	
	'display dialog
	myReturn = myDialog.Show
	
	
	
	
	If myReturn = True Then
		'Get the values from the dialog box.
		
		if(clearData.checkedState = true) then
			
			clearIt = MsgBox("Are you sure you want to clear all of the configured data for this element?", vbYesNo, "Clear Data")
			continueOn = (clearIt = vbYes)
			
			if continueOn then
				myObject.Label = ""
				myObject.InsertLabel "type", ""
				myObject.InsertLabel "sort", ""
				myObject.InsertLabel "rows", ""
				myObject.InsertLabel "cols", ""
				myObject.InsertLabel "styleCode", ""
			end if
		else
			if (areaSort.EditContents <> "") then
				myObject.Label = "set"
				myObject.InsertLabel "type", "area"
				
				myObject.InsertLabel "sort", areaSort.EditContents
				myObject.InsertLabel "rows", areaRows.EditContents
				myObject.InsertLabel "cols", areaCols.EditContents
				myObject.InsertLabel "styleCode", styleCode.EditContents
			else
				MsgBox ("Sort order cannot be blank.")
			end if
		end if
	End If
End Function




Function ReadPref(theKey)
	Dim wsh
	Dim returnMe
	Set wsh = CreateObject("WScript.Shell")
	
	On Error Resume Next
		returnMe = wsh.RegRead(pP2PrefsRegistryKey & theKey)
	On Error Goto 0
	
	ReadPref = returnMe
End Function


Function getNextSort (theType, myInDesign)
	dim finalSort, myCounter, elemType
	
	finalSort = 0
	
	'Loop through elements on current document
	For myCounter = 1 To myInDesign.ActiveDocument.PageItems.Count
		elemType = myInDesign.ActiveDocument.PageItems.Item(myCounter).ExtractLabel ("type")
		
		if(elemType = theType) then
			newSort = cInt(myInDesign.ActiveDocument.PageItems.Item(myCounter).ExtractLabel ("sort"))
			
			if (newSort > finalSort) then
				finalSort = newSort
			end if
		end if	
	Next
	
	finalSort = finalSort + 1
	
	getNextSort = CStr(finalSort)
End Function

