pP2PrefsRegistryKey = "HKCU\Software\DND\InDesign_ProMotor\"
'SET THE VERSION HERE:
theVersion = ""
'theVersion = "4"
'theVersion = "CC"
'theVersion = "CC.2014"

if(theVersion = "")then
	'Load the version
	theVersion = ReadPref("ID_Version")
end if


if (theVersion <> "") then
	Set myInDesign = CreateObject("InDesign.Application." & theVersion)
	
	If myInDesign.Documents.Count <> 0 Then
		if (myInDesign.Documents(1).DocumentPreferences.FacingPages = false) then
			myDisplayDialog myInDesign
		else
			MsgBox ("The document cannot be configured with facing pages turned on.")
		end if
	Else
		MsgBox ("Please open a document.")
	End If
	
	
	Function myDisplayDialog(myInDesign)
		dim setDocName, myDoc, groupListText, folderListText
		
		
		set myDoc = myInDesign.Documents(1)
	
		'Set group drop down values
		groupListText = GetGroupList()
		setGroup = 0
		If (groupListText <> "") Then
			
			groupListText = "Please Select," + groupListText
			groupListText = Replace(groupListText,chr(13),"")
			groupListText = Replace(groupListText,chr(10),"")
			
			groupList = Split(groupListText, ",")
			
			For i = LBound(groupList) to UBound(groupList)
				if(groupList(i) = myDoc.ExtractLabel ("group")) then
					setGroup = i
				end if
			Next
		Else
			dim groupList(0)
			groupList(0) = "Unable to connect to server."
		End If
		
		
		
		if(myDoc.Label = "") then
			'Newly configured element
			setDocName = ""
		else
			setDocName = myDoc.Label
		end if

		setDocDisplayName = myDoc.ExtractLabel ("displayName")
		
		setStyleCode = myDoc.ExtractLabel ("styleCode")
		setRows = myDoc.ExtractLabel ("rows")
		setCols = myDoc.ExtractLabel ("cols")
		
		
		setWhiteText = false
		if(myDoc.ExtractLabel ("whiteText") = "true") then
			setWhiteText = true
		end if
		
		
		setSplit = false
		if(myDoc.ExtractLabel ("splitPages") = "true") then
			setSplit = true
		end if


		setJpgExport = false
		if(myDoc.ExtractLabel ("jpgExport") = "true") then
			setJpgExport = true
		end if


		setForceCrop = false
		if(myDoc.ExtractLabel ("forceCrop") = "true") then
			setForceCrop = true
		end if
		
		
		setProdAccess = false
		if(myDoc.ExtractLabel ("prodAccess") = "true") then
			setProdAccess = true
		end if

		setMultiPageListing = false
		if(myDoc.ExtractLabel ("multiPageListing") = "true") then
			setMultiPageListing = true
		end if
		
		'get the url
		theURL = ReadPref("Server_URL")
		
		
		if(myDoc.ExtractLabel ("dontLink") = "true") then
			setDontLink = true
		else
			'custom code for essex and taunton
			if(theURL = "http://essex.ezadspro.co.uk/") OR (theURL = "http://taunton.ezadspro.co.uk/")then
				'newly configured element
				if(myDoc.Label = "") then
					setDontLink = true
				else
					setDontLink = false
				end if
			else
				setDontLink = false
			end if
		end if
		
		
		Set myDialog = myInDesign.Dialogs.Add
		myDialog.Name = "Configure Document"
		
		With myDialog.DialogColumns.Add
			With .BorderPanels.Add
				With .DialogColumns.Add
					With .DialogRows.Add
						With .DialogColumns.Add
							With .StaticTexts.Add
								.staticLabel = "Name"
							End With
							With .StaticTexts.Add
								.staticLabel = "Style Code"
							End With
							With .StaticTexts.Add
								.staticLabel = "Rows"
							End With
							With .StaticTexts.Add
								.staticLabel = "Columns"
							End With
							With .StaticTexts.Add
								.staticLabel = "Group"
							End With
							With .StaticTexts.Add
								.staticLabel = "Display Name"
							End With
							With .StaticTexts.Add
								.staticLabel = "Production Access Only"
							End With
							With .StaticTexts.Add
								.staticLabel = "Multi Page Listing"
							End With
							With .StaticTexts.Add
								.staticLabel = "Don't Upload Artwork"
							End With
							With .StaticTexts.Add
								.staticLabel = "Split and Zip Output"
							End With
							With .StaticTexts.Add
								.staticLabel = "JPG Output"
							End With
							With .StaticTexts.Add
								.staticLabel = "Force Crop PDF Preset"
							End With
							With .StaticTexts.Add
								.staticLabel = "Set Background Colour"
							End With
						End With
						With .DialogColumns.Add
							Set docName = .TextEditboxes.Add
							With docName
								.EditContents = setDocName
								.MinWidth = 150
							End With
							Set styleCode = .TextEditboxes.Add
							With styleCode
								.EditContents = setStyleCode
								.MinWidth = 150
							End With
							Set docRows = .TextEditboxes.Add
							With docRows
								.EditContents = setRows
							End With
							Set docCols = .TextEditboxes.Add
							With docCols
								.EditContents = setCols
							End With
							Set docGroup = .dropdowns.Add
							With docGroup
								.StringList = groupList
								.selectedIndex = setGroup                           
							End With
							Set docDisplayName = .TextEditboxes.Add
							With docDisplayName
								.EditContents = setDocDisplayName
								.MinWidth = 150
							End With
							Set prodAccess = .checkboxControls.Add
							With prodAccess
								.checkedState = setProdAccess                          
							End With
							Set multiPageListing = .checkboxControls.Add
							With multiPageListing
								.checkedState = setMultiPageListing                         
							End With
							Set dontLink = .checkboxControls.Add
							With dontLink
								.checkedState = setDontLink                         
							End With
							Set splitPages = .checkboxControls.Add
							With splitPages
								.checkedState = setSplit                       
							End With
							Set jpgExport = .checkboxControls.Add
							With jpgExport
								.checkedState = setJpgExport                       
							End With
							Set forceCrop = .checkboxControls.Add
							With forceCrop
								.checkedState = setForceCrop
							End With
							Set whiteText = .checkboxControls.Add
							With whiteText
								.checkedState = setWhiteText                       
							End With
						End With
					End With
				End With
			End With
			
			With .BorderPanels.Add
				With .DialogColumns.Add
					With .DialogRows.Add
						With .DialogColumns.Add
							With .StaticTexts.Add
								.staticLabel = "CLEAR ALL CONFIGURED DATA?"
							End With
						End With
						With .DialogColumns.Add
							Set clearData = .checkboxControls.Add
							With clearData
								.checkedState = false
							End With
						End With
					End With
				End With
			End With
		End With
	
		myReturn = myDialog.Show
		
		If myReturn = True Then
			'Get the values from the dialog box.
			
			if(clearData.checkedState = true) then
				
				clearIt = MsgBox("Are you sure you want to clear all of the configured document data?", vbYesNo, "Clear Data")
				continueOn = (clearIt = vbYes)
				
				if continueOn then
					myDoc.Label = ""
					myDoc.InsertLabel "rows", ""
					myDoc.InsertLabel "cols", ""
					myDoc.InsertLabel "keyWord", ""
					myDoc.InsertLabel "category", ""
					myDoc.InsertLabel "sub category", ""
					myDoc.InsertLabel "styleCode", ""
					myDoc.InsertLabel "group", ""
					myDoc.InsertLabel "prodAccess", ""
					myDoc.InsertLabel "dontLink", ""
					myDoc.InsertLabel "splitPages", ""
					myDoc.InsertLabel "whiteText", ""
					myDoc.InsertLabel "displayName", ""
					myDoc.InsertLabel "multiPageListing", ""
					myDoc.InsertLabel "jpgExport", ""
					myDoc.InsertLabel "forceCrop", ""
				end if
			else			
				'Make sure the document name has been filled in
				if (docName.EditContents <> "") then
					myDoc.Label = docName.EditContents
					myDoc.InsertLabel "displayName", docDisplayName.EditContents


					myDoc.InsertLabel "rows", docRows.EditContents
					myDoc.InsertLabel "cols", docCols.EditContents
					
					myDoc.InsertLabel "styleCode", styleCode.EditContents
					myDoc.InsertLabel "group", groupList(docGroup.selectedIndex)
					
					if(splitPages.checkedState = true) then
						myDoc.InsertLabel "splitPages", "true"
					else
						myDoc.InsertLabel "splitPages", "false"
					end if

					if(jpgExport.checkedState = true) then
						myDoc.InsertLabel "jpgExport", "true"
					else
						myDoc.InsertLabel "jpgExport", "false"
					end if

					if(forceCrop.checkedState = true) then
						myDoc.InsertLabel "forceCrop", "true"
					else
						myDoc.InsertLabel "forceCrop", "false"
					end if
					
					if(whiteText.checkedState = true) then
						myDoc.InsertLabel "whiteText", "true"
					else
						myDoc.InsertLabel "whiteText", "false"
					end if
					
					if(prodAccess.checkedState = true) then
						myDoc.InsertLabel "prodAccess", "true"
					else
						myDoc.InsertLabel "prodAccess", "false"
					end if

					if(multiPageListing.checkedState = true) then
						myDoc.InsertLabel "multiPageListing", "true"
					else
						myDoc.InsertLabel "multiPageListing", "false"
					end if
					
					if(dontLink.checkedState = true) then
						myDoc.InsertLabel "dontLink", "true"
					else
						myDoc.InsertLabel "dontLink", ""
					end if
				else
					MsgBox ("Document name cannot be blank.")
				end if
			end if
		End If
	End Function
else
	MsgBox ("Please configure your scripts.")
end if



Function ReadPref(theKey)
	Dim wsh
	Dim returnMe
	Set wsh = CreateObject("WScript.Shell")
	
	On Error Resume Next
		returnMe = wsh.RegRead(pP2PrefsRegistryKey & theKey)
	On Error Goto 0
	
	ReadPref = returnMe
End Function


Function getNextSort (theType, myInDesign)
	dim finalSort, myCounter, elemType
	
	finalSort = 0
	
	'Loop through elements on current document
	For myCounter = 1 To myInDesign.ActiveDocument.PageItems.Count
		elemType = myInDesign.ActiveDocument.PageItems.Item(myCounter).ExtractLabel ("type")
		
		if(elemType = theType) then
			newSort = cInt(myInDesign.ActiveDocument.PageItems.Item(myCounter).ExtractLabel ("sort"))
			
			if (newSort > finalSort) then
				finalSort = newSort
			end if
		end if	
	Next
	
	finalSort = finalSort + 1
	
	getNextSort = CStr(finalSort)
End Function


Function CreateGUID
  Dim TypeLib
  Set TypeLib = CreateObject("Scriptlet.TypeLib")
  CreateGUID = Mid(TypeLib.Guid, 2, 36)
End Function


Function GetGroupList()
	dim theURL, theResult

	theURL = ReadPref("Server_URL")
	theResult = DownloadLongText(theURL & "4dcgi/u_get_group_list.a4d?unique=" & CreateGUID)
	
	GetGroupList = theResult
End Function


Function DisplayError(theMessage)
	msgbox(theMessage)
End Function



Function DownloadLongText(ByVal url)
	Dim returnMe
	Dim errTemp
	Dim xmlhttp
	
	returnMe = ""

	On Error Resume Next
	Set xmlhttp = CreateObject("MSXML2.XMLHTTP")

	errTemp = Err.Number
	If errTemp <> 0 Then
		msgbox("Unable to create scripting object: MSXML2.XMLHTTP")
		msgbox(Err.Description )
	End If

	If errTemp = 0 Then
		Call xmlhttp.Open("GET", url, False)
		errTemp = Err.Number
	End If
	
	If errTemp = 0 Then
		xmlhttp.Send
		errTemp = Err.Number
	End If

	If errTemp = 0 Then
		returnMe = xmlhttp.ResponseText
	End If
	
	DownloadLongText = returnMe
End Function


Function GetHotFolderList()
	dim theURL, theResult

	theURL = ReadPref("Server_URL")
	theResult = DownloadLongText(theURL & "u_get_hotfolder_list.a4d")
	
	GetHotFolderList = theResult
End Function


Function GetCategoryList()
	dim theURL, theCategories, theID

	theURL = ReadPref("Server_URL")
	theID = ReadPref("Server_BF")
	theCategories = DownloadLongText(theURL & "u_get_category_list.a4d?id=" & theID)
	
	GetCategoryList = theCategories
End Function
