pP2PrefsRegistryKey = "HKCU\Software\DND\InDesign_ProMotor\"
'SET THE VERSION HERE:
theVersion = ""
'theVersion = "4"
'theVersion = "CC"
'theVersion = "CC.2014"

if(theVersion = "")then
	'Load the version
	theVersion = ReadPref("ID_Version")
end if


if (theVersion <> "") then

	Set myInDesign = CreateObject("InDesign.Application." & theVersion)

	'Check document is open.
	If myInDesign.Documents.Count <> 0 Then
	
		'Check one element is selected.
		If myInDesign.Selection.Count = 1 Then
			
			set myElem = myInDesign.Selection.Item(1)
			
			'Check selected element is the right type.
			Select Case TypeName(myElem)
				Case "Rectangle", "Oval", "Polygon", "Group", "TextFrame"
					'Check selected element is new or type is flash.
					if (myElem.ExtractLabel ("type") = "flash") OR (myElem.ExtractLabel ("type") = "") then
						'Check selected element is the right type.
						myDisplayDialog myInDesign, myElem
					else
						MsgBox ("This element has been configured as a " & myElem.ExtractLabel("type") & " element.")
					end if
				Case Else
					MsgBox ("Please select a group of elements, text field or image box.")
			End Select
		Else
			MsgBox ("Please select a group of elements.")
		End If
	Else
		MsgBox ("Please open a document.")
	End If
	
	
	Function myDisplayDialog(myInDesign, myObject)
		dim setTxtName, setDefaultTxt, setMaxChars, setSort, setAutoFill, setNumberOfLines, setCharacterWidth, setMinPointSize
		
		
		'Set fit method drop down values
		dim fitMethodDropDown(5)
		fitMethodDropDown(0)="None"
		fitMethodDropDown(1)="Adjust By Size"
		fitMethodDropDown(2)="Adjust By Leading"
		fitMethodDropDown(3)="Adjust by Horizontal Scale"
		fitMethodDropDown(4)="Adjust by Word Spacing"
		fitMethodDropDown(5)="Adjust by Tracking"
		
		
		'Set field name values
		dim fieldNameDropDown(30)
		fieldNameDropDown(0)="Flash 1"
		fieldNameDropDown(1)="Flash 2"
		fieldNameDropDown(2)="Flash 3"
		fieldNameDropDown(3)="Flash 4"
		fieldNameDropDown(4)="Flash 5"
		fieldNameDropDown(5)="Flash 6"
		fieldNameDropDown(6)="Flash 7"
		fieldNameDropDown(7)="Flash 8"
		fieldNameDropDown(8)="Flash 9"
		fieldNameDropDown(9)="Flash 10"
		fieldNameDropDown(10)="Flash 11"
		fieldNameDropDown(11)="Flash 12"
		fieldNameDropDown(12)="Flash 13"
		fieldNameDropDown(13)="Flash 14"
		fieldNameDropDown(14)="Flash 15"
		fieldNameDropDown(15)="Flash 16"
		fieldNameDropDown(16)="Flash 17"
		fieldNameDropDown(17)="Flash 18"
		fieldNameDropDown(18)="Flash 19"
		fieldNameDropDown(19)="Flash 20"
		fieldNameDropDown(20)="Flash 21"
		fieldNameDropDown(21)="Flash 22"
		fieldNameDropDown(22)="Flash 23"
		fieldNameDropDown(23)="Flash 24"
		fieldNameDropDown(24)="Flash 25"
		fieldNameDropDown(25)="Flash 26"
		fieldNameDropDown(26)="Flash 27"
		fieldNameDropDown(27)="Flash 28"
		fieldNameDropDown(28)="Flash 29"
		fieldNameDropDown(29)="Flash 30"
		fieldNameDropDown(30)="SMS Flash"
		
		
		'Set case dropdown
		dim changeCaseDropDown(4)
		changeCaseDropDown(0)="None"
		changeCaseDropDown(1)="Uppercase"
		changeCaseDropDown(2)="Lowercase"
		changeCaseDropDown(3)="Title Case"
		changeCaseDropDown(4)="Sentence Case"
		
		
		'Set case dropdown
		dim vertDropDown(4)
		vertDropDown(0)="None"
		vertDropDown(1)="Top"
		vertDropDown(2)="Centre"
		vertDropDown(3)="Bottom"
		vertDropDown(4)="Justify"
		
		
		if(myObject.Label = "") then
			'Newly configured element
			setSort = getNextSort("flash", myInDesign)
			
			if(setSort < 11)then
				setTxtName = "Flash " & setSort
			else
				setTxtName = ""
			end if
		else
			setTxtName = myObject.Label
			setSort = myObject.ExtractLabel ("sort")
		end if
		
		setMinPointSize = myObject.ExtractLabel ("minPointSize")
		setMaxPointSize = myObject.ExtractLabel ("maxPointSize")
		setAutoFill = myObject.ExtractLabel ("autoFill")
		setsearchReplace = myObject.ExtractLabel ("searchReplace")
		
		
		'Find selected fit method
		setFitMethod = 0	
		For i = LBound(fitMethodDropDown) to UBound(fitMethodDropDown)
			if(fitMethodDropDown(i) = myObject.ExtractLabel ("fitMethod")) then
				setFitMethod = i
			end if
		Next
		
		
		'Find selected name value
		setNameVal = 0	
		For i = LBound(fieldNameDropDown) to UBound(fieldNameDropDown)
			if(fieldNameDropDown(i) = setTxtName) then
				setNameVal = i
			end if
		Next		
		
		
		if(myObject.ExtractLabel ("blind") = "true") then
			setBlind = true
		else
			setBlind = false
		end if
		
		
		
		'Find selected case change
		setChangeCase = 0
		For i = LBound(changeCaseDropDown) to UBound(changeCaseDropDown)
			if(changeCaseDropDown(i) = myObject.ExtractLabel ("changeCase")) then
				setChangeCase = i
			end if
		Next
		
		
		'Find selected vertical override change
		setVert = 0
		For i = LBound(vertDropDown) to UBound(vertDropDown)
			if(vertDropDown(i) = myObject.ExtractLabel ("vertOverride")) then
				setVert = i
			end if
		Next
		
		
		Set myDialog = myInDesign.Dialogs.Add
		myDialog.Name = "Configure Flash"
		
		With myDialog.DialogColumns.Add
			With .BorderPanels.Add
				With .DialogColumns.Add
					With .DialogRows.Add
						With .DialogColumns.Add
							With .StaticTexts.Add
								.staticLabel = "Name"
							End With
							With .StaticTexts.Add
								.staticLabel = "Sort"
							End With
							With .StaticTexts.Add
								.staticLabel = "Autofill"
							End With
							With .StaticTexts.Add
								.staticLabel = "Fit Method"
							End With
							With .StaticTexts.Add
								.staticLabel = "Fit Minimum"
							End With
							With .StaticTexts.Add
								.staticLabel = "Fit Maximum"
							End With	
							With .StaticTexts.Add
								.staticLabel = "Search and Replace"
							End With
							With .StaticTexts.Add
								.staticLabel = "Change Case"
							End With	
							
							
							if(InStr(UCase(theVersion),"CC") = 0)then
								if(cint(theVersion) < 5)then
									With .StaticTexts.Add
										.staticLabel = "Override Vertical Justification"
									End With
								end if
							end if
							
							With .StaticTexts.Add
								.staticLabel = "Hidden"
							End With
						End With
						With .DialogColumns.Add
							Set txtName = .dropdowns.Add
							With txtName
								.StringList = fieldNameDropDown
								.selectedIndex = setNameVal
							End With
							Set txtSort = .TextEditboxes.Add
							With txtSort
								.EditContents = setSort
							End With
							Set autoFill = .TextEditboxes.Add
							With autoFill
								.EditContents = setAutoFill
							End With	
							Set fitMethod = .dropdowns.Add
							With fitMethod
								.StringList = fitMethodDropDown
								.selectedIndex = setFitMethod
							End With
							Set minPointSize = .TextEditboxes.Add
							With minPointSize
								.EditContents = setMinPointSize
							End With
							Set maxPointSize = .TextEditboxes.Add
							With maxPointSize
								.EditContents = setMaxPointSize
							End With
							Set searchReplace = .TextEditboxes.Add
							With searchReplace
								.EditContents = setSearchReplace
								.MinWidth = 190
							End With
							Set changeCase = .dropdowns.Add
							With changeCase
								.StringList = changeCaseDropDown
								.selectedIndex = setChangeCase
							End With

							if(InStr(UCase(theVersion),"CC") = 0)then
								if(cint(theVersion) < 5)then
									Set vertOverride = .dropdowns.Add
									With vertOverride
										.StringList = vertDropDown
										.selectedIndex = setVert
									End With
								end if
							end if
							
							Set blind = .checkboxControls.Add
							With blind
								.checkedState = setBlind                          
							End With								
						End With
					End With
				End With
			End With
			
	
			With .BorderPanels.Add
				With .DialogColumns.Add
					With .DialogRows.Add
						With .DialogColumns.Add
							With .StaticTexts.Add
								.staticLabel = "CLEAR ALL CONFIGURED DATA?"
							End With
						End With
						With .DialogColumns.Add
							Set clearData = .checkboxControls.Add
							With clearData
								.checkedState = false
							End With
						End With
					End With
				End With
			End With
		End With
	
		myReturn = myDialog.Show
		
		If myReturn = True Then
			'Get the values from the dialog box.
			
			if(clearData.checkedState = true) then
				
				clearIt = MsgBox("Are you sure you want to clear all of the configured data for this element?", vbYesNo, "Clear Data")
				continueOn = (clearIt = vbYes)
				
				if continueOn then
					myObject.Label = ""
					myObject.InsertLabel "type", ""
					myObject.InsertLabel "sort", ""
					myObject.InsertLabel "minPointSize", ""
					myObject.InsertLabel "maxPointSize", ""
					myObject.InsertLabel "fitMethod", ""
					myObject.InsertLabel "autoFill", ""
					myObject.InsertLabel "searchReplace", ""
					myObject.InsertLabel "blind", ""
					myObject.InsertLabel "changeCase", ""
				end if			
			else
				'Make sure text name has been filled in
					if (txtSort.EditContents <> "") then
						myObject.Label = fieldNameDropDown(txtName.selectedIndex)
						
						myObject.InsertLabel "type", "flash"
						myObject.InsertLabel "sort", txtSort.EditContents
						myObject.InsertLabel "minPointSize", minPointSize.EditContents
						myObject.InsertLabel "maxPointSize", maxPointSize.EditContents
						myObject.InsertLabel "fitMethod", fitMethodDropDown(fitMethod.selectedIndex)
						myObject.InsertLabel "autoFill", autoFill.EditContents
						myObject.InsertLabel "searchReplace", searchReplace.EditContents
						myObject.InsertLabel "changeCase", changeCaseDropDown(changeCase.selectedIndex)
						
						if(InStr(UCase(theVersion),"CC") = 0)then
							if(cint(theVersion) < 5)then
								myObject.InsertLabel "vertOverride", vertDropDown(vertOverride.selectedIndex)
							else
								myObject.InsertLabel "vertOverride", ""
							end if
						end if
						
						'2.5 testing
						myObject.InsertLabel "numberOfLines", "5"
						myObject.InsertLabel "characterWidth", "20"
						
						
						if(blind.checkedState = true) then
							myObject.InsertLabel "blind", "true"
						else
							myObject.InsertLabel "blind", "false"
						end if
					else
						MsgBox ("Sort order cannot be blank.")
					end if
			end if
		End If
	End Function
else
	MsgBox ("Please configure your scripts.")
end if


Function ReadPref(theKey)
	Dim wsh
	Dim returnMe
	Set wsh = CreateObject("WScript.Shell")
	
	On Error Resume Next
		returnMe = wsh.RegRead(pP2PrefsRegistryKey & theKey)
	On Error Goto 0
	
	ReadPref = returnMe
End Function


Function getNextSort (theType, myInDesign)
	dim finalSort, myCounter, elemType
	
	finalSort = 0
	
	'Loop through elements on current document
	For myCounter = 1 To myInDesign.ActiveDocument.PageItems.Count
		elemType = myInDesign.ActiveDocument.PageItems.Item(myCounter).ExtractLabel ("type")
		
		if(elemType = theType) then
			newSort = cInt(myInDesign.ActiveDocument.PageItems.Item(myCounter).ExtractLabel ("sort"))
			
			if (newSort > finalSort) then
				finalSort = newSort
			end if
		end if	
	Next
	
	finalSort = finalSort + 1
	
	getNextSort = CStr(finalSort)
End Function
