pP2PrefsRegistryKey = "HKCU\Software\DND\InDesign_ProMotor\"
'SET THE VERSION HERE:
theVersion = ""
'theVersion = "4"
'theVersion = "CC"
'theVersion = "CC.2014"

if(theVersion = "")then
	'Load the version
	theVersion = ReadPref("ID_Version")
end if

if (theVersion <> "") then

	Set myInDesign = CreateObject("InDesign.Application." & theVersion)

	'Check document is open.
	If myInDesign.Documents.Count <> 0 Then
	
		'Check one element is selected.
		If myInDesign.Selection.Count = 1 Then
			
			set myElem = myInDesign.Selection.Item(1)
			
			'Check selected element is new or type is text.
			if (myElem.ExtractLabel ("type") = "image") OR (myElem.ExtractLabel ("type") = "") then
				
				'Check selected element is the right type.
				Select Case TypeName(myElem)
				Case "Rectangle", "Oval", "Polygon"
					myDisplayDialog myInDesign, myElem
				Case Else
					MsgBox ("Please select an image element.")
				End Select
			else
				MsgBox ("This element has been configured as a " & myElem.ExtractLabel("type") & " elemenet.")
			end if
		Else
			MsgBox ("Please select an image element.")
		End If
	Else
		MsgBox ("Please open a document.")
	End If
	
	Function myDisplayDialog(myInDesign, myObject)
		
		'Set fit method drop down values
		dim fitMethodDropDown(3)
		fitMethodDropDown(0)="None"
		fitMethodDropDown(1)="Fill container"
		fitMethodDropDown(2)="Fit within container"
		fitMethodDropDown(3)="Scale to fit container"	
		
		
		'Set image type drop down values
		dim imageTypeDropDown(12)
		imageTypeDropDown(0)="Item"
		imageTypeDropDown(1)="Image Library Image"
		imageTypeDropDown(2)="Company Logo 1"
		imageTypeDropDown(3)="Company Logo 2"
		imageTypeDropDown(4)="Company Logo 3"
		imageTypeDropDown(5)="Company Logo 4"
		imageTypeDropDown(6)="Agent Picture 1"
		imageTypeDropDown(7)="Agent Picture 2"
		imageTypeDropDown(8)="Agent Picture 3"
		imageTypeDropDown(9)="QR Code"
		imageTypeDropDown(10)="QR Code Group"
		imageTypeDropDown(11)="Logo"
		imageTypeDropDown(12)="Zappar"
		
		if(myObject.Label = "") then
			'Newly configured element
			setSort = getNextSort("image", myInDesign)
		else
			setSort = myObject.ExtractLabel ("sort")
		end if
		
		
		'Find selected fit method
		setFitMethod = 1
		For i = LBound(fitMethodDropDown) to UBound(fitMethodDropDown)
			if(fitMethodDropDown(i) = myObject.ExtractLabel ("fitMethod")) then
				setFitMethod = i
			end if
		Next
		
		
		'Find selected image type
		setImageType = 0	
		For i = LBound(imageTypeDropDown) to UBound(imageTypeDropDown)
			if(imageTypeDropDown(i) = myObject.ExtractLabel ("imageType")) then
				setImageType = i
			end if
		Next
		
		
		'Set image actions drop down values
		actionsListText = GetImageActionsList()
		setAction = 0
		If (actionsListText <> "") Then
			actionsListText = "Please Select," + actionsListText
			actionsListText = Replace(actionsListText,chr(13),"")
			actionsListText = Replace(actionsListText,chr(10),"")
			
			actionList = Split(actionsListText, ",")
			
			For i = LBound(actionList) to UBound(actionList)
				if(actionList(i) = myObject.ExtractLabel ("imageAction")) then
					setAction = i
				end if
			Next
		Else
			dim actionList(0)
			
			actionList(0) = "Please Select"
		End If
		
		
		
		
		Set myDialog = myInDesign.Dialogs.Add
		myDialog.Name = "Configure Image"
		
		With myDialog.DialogColumns.Add
			With .BorderPanels.Add
				With .DialogColumns.Add
					With .DialogRows.Add
						With .DialogColumns.Add
							With .StaticTexts.Add
								.staticLabel = "Sort"
							End With
							With .StaticTexts.Add
								.staticLabel = "Type"
							End With
							With .StaticTexts.Add
								.staticLabel = "Fit Method"
							End With
							With .StaticTexts.Add
								.staticLabel = "Image Action"
							End With						
						End With
						With .DialogColumns.Add
							Set imageSort = .TextEditboxes.Add
							With imageSort
								.EditContents = setSort
							End With
							Set imageType = .dropdowns.Add
							With imageType
								.StringList = imageTypeDropDown
								.selectedIndex = setImageType
							End With
							Set fitMethod = .dropdowns.Add
							With fitMethod
								.StringList = fitMethodDropDown
								.selectedIndex = setFitMethod
							End With
							Set imageAction = .dropdowns.Add
							With imageAction
								.StringList = actionList
								.selectedIndex = setAction                         
							End With					
						End With
					End With
				End With
			End With
			
			With .BorderPanels.Add
				With .DialogColumns.Add
					With .DialogRows.Add
						With .DialogColumns.Add
							With .StaticTexts.Add
								.staticLabel = "CLEAR ALL CONFIGURED DATA?"
							End With
						End With
						With .DialogColumns.Add
							Set clearData = .checkboxControls.Add
							With clearData
								.checkedState = false
							End With
						End With
					End With
				End With
			End With
		End With
	
		myReturn = myDialog.Show
		
		If myReturn = True Then
			'Get the values from the dialog box.
			
			if(clearData.checkedState = true) then
				
				clearIt = MsgBox("Are you sure you want to clear all of the configured data for this element?", vbYesNo, "Clear Data")
				continueOn = (clearIt = vbYes)
				
				if continueOn then
					myObject.Label = ""
					myObject.InsertLabel "type", ""
					myObject.InsertLabel "sort", ""
					myObject.InsertLabel "fitMethod", ""
					myObject.InsertLabel "imageType", ""
					myObject.InsertLabel "imageAction", ""
				end if
			else
				if (imageSort.EditContents <> "") then
					
					if(imageTypeDropDown(imageType.selectedIndex) = "Zappar") then
						myObject.Label = "zappar"
					else
						if(imageTypeDropDown(imageType.selectedIndex) = "QR Code") then
							myObject.Label = "qrcode"
						else
							myObject.Label = "set" & CStr(imageSort.EditContents)
						end if
					end if
					
					
					if isNumeric(imageSort.EditContents) then
						newSort = imageSort.EditContents
					else
						newSort = "0"
					end if
					
					
					myObject.InsertLabel "type", "image"
					myObject.InsertLabel "sort", newSort
					myObject.InsertLabel "fitMethod", fitMethodDropDown(fitMethod.selectedIndex)
					myObject.InsertLabel "imageType", imageTypeDropDown(imageType.selectedIndex)						
					myObject.InsertLabel "imageAction", actionList(imageAction.selectedIndex)					
				else
					MsgBox ("Sort order cannot be blank.")
				end if
			end if
		End If
	End Function
else
	MsgBox ("Please configure your scripts.")
end if



Function ReadPref(theKey)
	Dim wsh
	Dim returnMe
	Set wsh = CreateObject("WScript.Shell")
	
	On Error Resume Next
		returnMe = wsh.RegRead(pP2PrefsRegistryKey & theKey)
	On Error Goto 0
	
	ReadPref = returnMe
End Function


Function getNextSort (theType, myInDesign)
	dim finalSort, myCounter, elemType
	
	finalSort = 0
	
	'Loop through elements on current document
	For myCounter = 1 To myInDesign.ActiveDocument.PageItems.Count
		elemType = myInDesign.ActiveDocument.PageItems.Item(myCounter).ExtractLabel ("type")
		
		if(elemType = theType) then
			theSort = myInDesign.ActiveDocument.PageItems.Item(myCounter).ExtractLabel ("sort")
			
			if isNumeric(theSort) then
				newSort = cInt(theSort)
			else
				newSort = 0
			end if
			
			if (newSort > finalSort) then
				finalSort = newSort
			end if
		end if	
	Next
	
	finalSort = finalSort + 1
	
	getNextSort = CStr(finalSort)
End Function


Function GetImageActionsList()
	dim theURL, theResult

	theURL = ReadPref("Server_URL")
	theResult = DownloadLongText(theURL & "u_get_image_action_list.a4d")
	
	GetImageActionsList = theResult
End Function



Function DownloadLongText(ByVal url)
	Dim returnMe
	Dim errTemp
	Dim xmlhttp
	
	returnMe = ""

	On Error Resume Next
	Set xmlhttp = CreateObject("MSXML2.XMLHTTP")

	errTemp = Err.Number
	If errTemp <> 0 Then
		msgbox("Unable to create scripting object: MSXML2.XMLHTTP")
		msgbox(Err.Description )
	End If

	If errTemp = 0 Then
		Call xmlhttp.Open("GET", url, False)
		errTemp = Err.Number
	End If
	
	If errTemp = 0 Then
		xmlhttp.Send
		errTemp = Err.Number
	End If

	If errTemp = 0 Then
		returnMe = xmlhttp.ResponseText
	End If
	
	DownloadLongText = returnMe
End Function


