pP2PrefsRegistryKey = "HKCU\Software\DND\InDesign_ProMotor\"
'SET THE VERSION HERE:
theVersion = ""
'theVersion = "4"
'theVersion = "CC"
'theVersion = "CC.2014"

if(theVersion = "")then
	'Load the version
	theVersion = ReadPref("ID_Version")
end if


if (theVersion <> "") then

	Set myInDesign = CreateObject("InDesign.Application." & theVersion)

	'Check document is open.
	If myInDesign.Documents.Count <> 0 Then
	
		'Check one element is selected.
		If myInDesign.Selection.Count = 1 Then
			
			set myElem = myInDesign.Selection.Item(1)
			
			if (TypeName(myElem) = "TextFrame") then
				'Check selected element is new or type is text.
				if (myElem.ExtractLabel ("type") = "list") OR (myElem.ExtractLabel ("type") = "") then
					if(myElem.TextFrameIndex = 1) then
						myDisplayDialog myInDesign, myElem
					else
						MsgBox ("Please select the first linked text box.")
					end if
				else
					MsgBox ("This element has been configured as a " & myElem.ExtractLabel("type") & " elemenet.")
				end if
			else
				MsgBox ("Please select a text element using the selection tool.")
			end if
		Else
			MsgBox ("Please select a text element.")
		End If
	Else
		MsgBox ("Please open a document.")
	End If
	
	Function myDisplayDialog(myInDesign, myObject)
		dim setTxtName, setDefaultTxt, setMaxChars, setSort, setAutoFill, setNumberOfLines, setCharacterWidth, setMinPointSize
		
		
		'Set fit method drop down values
		dim fitMethodDropDown(4)
		fitMethodDropDown(0)="None"
		fitMethodDropDown(1)="Adjust By Size"
		fitMethodDropDown(2)="Adjust By Leading"
		fitMethodDropDown(3)="Adjust by Horizontal Scale"
		fitMethodDropDown(4)="Adjust by Word Spacing"

			
		if(myObject.Label = "") then
		
		end if
		
		
		setMinPointSize = myObject.ExtractLabel ("minPointSize")
		setMaxPointSize = myObject.ExtractLabel ("maxPointSize")
		setDingbat = myObject.ExtractLabel ("dingbat")
		setsearchReplace = myObject.ExtractLabel ("searchReplace")
		
		
		'list data
		setListStyle = myObject.ExtractLabel ("listStyle")
		setListSort = myObject.ExtractLabel ("listSort")
		setHeadingStyle = myObject.ExtractLabel ("headingStyle")
		setHeadingField = myObject.ExtractLabel ("headingField")
		
		
		'Find selected fit method
		setFitMethod = 0	
		For i = LBound(fitMethodDropDown) to UBound(fitMethodDropDown)
			if(fitMethodDropDown(i) = myObject.ExtractLabel ("fitMethod")) then
				setFitMethod = i
			end if
		Next
		
		
		Set myDialog = myInDesign.Dialogs.Add
		myDialog.Name = "Configure List"
		
		With myDialog.DialogColumns.Add
			With .BorderPanels.Add
				With .DialogColumns.Add
					With .DialogRows.Add
						With .DialogColumns.Add
							With .StaticTexts.Add
								.staticLabel = "Dingbat"
							End With
							With .StaticTexts.Add
								.staticLabel = "Search and Replace"
							End With
							With .StaticTexts.Add
								.staticLabel = "Fit Method"
							End With
							With .StaticTexts.Add
								.staticLabel = "Fit Minimum"
							End With
							With .StaticTexts.Add
								.staticLabel = "Fit Maximum"
							End With
						End With
						With .DialogColumns.Add
							Set dingbat = .TextEditboxes.Add
							With dingbat
								.EditContents = setDingbat
								.MinWidth = 190
							End With
							Set searchReplace = .TextEditboxes.Add
							With searchReplace
								.EditContents = setSearchReplace
								.MinWidth = 190
							End With
							Set fitMethod = .dropdowns.Add
							With fitMethod
								.StringList = fitMethodDropDown
								.selectedIndex = setFitMethod
							End With
							Set minPointSize = .TextEditboxes.Add
							With minPointSize
								.EditContents = setMinPointSize
							End With
							Set maxPointSize = .TextEditboxes.Add
							With maxPointSize
								.EditContents = setMaxPointSize
							End With	
						End With
					End With
				End With
			End With
			

			With .BorderPanels.Add
				With .DialogColumns.Add
					With .DialogRows.Add
						With .DialogColumns.Add
							With .StaticTexts.Add
								.staticLabel = "Heading Style"
							End With	
							With .StaticTexts.Add
								.staticLabel = "Heading Field"
							End With							
							With .StaticTexts.Add
								.staticLabel = "List Style"
							End With
							With .StaticTexts.Add
								.staticLabel = "List Sort"
							End With	
						End With
						With .DialogColumns.Add
							Set headingStyle = .TextEditboxes.Add
							With headingStyle
								.EditContents = setHeadingStyle
								.MinWidth = 190
							End With
							Set headingField = .TextEditboxes.Add
							With headingField
								.EditContents = setHeadingField
								.MinWidth = 190
							End With							
							Set listStyle = .TextEditboxes.Add
							With listStyle
								.EditContents = setListStyle
								.MinWidth = 190
							End With
							Set listSort = .TextEditboxes.Add
							With listSort
								.EditContents = setListSort
								.MinWidth = 190
							End With
						End With
					End With
				End With
			End With
			
			
			if myObject.RotationAngle <> 0 then
				With .BorderPanels.Add
					With .DialogColumns.Add
						With .DialogRows.Add
							With .DialogColumns.Add
								With .StaticTexts.Add
									.staticLabel = "*PLEASE ROTATE ELEMENTS FROM THE LOWER LEFT CORNER"
								End With
							End With

						End With
					End With
				End With
			end if
	
	
			With .BorderPanels.Add
				With .DialogColumns.Add
					With .DialogRows.Add
						With .DialogColumns.Add
							With .StaticTexts.Add
								.staticLabel = "CLEAR ALL CONFIGURED DATA?"
							End With
						End With
						With .DialogColumns.Add
							Set clearData = .checkboxControls.Add
							With clearData
								.checkedState = false
							End With
						End With
					End With
				End With
			End With
		End With
	
		myReturn = myDialog.Show
		
		If myReturn = True Then
			'Get the values from the dialog box.
			
			if(clearData.checkedState = true) then
				
				clearIt = MsgBox("Are you sure you want to clear all of the configured data for this element?", vbYesNo, "Clear Data")
				continueOn = (clearIt = vbYes)
				
				if continueOn then
					myObject.Label = ""
					myObject.InsertLabel "type", ""
					myObject.InsertLabel "defaultTxt", ""
					myObject.InsertLabel "maxChars", ""
					myObject.InsertLabel "autoFill", ""
					myObject.InsertLabel "dingbat", ""
					myObject.InsertLabel "numberOfLines", ""
					myObject.InsertLabel "characterWidth", ""
					myObject.InsertLabel "minPointSize", ""
					myObject.InsertLabel "maxPointSize", ""
					myObject.InsertLabel "fitMethod", ""
					myObject.InsertLabel "disableSpellcheck", ""
					myObject.InsertLabel "subEdit", ""
					
					myObject.InsertLabel "searchReplace", ""
					myObject.InsertLabel "headingStyle", ""
					myObject.InsertLabel "headingField", ""
					myObject.InsertLabel "listStyle", ""
					myObject.InsertLabel "listSort", ""
				end if			
			else
				myObject.Label = "List"
				
				myObject.InsertLabel "type", "list"
				myObject.InsertLabel "maxChars", "60"
				myObject.InsertLabel "dingbat", dingbat.EditContents
				myObject.InsertLabel "numberOfLines", "5"
				myObject.InsertLabel "characterWidth", "30"
				myObject.InsertLabel "minPointSize", minPointSize.EditContents
				myObject.InsertLabel "maxPointSize", maxPointSize.EditContents
				myObject.InsertLabel "fitMethod", fitMethodDropDown(fitMethod.selectedIndex)
				
				myObject.InsertLabel "headingStyle", headingStyle.EditContents
				myObject.InsertLabel "headingField", headingField.EditContents
				myObject.InsertLabel "listStyle", listStyle.EditContents
				myObject.InsertLabel "listSort", listSort.EditContents
				myObject.InsertLabel "searchReplace", searchReplace.EditContents
			end if
		End If
	End Function
else
	MsgBox ("Please configure your scripts.")
end if



Function ReadPref(theKey)
	Dim wsh
	Dim returnMe
	Set wsh = CreateObject("WScript.Shell")
	
	On Error Resume Next
		returnMe = wsh.RegRead(pP2PrefsRegistryKey & theKey)
	On Error Goto 0
	
	ReadPref = returnMe
End Function


Function getNextSort (theType, myInDesign)
	dim finalSort, myCounter, elemType
	
	finalSort = 0
	
	'Loop through elements on current document
	For myCounter = 1 To myInDesign.ActiveDocument.PageItems.Count
		elemType = myInDesign.ActiveDocument.PageItems.Item(myCounter).ExtractLabel ("type")
		
		if(elemType = theType) then
			newSort = cInt(myInDesign.ActiveDocument.PageItems.Item(myCounter).ExtractLabel ("sort"))
			
			if (newSort > finalSort) then
				finalSort = newSort
			end if
		end if	
	Next
	
	finalSort = finalSort + 1
	
	getNextSort = CStr(finalSort)
End Function

