pP2PrefsRegistryKey = "HKCU\Software\DND\InDesign_ProMotor\"
'SET THE VERSION HERE:
theVersion = ""
'theVersion = "4"
'theVersion = "CC"
'theVersion = "CC.2014"

if(theVersion = "")then
	'Load the version
	theVersion = ReadPref("ID_Version")
end if


if (theVersion <> "") then

	Set myInDesign = CreateObject("InDesign.Application." & theVersion)

	'Check document is open.
	If myInDesign.Documents.Count <> 0 Then
		'Check one element is selected.
		If myInDesign.Selection.Count = 1 Then
			
			set myElem = myInDesign.Selection.Item(1)
			
			'Check selected element is new or type is overlay.
			if (myElem.ExtractLabel ("type") = "overlay") OR (myElem.ExtractLabel ("type") = "") then
				'Check selected element is the right type.
				Select Case TypeName(myElem)
				Case "Group"
						myDisplayDialog myInDesign, myElem
				Case Else
						MsgBox ("Please select a group of elements.")
				End Select
			else
				MsgBox ("This element has been configured as a " & myElem.ExtractLabel("type") & " elemenet.")
			end if
		Else
			MsgBox ("Please select a group of elements.")
		End If
	Else
		MsgBox ("Please open a document.")
	End If
else
	MsgBox ("Please configure your scripts.")
end if





Function myDisplayDialog(myInDesign, myObject)
	
	
	if(myObject.Label = "") then
		'Newly configured element
		
		setSort = getNextSort("overlay", myInDesign)
		setName = "overlay_" & setSort
		setOverlay = false
		
	else
		setName = myObject.Label
		setSort = myObject.ExtractLabel ("sort")
		setOverlay = true
	end if
	
	
	Set myDialog = myInDesign.Dialogs.Add
	myDialog.Name = "Configure Overlay"
	
	With myDialog.DialogColumns.Add
		With .BorderPanels.Add
			With .DialogColumns.Add
				With .DialogRows.Add
					With .DialogColumns.Add
						With .StaticTexts.Add
							.staticLabel = "Overlay Element"
						End With																				
					End With
					With .DialogColumns.Add	
						Set makeOverlay = .checkboxControls.Add
						With makeOverlay
							.checkedState = setOverlay                          
						End With		
					End With
				End With
			End With
		End With
	End With
	
	
	
	'display dialog
	myReturn = myDialog.Show
	
	
	
	If (myReturn = True) Then
		'Get the values from the dialog box.
		if(makeOverlay.checkedState = true) then
			myObject.Label = setName
			myObject.InsertLabel "type", "overlay"
			myObject.InsertLabel "sort", setSort
		else
			myObject.Label = ""
			myObject.InsertLabel "type", ""
			myObject.InsertLabel "sort", ""
		end if
	end If
End Function



Function ReadPref(theKey)
	Dim wsh
	Dim returnMe
	Set wsh = CreateObject("WScript.Shell")
	
	On Error Resume Next
		returnMe = wsh.RegRead(pP2PrefsRegistryKey & theKey)
	On Error Goto 0
	
	ReadPref = returnMe
End Function


Function getNextSort (theType, myInDesign)
	dim finalSort, myCounter, elemType
	
	finalSort = 0
	
	'Loop through elements on current document
	For myCounter = 1 To myInDesign.ActiveDocument.PageItems.Count
		elemType = myInDesign.ActiveDocument.PageItems.Item(myCounter).ExtractLabel ("type")
		
		if(elemType = theType) then
			newSort = cInt(myInDesign.ActiveDocument.PageItems.Item(myCounter).ExtractLabel ("sort"))
			
			if (newSort > finalSort) then
				finalSort = newSort
			end if
		end if	
	Next
	
	finalSort = finalSort + 1
	
	getNextSort = CStr(finalSort)
End Function

