pP2PrefsRegistryKey = "HKCU\Software\DND\InDesign_ProMotor\"
'SET THE VERSION HERE:
theVersion = ""
'theVersion = "4"
'theVersion = "CC"
'theVersion = "CC.2014"

if(theVersion = "")then
	'Load the version
	theVersion = ReadPref("ID_Version")
end if


'test version has been set
if (theVersion <> "") then

	'get application object
	if(InStr(UCase(theVersion),"CC") > 0)then
		Set myInDesign = CreateObject("InDesign.Application." & theVersion)
	else
		Set myInDesign = CreateObject("InDesign.Application.CS" & theVersion)
	end if

	
	'test for active document
	If myInDesign.Documents.Count <> 0 Then	
		
		'get the document name
		templateName = myInDesign.ActiveDocument.Label
		
		'test document name has been configured
		if(templateName <> "") Then

			groupName = myInDesign.ActiveDocument.ExtractLabel ("group")

			if(groupName <> "") Then
				
				inDesignPath = myInDesign.FilePath
				scriptPath = inDesignPath & "\Scripts\Scripts Panel\4D\Upload.vbs"

				if(Not(checkFileExists(scriptPath)))then
					scriptPath = inDesignPath & "\Scripts\Scripts Panel\EzAdsPro\Upload.vbs"
				end if

				if(Not(checkFileExists(scriptPath)))then
					scriptPath = inDesignPath & "\Scripts\Scripts Panel\Upload.vbs"
				end if

				if(Not(checkFileExists(scriptPath)))then
					scriptPath = inDesignPath & "\Scripts\Scripts Panel\ProMotor\Upload.vbs"
				end if

				if(Not(checkFileExists(scriptPath)))then
					scriptPath = "c:\Scripts\Scripts Panel\EzAdsPro\Upload.vbs"
				end if

				'msgbox(scriptPath)

				if(checkFileExists(scriptPath))then
					'let the upload script know we are previewing
					writePref "is_preview", "1"

					'run the upload script
					Dim objShell
					Set objShell = CreateObject("WScript.Shell")
					returnVal = objShell.Run("cscript " & chr(34) & scriptPath & chr(34), 6, 1)
					Set objShell = Nothing

					'disable the preview
					writePref "is_preview", ""

					'the server url
					theURL = ReadPref("Server_URL")

					encodedTemplateName = Encode_UTF8(templateName)
					encodedGroupName = Encode_UTF8(groupName)

					'do build and return preview url
					theFullURL = theURL & "4dcgi/preview_build.a4d?templateName=" & encodedTemplateName & "&groupName=" & encodedGroupName & "&unique=" & CreateGUID
					'msgbox(theFullURL)
					siteText = PostForm(theFullURL, "a=1")

					'debug
					'msgbox(siteText)

					If(Len(siteText) < 200)Then
						if(InStr(UCase(siteText),"ERROR: ") > 0)then
							msgbox(siteText)
						else
							'Change units to points
							userUnitsHoriz = myInDesign.ActiveDocument.viewPreferences.HorizontalMeasurementUnits
							userUnitsVert = myInDesign.ActiveDocument.viewPreferences.VerticalMeasurementUnits
							
							myInDesign.ActiveDocument.viewPreferences.HorizontalMeasurementUnits = 2054188905
							myInDesign.ActiveDocument.viewPreferences.VerticalMeasurementUnits = 2054188905

							theWidth = myInDesign.ActiveDocument.documentPreferences.PageWidth
							theHeight = myInDesign.ActiveDocument.documentPreferences.PageHeight

							if((theWidth > 400) OR (theHeight > 600))then
								theWidth = theWidth / 2
								theHeight = theHeight / 2
							end if


							imagePath = theURL & siteText & "&unique=" & CreateGUID


							'Change units back to user defined
							myInDesign.ActiveDocument.viewPreferences.HorizontalMeasurementUnits = userUnitsHoriz
							myInDesign.ActiveDocument.viewPreferences.VerticalMeasurementUnits = userUnitsVert


							'show build preview
							Set objExplorer = CreateObject("InternetExplorer.Application")
							With objExplorer
							    .Navigate "about:blank"
							    .Visible = True
							    .Document.Title = templateName & " Build Preview"
							    .Toolbar=False
							    .Statusbar=False
							    .Top=200
							    .Left=400
							    .Height=theHeight
							    .Width=theWidth
							    .Document.Body.InnerHTML = "<img style='width: 100%;' src='" & imagePath & "'>"
							End With
						End If
					Else
						MsgBox ("An error has occurred, please check your server url.")
					End If
				Else
					MsgBox ("Failed to locate upload script.")
				End If
			Else
				MsgBox ("Please configure the document.")
			End If
		Else
			MsgBox ("Please configure the document.")
		End If
	Else
		MsgBox ("Please open a document.")
	End If
else
	MsgBox ("Please configure your scripts.")
end if


Function CreateGUID
  Dim TypeLib
  Set TypeLib = CreateObject("Scriptlet.TypeLib")
  CreateGUID = Mid(TypeLib.Guid, 2, 36)
End Function


Function Encode_UTF8(astr)
    astr = Replace(astr, "’", "'")
    astr = Replace(astr, "–", "-")
	astr = Replace(astr, " ", "%20")

    Encode_UTF8 = astr
End Function


Function checkFileExists(filePathToCheck)
	dim filesys
	dim returnVal
	
	Set filesys = CreateObject("Scripting.FileSystemObject") 

	If filesys.FileExists(filePathToCheck) Then
		returnVal = true
	else
		returnVal = false
	End If 
	
	checkFileExists = returnVal
End Function



Function ReadPref(theKey)
	Dim wsh
	Dim returnMe
	Set wsh = CreateObject("WScript.Shell")
	
	On Error Resume Next
		returnMe = wsh.RegRead(pP2PrefsRegistryKey & theKey)
	On Error Goto 0
	
	ReadPref = returnMe
End Function


Sub WritePref(ByRef theKey, ByRef newValue)
		Dim wsh
		Set wsh = CreateObject("WScript.Shell")
	
		Call wsh.RegWrite(pP2PrefsRegistryKey & theKey, newValue)
End Sub


Function PostForm(ByRef url, ByRef formData)
	Dim returnMe, formText, commandLine
	
	returnMe = ""

	If IsArray(formData) Then
		formText = MakeFormText(formData)
	Else
		formText = formData
	End If

	commandLine = "-F " & formText & " " & url	
	
	returnMe = CURL(commandLine)

	PostForm = returnMe
End Function


Function CURL(ByVal commandLine)
	Dim returnMe
	Dim errMsg
	Dim WshShell, curlExec, i
	
	returnMe = ""
	theProxy = ReadPref("Server_Proxy")
	
	if theProxy <> "" then
		commandLine = "-x " & theProxy & " " & commandLine
	end if
	
	commandLine = "curl " & commandLine
	Set WshShell = CreateObject("WScript.Shell")
	
	On Error Resume Next
	Set curlExec = WshShell.Exec(commandLine)


	errMsg = Err.Description
	On Error Goto 0
	
	If IsObject(curlExec) Then
		Dim timeLeft
		
		'Time left in seconds
		timeLeft = 240
		Do While (curlExec.Status = 0) And (timeLeft > 0)
			SillySleep(1)
			timeLeft = timeLeft - 1
		Loop

		If (timeLeft > 0) Then
			If (curlExec.ExitCode = 0) Then
				returnMe = curlExec.StdOut.ReadAll
			Else
				Dim errNum, errText
				errText = curlExec.StdOut.ReadAll
				errNum = curlExec.ExitCode
				returnMe = errText
			End If
		Else
			curlExec.Terminate
		End If
	Else
		msgbox("Unable to find curl.exe")
	End If
	
	CURL = returnMe
End Function



Sub SillySleep(ByRef seconds)
	Dim WshShell, commandLine
	Set WshShell = CreateObject("Wscript.Shell")
	commandLine = "%COMSPEC% /c ping -n " & 1 + seconds & " 127.0.0.1>nul"
	Call WshShell.Run(commandLine, 0, 1)
End Sub


Function Slashify(someString)
	Dim returnMe
	returnMe = someString
	
	If Right(returnMe, 1) <> "\" Then returnMe = returnMe & "\"
	
	Slashify = returnMe
End Function


function setData (elemName, elemValue)
	'setData = elemName & theDelimeter & elemValue & theDelimeter
	
	'strip bad chars
	elemValue = stripTags(elemValue)
	
	setData = elemName & " value121" & theDelimeter & elemValue & theDelimeter
end function


Function PostFile(ByRef url, ByRef fileObj)
	Dim returnMe
	Dim commandLine
	
	returnMe = ""
	commandLine = "-F upload=@" & chr(34) & fileObj & chr(34) & " " & url
	
	

	tmpSize = getFileSize(fileObj)
	if(tmpSize > 6144)then
		returnMe = CurlLarge(commandLine)
	else
		returnMe = CURL(commandLine)
	end if

	PostFile = returnMe
End Function


Function CurlLarge(ByVal commandLine)
	Dim returnMe
	Dim errMsg
	Dim WshShell, curlExec, i
	
	returnMe = ""
	theProxy = ReadPref("Server_Proxy")
	
	if theProxy <> "" then
		commandLine = "-x " & theProxy & " " & commandLine
	end if
	
	commandLine = "curl " & commandLine
	Set WshShell = CreateObject("WScript.Shell")
	
	On Error Resume Next
	Set curlExec = WshShell.Exec(commandLine)


	errMsg = Err.Description
	On Error Goto 0
	
	If IsObject(curlExec) Then
		Dim timeLeft
		
		'Time left in seconds
		timeLeft = 600
		Do While (curlExec.Status = 0) And (timeLeft > 0)
			SillySleep(1)
			timeLeft = timeLeft - 1
		Loop

		If (timeLeft > 0) Then
			If (curlExec.ExitCode = 0) Then
				returnMe = curlExec.StdOut.ReadAll
			Else
				Dim errNum, errText
				errText = curlExec.StdOut.ReadAll
				errNum = curlExec.ExitCode
				returnMe = errText
			End If
		Else
			curlExec.Terminate
		End If
	Else
		msgbox("Unable to find curl.exe")
	End If
	
	CurlLarge = returnMe
End Function