pP2PrefsRegistryKey = "HKCU\Software\DND\InDesign_ProMotor\"


'Load the version
theVersion = ReadPref("ID_Version")


if (theVersion <> "") then
	Set myInDesign = CreateObject("InDesign.Application." & theVersion)
	
	If myInDesign.Documents.Count <> 0 Then
		if (myInDesign.Documents(1).DocumentPreferences.FacingPages = false) then
			myDisplayDialog myInDesign
		else
			MsgBox ("The document cannot be configured with facing pages turned on.")
		end if
	Else
		MsgBox ("Please open a document.")
	End If
	
	
	Function myDisplayDialog(myInDesign)
		dim setDocName, myDoc, groupListText, folderListText
		
		
		set myDoc = myInDesign.Documents(1)
	
		'Set group (or category for bluefin) drop down values
		if(ReadPref("EzAdsPro_Product") = "1") OR (ReadPref("EzAdsPro_Product") = "2")then
			groupListText = GetPHPCategoryList()
		else
			groupListText = GetGroupList()
		end if
		
		
		setGroup = 0
		If (groupListText <> "") Then
			
			groupListText = "Please Select," + groupListText
			groupListText = Replace(groupListText,chr(13),"")
			groupListText = Replace(groupListText,chr(10),"")
			
			groupList = Split(groupListText, ",")
			
			For i = LBound(groupList) to UBound(groupList)
				if(groupList(i) = myDoc.ExtractLabel ("group")) then
					setGroup = i
				end if
			Next
		Else
			dim groupList(0)
			groupList(0) = "Unable to connect to server."
		End If
		
		
		'Set hot folder drop down values
		folderListText = GetHotFolderList()
		setFolder = 0
		If (folderListText <> "") Then
			
			folderListText = "Please Select," + folderListText
			folderListText = Replace(folderListText,chr(13),"")
			folderListText = Replace(folderListText,chr(10),"")
			
			folderList = Split(folderListText, ",")
			
			For i = LBound(folderList) to UBound(folderList)
				if(folderList(i) = myDoc.ExtractLabel ("hotFolder")) then
					setFolder = i
				end if
			Next
		Else
			dim folderList(0)
			folderList(0) = "Please Select"
		End If
		
		
		if(myDoc.Label = "") then
			'Newly configured element
	
			setDocName = ""
		else
			setDocName = myDoc.Label
		end if
		
		setStyleCode = myDoc.ExtractLabel ("styleCode")
		setRows = myDoc.ExtractLabel ("rows")
		setCols = myDoc.ExtractLabel ("cols")

		setBleedTop = myDoc.ExtractLabel ("bleedTop")
		setBleedBottom = myDoc.ExtractLabel ("bleedBottom")
		setBleedLeft = myDoc.ExtractLabel ("bleedLeft")
		setBleedRight = myDoc.ExtractLabel ("bleedRight")
		
		setProdAccess = false
		if(myDoc.ExtractLabel ("prodAccess") = "true") then
			setProdAccess = true
		end if
		

		setMultiPageListing = false
		if(myDoc.ExtractLabel ("multiPageListing") = "true") then
			setMultiPageListing = true
		end if


		setJpgExport = false
		if(myDoc.ExtractLabel ("jpgExport") = "true") then
			setJpgExport = true
		end if
		
		
		'Bluefin Options
		
		if(ReadPref("EzAdsPro_Product") = "1") or (ReadPref("EzAdsPro_Product") = "2") then
			enableBF = true
			setKeyWord = myDoc.ExtractLabel ("keyWord")
			setSubCat = myDoc.ExtractLabel ("sub category")
		else
			enableBF = false
		end if
		
		
		if(ReadPref("EzAdsPro_Product") = "1") or (ReadPref("EzAdsPro_Product") = "2") then
			categoryText = GetCategoryList()
			setCategory = 0
			If (categoryText <> "") Then
				
				categoryText = "Please Select," + categoryText
				categoryText = Replace(categoryText,chr(13),"")
				categoryText = Replace(categoryText,chr(10),"")
				
				categoryList = Split(categoryText, ",")
				
				For i = LBound(categoryList) to UBound(categoryList)
					if(categoryList(i) = myDoc.ExtractLabel ("category")) then
						setCategory = i
					end if
				Next
			Else
				dim categoryList(0)
				categoryList(0) = "Please Select"
			End If
		end if
		'End Bluefin Options
		
		
		
		Set myDialog = myInDesign.Dialogs.Add
		myDialog.Name = "Configure Document"
		
		With myDialog.DialogColumns.Add
			With .BorderPanels.Add
				With .DialogColumns.Add
					With .DialogRows.Add
						With .DialogColumns.Add
							With .StaticTexts.Add
								.staticLabel = "Name"
							End With
							
							if enableBF then
								With .StaticTexts.Add
									.staticLabel = "Key Word"
								End With
							else
								With .StaticTexts.Add
									.staticLabel = "Style Code"
								End With
							end if	
							
							With .StaticTexts.Add
								.staticLabel = "Rows"
							End With
							With .StaticTexts.Add
								.staticLabel = "Columns"
							End With

							With .StaticTexts.Add
								.staticLabel = "Bleed Top"
							End With
							With .StaticTexts.Add
								.staticLabel = "Bleed Bottom"
							End With
							With .StaticTexts.Add
								.staticLabel = "Bleed Left"
							End With
							With .StaticTexts.Add
								.staticLabel = "Bleed Right"
							End With

							With .StaticTexts.Add
								.staticLabel = "Hot Folder"
							End With
							
							if(ReadPref("EzAdsPro_Product") = "1") or (ReadPref("EzAdsPro_Product") = "2") then
								With .StaticTexts.Add
									.staticLabel = "Category"
								End With							
							else
								With .StaticTexts.Add
									.staticLabel = "Group"
								End With
							end if	
							
							
							if(ReadPref("EzAdsPro_Product") = "1") or (ReadPref("EzAdsPro_Product") = "2") then
								With .StaticTexts.Add
									.staticLabel = "Sub Category"
								End With	
							end if
							
							With .StaticTexts.Add
								.staticLabel = "Production Access Only"
							End With

							With .StaticTexts.Add
								.staticLabel = "Multi Page Listing"
							End With

							With .StaticTexts.Add
								.staticLabel = "JPG Output"
							End With
						End With
						
						With .DialogColumns.Add
							Set docName = .TextEditboxes.Add
							With docName
								.EditContents = setDocName
								.MinWidth = 150
							End With
	
							
							if enableBF then
								Set keyWord = .TextEditboxes.Add
								With keyWord
									.EditContents = setKeyWord
									.MinWidth = 150
								End With							
							else
								Set styleCode = .TextEditboxes.Add
								With styleCode
									.EditContents = setStyleCode
									.MinWidth = 150
								End With
							end if
							
							
							Set docRows = .TextEditboxes.Add
							With docRows
								.EditContents = setRows
							End With
							Set docCols = .TextEditboxes.Add
							With docCols
								.EditContents = setCols
							End With

							Set bleedTop = .TextEditboxes.Add
							With bleedTop
								.EditContents = setBleedTop
							End With
							Set bleedBottom = .TextEditboxes.Add
							With bleedBottom
								.EditContents = setBleedBottom
							End With
							Set bleedLeft = .TextEditboxes.Add
							With bleedLeft
								.EditContents = setBleedLeft
							End With
							Set bleedRight = .TextEditboxes.Add
							With bleedRight
								.EditContents = setBleedRight
							End With



							Set hotFolder = .dropdowns.Add
							With hotFolder
								.StringList = folderList
								.selectedIndex = setFolder                          
							End With
							
							
							if(ReadPref("EzAdsPro_Product") = "1") or (ReadPref("EzAdsPro_Product") = "2") then
								Set category = .dropdowns.Add
								With category
									.StringList = categoryList
									.selectedIndex = setCategory                          
								End With
							else
								Set docGroup = .dropdowns.Add
								With docGroup
									.StringList = groupList
									.selectedIndex = setGroup                           
								End With
							end if
							
							
							if(ReadPref("EzAdsPro_Product") = "1") or (ReadPref("EzAdsPro_Product") = "2") then
								Set subCategory = .TextEditboxes.Add
								With subCategory
									.EditContents = setSubCat
									.MinWidth = 100                   
								End With
							end if
							
							
							Set prodAccess = .checkboxControls.Add
							With prodAccess
								.checkedState = setProdAccess                          
							End With	
							Set multiPageListing = .checkboxControls.Add
							With multiPageListing
								.checkedState = setMultiPageListing                         
							End With

							Set jpgExport = .checkboxControls.Add
							With jpgExport
								.checkedState = setJpgExport                       
							End With					
						End With
					End With
				End With
			End With
			
			With .BorderPanels.Add
				With .DialogColumns.Add
					With .DialogRows.Add
						With .DialogColumns.Add
							With .StaticTexts.Add
								.staticLabel = "CLEAR ALL CONFIGURED DATA?"
							End With
						End With
						With .DialogColumns.Add
							Set clearData = .checkboxControls.Add
							With clearData
								.checkedState = false
							End With
						End With
					End With
				End With
			End With
		End With
	
		myReturn = myDialog.Show
		
		If myReturn = True Then
			'Get the values from the dialog box.
			
			if(clearData.checkedState = true) then
				
				clearIt = MsgBox("Are you sure you want to clear all of the configured document data?", vbYesNo, "Clear Data")
				continueOn = (clearIt = vbYes)
				
				if continueOn then
					myDoc.Label = ""
					myDoc.InsertLabel "rows", ""
					myDoc.InsertLabel "cols", ""
					myDoc.InsertLabel "hotFolder", ""
					myDoc.InsertLabel "keyWord", ""
					myDoc.InsertLabel "category", ""
					myDoc.InsertLabel "sub category", ""
					myDoc.InsertLabel "styleCode", ""
					myDoc.InsertLabel "group", ""
					myDoc.InsertLabel "prodAccess", ""
					myDoc.InsertLabel "multiPageListing", ""
					myDoc.InsertLabel "jpgExport", ""
					myDoc.InsertLabel "bleedTop", ""
					myDoc.InsertLabel "bleedBottom", ""
					myDoc.InsertLabel "bleedLeft", ""
					myDoc.InsertLabel "bleedRight", ""
				end if
			else			
				'Make sure the document name has been filled in
				if (docName.EditContents <> "") then
					myDoc.Label = docName.EditContents
					
					myDoc.InsertLabel "rows", docRows.EditContents
					myDoc.InsertLabel "cols", docCols.EditContents
					myDoc.InsertLabel "hotFolder", folderList(hotFolder.selectedIndex)

					myDoc.InsertLabel "bleedTop", bleedTop.EditContents
					myDoc.InsertLabel "bleedBottom", bleedBottom.EditContents
					myDoc.InsertLabel "bleedLeft", bleedLeft.EditContents
					myDoc.InsertLabel "bleedRight", bleedRight.EditContents
					
					
					'get group or category
					if(ReadPref("EzAdsPro_Product") = "1") or (ReadPref("EzAdsPro_Product") = "2") then
						myDoc.InsertLabel "category", categoryList(category.selectedIndex)
					else
						myDoc.InsertLabel "group", groupList(docGroup.selectedIndex)
					end if


					if(jpgExport.checkedState = true) then
						myDoc.InsertLabel "jpgExport", "true"
					else
						myDoc.InsertLabel "jpgExport", "false"
					end if
					
					
					if enableBF then
						myDoc.InsertLabel "keyWord", keyWord.EditContents
						myDoc.InsertLabel "sub category", subCategory.EditContents
					else
						myDoc.InsertLabel "styleCode", styleCode.EditContents
					end if
					
					
					if(prodAccess.checkedState = true) then
						myDoc.InsertLabel "prodAccess", "true"
					else
						myDoc.InsertLabel "prodAccess", "false"
					end if

					if(multiPageListing.checkedState = true) then
						myDoc.InsertLabel "multiPageListing", "true"
					else
						myDoc.InsertLabel "multiPageListing", "false"
					end if
				else
					MsgBox ("Document name cannot be blank.")
				end if
			end if
		End If
	End Function
else
	MsgBox ("Please configure your scripts.")
end if


Function ReadPref(theKey)
	Dim wsh
	Dim returnMe
	Set wsh = CreateObject("WScript.Shell")
	
	On Error Resume Next
		returnMe = wsh.RegRead(pP2PrefsRegistryKey & theKey)
	On Error Goto 0
	
	ReadPref = returnMe
End Function


Function GetGroupList()
	dim theURL, theResult

	theURL = ReadPref("Server_URL")
	
	if(theURL = "http://127.0.0.1/") then
		theResult = DownloadLongText(theURL & "ezp_engine/code/group_list.php")
	else
		theResult = DownloadLongText(theURL & "4dcgi/u_get_group_list.a4d")
	end if
	
	GetGroupList = theResult
End Function



Function GetPHPCategoryList()
	dim theURL, theResult

	theURL = ReadPref("Server_URL")
	theID = ReadPref("Server_BF")
	
	theResult = DownloadLongText(theURL & "bf/u_get_category_list.php?client_id=" & theID)
	
	GetPHPCategoryList = theResult
End Function




Function DownloadLongText(ByVal url)
	Dim returnMe
	Dim errTemp
	Dim xmlhttp
	
	returnMe = ""

	On Error Resume Next
	Set xmlhttp = CreateObject("MSXML2.XMLHTTP")

	errTemp = Err.Number
	If errTemp <> 0 Then
		msgbox("Unable to create scripting object: MSXML2.XMLHTTP")
		msgbox(Err.Description )
	End If

	If errTemp = 0 Then
		Call xmlhttp.Open("GET", url, False)
		errTemp = Err.Number
	End If
	
	If errTemp = 0 Then
		xmlhttp.Send
		errTemp = Err.Number
	End If

	If errTemp = 0 Then
		returnMe = xmlhttp.ResponseText
	End If
	
	DownloadLongText = returnMe
End Function



Function GetHotFolderList()
	dim theURL, theResult

	theURL = ReadPref("Server_URL")
	theResult = DownloadLongText(theURL & "u_get_hotfolder_list.a4d")
	
	GetHotFolderList = theResult
End Function


Function GetCategoryList()
	dim theURL, theCategories, theID

	theURL = ReadPref("Server_URL")
	theID = ReadPref("Server_BF")
	theCategories = DownloadLongText(theURL & "u_get_category_list.a4d?id=" & theID)
	
	GetCategoryList = theCategories
End Function
