pP2PrefsRegistryKey = "HKCU\Software\DND\InDesign_ProMotor\"


'Load the version
theVersion = ReadPref("ID_Version")


if (theVersion <> "") then

	Set myInDesign = CreateObject("InDesign.Application." & theVersion)

	'Check document is open.
	If myInDesign.Documents.Count <> 0 Then
	
		'Check one element is selected.
		If myInDesign.Selection.Count = 1 Then
			
			set myElem = myInDesign.Selection.Item(1)
			
			Select Case TypeName(myElem)
				Case "Rectangle", "Oval", "Polygon", "Group", "TextFrame"
					'Check selected element is new or type is flash.
					if (myElem.ExtractLabel ("type") = "flash") OR (myElem.ExtractLabel ("type") = "") then
						'Check selected element is the right type.
						myDisplayDialog myInDesign, myElem
					else
						MsgBox ("This element has been configured as a " & myElem.ExtractLabel("type") & " elemenet.")
					end if
			case else
					MsgBox ("Please select a group of elements using the Selection tool.")
			end select
		Else
			MsgBox ("Please select a group of elements.")
		End If
	Else
		MsgBox ("Please open a document.")
	End If
	
	Function myDisplayDialog(myInDesign, myObject)
		dim setTxtName, setDefaultTxt, setMaxChars, setSort, setAutoFill, setNumberOfLines, setCharacterWidth, setMinPointSize
		
		
		'Set fit method drop down values
		dim fitMethodDropDown(4)
		fitMethodDropDown(0)="None"
		fitMethodDropDown(1)="Adjust By Size"
		fitMethodDropDown(2)="Adjust By Leading"
		fitMethodDropDown(3)="Adjust by Horizontal Scale"
		fitMethodDropDown(4)="Adjust by Word Spacing"
			
		if(myObject.Label = "") then
			'Newly configured element
			
			setTxtName = ""
			setSort = getNextSort("flash", myInDesign)
	
			setMaxChars = "15"
			setCharacterWidth = "15"
			setNumberOfLines = "1"
		else
			setTxtName = myObject.Label
			setMaxChars = myObject.ExtractLabel ("maxChars")
			setNumberOfLines = myObject.ExtractLabel ("numberOfLines")
			setCharacterWidth = myObject.ExtractLabel ("characterWidth")
			setSort = myObject.ExtractLabel ("sort")
		end if
		
		setMinPointSize = myObject.ExtractLabel ("minPointSize")
		setMaxPointSize = myObject.ExtractLabel ("maxPointSize")
		setAutoFill = myObject.ExtractLabel ("autoFill")
		
		
		'Find selected fit method
		setFitMethod = 0	
		For i = LBound(fitMethodDropDown) to UBound(fitMethodDropDown)
			if(fitMethodDropDown(i) = myObject.ExtractLabel ("fitMethod")) then
				setFitMethod = i
			end if
		Next
		
		
		if(myObject.ExtractLabel ("blind") = "true") then
			setBlind = true
		else
			setBlind = false
		end if
		
		
		setDisableSpellcheck = false
		if(myObject.ExtractLabel ("disableSpellcheck") = "true") then
			setDisableSpellcheck = true
		end if
			
		
		Set myDialog = myInDesign.Dialogs.Add
		myDialog.Name = "Configure Flash"
		
		With myDialog.DialogColumns.Add
			With .BorderPanels.Add
				With .DialogColumns.Add
					With .DialogRows.Add
						With .DialogColumns.Add
							With .StaticTexts.Add
								.staticLabel = "Name"
							End With
							With .StaticTexts.Add
								.staticLabel = "Sort"
							End With
							With .StaticTexts.Add
								.staticLabel = "Autofill"
							End With
							With .StaticTexts.Add
								.staticLabel = "Fit Method"
							End With
							With .StaticTexts.Add
								.staticLabel = "Fit Minimum"
							End With
							With .StaticTexts.Add
								.staticLabel = "Fit Maximum"
							End With	
							With .StaticTexts.Add
								.staticLabel = "Disable Spellcheck"
							End With																											
						End With
						With .DialogColumns.Add
							Set txtName = .TextEditboxes.Add
							With txtName
								.EditContents = setTxtName
								.MinWidth = 190
							End With
							Set txtSort = .TextEditboxes.Add
							With txtSort
								.EditContents = setSort
							End With
							Set autoFill = .TextEditboxes.Add
							With autoFill
								.EditContents = setAutoFill
							End With	
							Set fitMethod = .dropdowns.Add
							With fitMethod
								.StringList = fitMethodDropDown
								.selectedIndex = setFitMethod
							End With
							Set minPointSize = .TextEditboxes.Add
							With minPointSize
								.EditContents = setMinPointSize
							End With
							Set maxPointSize = .TextEditboxes.Add
							With maxPointSize
								.EditContents = setMaxPointSize
							End With	
							Set disableSpellcheck = .checkboxControls.Add
							With disableSpellcheck
								.checkedState = setDisableSpellcheck                          
							End With	
						End With
					End With
				End With
			End With
			
			With .BorderPanels.Add
				With .DialogColumns.Add
					With .DialogRows.Add
						With .DialogColumns.Add
							With .StaticTexts.Add
								.staticLabel = "Number of Lines"
							End With
							With .StaticTexts.Add
								.staticLabel = "Character Width"
							End With						
							With .StaticTexts.Add
								.staticLabel = "Max Characters"
							End With
							With .StaticTexts.Add
								.staticLabel = "Hidden"
							End With
						End With
						With .DialogColumns.Add
							Set numberOfLines = .TextEditboxes.Add
							With numberOfLines
								.EditContents = setNumberOfLines
							End With
							Set characterWidth = .TextEditboxes.Add
							With characterWidth
								.EditContents = setCharacterWidth
							End With
							Set maxChars = .TextEditboxes.Add
							With maxChars
								.EditContents = setMaxChars
							End With
							Set blind = .checkboxControls.Add
							With blind
								.checkedState = setBlind                          
							End With
						End With
					End With
				End With
			End With
	
			With .BorderPanels.Add
				With .DialogColumns.Add
					With .DialogRows.Add
						With .DialogColumns.Add
							With .StaticTexts.Add
								.staticLabel = "CLEAR ALL CONFIGURED DATA?"
							End With
						End With
						With .DialogColumns.Add
							Set clearData = .checkboxControls.Add
							With clearData
								.checkedState = false
							End With
						End With
					End With
				End With
			End With
		End With
	
		myReturn = myDialog.Show
		
		If myReturn = True Then
			'Get the values from the dialog box.
			
			if(clearData.checkedState = true) then
				
				clearIt = MsgBox("Are you sure you want to clear all of the configured data for this element?", vbYesNo, "Clear Data")
				continueOn = (clearIt = vbYes)
				
				if continueOn then
					myObject.Label = ""
					myObject.InsertLabel "type", ""
					myObject.InsertLabel "sort", ""
					myObject.InsertLabel "maxChars", ""
					myObject.InsertLabel "numberOfLines", ""
					myObject.InsertLabel "characterWidth", ""
					myObject.InsertLabel "minPointSize", ""
					myObject.InsertLabel "maxPointSize", ""
					myObject.InsertLabel "fitMethod", ""
					myObject.InsertLabel "disableSpellcheck", ""
					myObject.InsertLabel "autoFill", ""
					myObject.InsertLabel "blind", ""
				end if			
			else
				'Make sure text name has been filled in
				if (txtName.EditContents <> "") then
					if (txtSort.EditContents <> "") then
						myObject.Label = txtName.EditContents
						
						myObject.InsertLabel "type", "flash"
						myObject.InsertLabel "sort", txtSort.EditContents
						myObject.InsertLabel "maxChars", maxChars.EditContents
						myObject.InsertLabel "numberOfLines", numberOfLines.EditContents
						myObject.InsertLabel "characterWidth", characterWidth.EditContents
						myObject.InsertLabel "minPointSize", minPointSize.EditContents
						myObject.InsertLabel "maxPointSize", maxPointSize.EditContents
						myObject.InsertLabel "fitMethod", fitMethodDropDown(fitMethod.selectedIndex)
						myObject.InsertLabel "autoFill", autoFill.EditContents
	
	
						if(blind.checkedState = true) then
							myObject.InsertLabel "blind", "true"
						else
							myObject.InsertLabel "blind", "false"
						end if
	
	
						if(disableSpellcheck.checkedState = true) then
							myObject.InsertLabel "disableSpellcheck", "true"
						else
							myObject.InsertLabel "disableSpellcheck", "false"
						end if
					else
						MsgBox ("Sort order cannot be blank.")
					end if
				else
					MsgBox ("Flash name cannot be blank.")
				end if
			end if
		End If
	End Function
else
	MsgBox ("Please configure your scripts.")
end if


Function ReadPref(theKey)
	Dim wsh
	Dim returnMe
	Set wsh = CreateObject("WScript.Shell")
	
	On Error Resume Next
		returnMe = wsh.RegRead(pP2PrefsRegistryKey & theKey)
	On Error Goto 0
	
	ReadPref = returnMe
End Function


Function getNextSort (theType, myInDesign)
	dim finalSort, myCounter, elemType
	
	finalSort = 0
	
	'Loop through elements on current document
	For myCounter = 1 To myInDesign.ActiveDocument.PageItems.Count
		elemType = myInDesign.ActiveDocument.PageItems.Item(myCounter).ExtractLabel ("type")
		
		if(elemType = theType) then
			newSort = cInt(myInDesign.ActiveDocument.PageItems.Item(myCounter).ExtractLabel ("sort"))
			
			if (newSort > finalSort) then
				finalSort = newSort
			end if
		end if	
	Next
	
	finalSort = finalSort + 1
	
	getNextSort = CStr(finalSort)
End Function

