pP2PrefsRegistryKey = "HKCU\Software\DND\InDesign_ProMotor\"


'Load the version
theVersion = ReadPref("ID_Version")


if (theVersion <> "") then

	Set myInDesign = CreateObject("InDesign.Application." & theVersion)

	'Check document is open.
	If myInDesign.Documents.Count <> 0 Then
		'Check one element is selected.
		If myInDesign.Selection.Count = 1 Then
			
			set myElem = myInDesign.Selection.Item(1)
					
			if (TypeName(myElem) = "TextFrame") then
				'Check selected element is new or type is text.
				if (myElem.ExtractLabel ("type") = "text") OR (myElem.ExtractLabel ("type") = "") then
					if(myElem.TextFrameIndex = 1) then
						myDisplayDialog myInDesign, myElem
					else
						MsgBox ("Please select the first linked text box.")
					end if
				else
					MsgBox ("This element has been configured as a " & myElem.ExtractLabel("type") & " elemenet.")
				end if
			else
				MsgBox ("Please select a text element using the selection tool.")
			end if
		Else
			MsgBox ("Please select a text element.")
		End If
	Else
		MsgBox ("Please open a document.")
	End If
	
	Function myDisplayDialog(myInDesign, myObject)
		dim setTxtName, setDefaultTxt, setMaxChars, setSort, setAutoFill, setNumberOfLines, setCharacterWidth, setMinPointSize
		
		
		'Set fit method drop down values
		dim fitMethodDropDown(4)
		fitMethodDropDown(0)="None"
		fitMethodDropDown(1)="Adjust By Size"
		fitMethodDropDown(2)="Adjust By Leading"
		fitMethodDropDown(3)="Adjust by Horizontal Scale"
		fitMethodDropDown(4)="Adjust by Word Spacing"

			
		if(myObject.Label = "") then
			'Newly configured element
			
			setTxtName = myObject.Contents
			setDefaultTxt = myObject.Contents
			setSort = getNextSort("text", myInDesign)
			
			
			'Work out box size
			if(myObject.id <> myObject.EndTextFrame.id) then
				'linked text box
				setMaxChars = "60"
				setCharacterWidth = "30"
				setNumberOfLines = "5"
			else
				'single text box
				textToReplace = myObject.Contents
				myObject.Contents = ""
				i = 1
				
				Do Until (myObject.Overflows)
					myObject.Contents = myObject.Contents & "nm "
					i = i + 3
				Loop
		
				setMaxChars = CStr(i)
				setCharacterWidth = CStr(round(i / myObject.lines.count))
				setNumberOfLines = CStr(myObject.lines.count)
		
				myObject.Contents = ""
				myObject.Contents = textToReplace
			end if
		else
			setTxtName = myObject.Label
			setMaxChars = myObject.ExtractLabel ("maxChars")
			setNumberOfLines = myObject.ExtractLabel ("numberOfLines")
			setCharacterWidth = myObject.ExtractLabel ("characterWidth")
			setDefaultTxt = myObject.ExtractLabel ("defaultTxt")
			setSort = myObject.ExtractLabel ("sort")
			setMaxPointSize = myObject.ExtractLabel ("maxPointSize")
		end if
		
		
		setAutoFill = myObject.ExtractLabel ("autoFill")
		setMinPointSize = myObject.ExtractLabel ("minPointSize")
		setMaxPointSize = myObject.ExtractLabel ("maxPointSize")
		setDingbat = myObject.ExtractLabel ("dingbat")
		setStartOfLine = myObject.ExtractLabel ("startOfLine")
		setsearchReplace = myObject.ExtractLabel ("searchReplace")
		
		
		if(myObject.ExtractLabel ("blind") = "true") then
			setBlind = true
		else
			setBlind = false
		end if

		if(myObject.ExtractLabel ("vd") = "true") then
			setVD = true
		else
			setVD = false
		end if
		
		
		'Find selected fit method
		setFitMethod = 0	
		For i = LBound(fitMethodDropDown) to UBound(fitMethodDropDown)
			if(fitMethodDropDown(i) = myObject.ExtractLabel ("fitMethod")) then
				setFitMethod = i
			end if
		Next
		
		
		setDisableSpellcheck = false
		if(myObject.ExtractLabel ("disableSpellcheck") = "true") then
			setDisableSpellcheck = true
		end if
		
		
		setAllowWysiwyg = false
		if(myObject.ExtractLabel ("allowWysiwyg") = "true") then
			setAllowWysiwyg = true
		end if
		
		
		setSubEdit = false
		if(myObject.ExtractLabel ("subEdit") = "true") then
			setSubEdit = true
		end if
			
		
		Set myDialog = myInDesign.Dialogs.Add
		myDialog.Name = "Configure Text"
		
		With myDialog.DialogColumns.Add
			With .BorderPanels.Add
				With .DialogColumns.Add
					With .DialogRows.Add
						With .DialogColumns.Add
							With .StaticTexts.Add
								.staticLabel = "Name"
							End With
							With .StaticTexts.Add
								.staticLabel = "Sort"
							End With
							With .StaticTexts.Add
								.staticLabel = "Auto Fill"
							End With
							With .StaticTexts.Add
								.staticLabel = "Dingbat"
							End With
							With .StaticTexts.Add
								.staticLabel = "Start of Line"
							End With						
							With .StaticTexts.Add
								.staticLabel = "Default Text"
							End With
							With .StaticTexts.Add
								.staticLabel = "Fit Method"
							End With
							With .StaticTexts.Add
								.staticLabel = "Fit Minimum"
							End With
							With .StaticTexts.Add
								.staticLabel = "Fit Maximum"
							End With
							With .StaticTexts.Add
								.staticLabel = "Search and Replace"
							End With	
							With .StaticTexts.Add
								.staticLabel = "Disable Spellcheck"
							End With	
							With .StaticTexts.Add
								.staticLabel = "Allow WYSIWYG"
							End With
							With .StaticTexts.Add
								.staticLabel = "Sub-Editing"
							End With																								
						End With
						With .DialogColumns.Add
							Set txtName = .TextEditboxes.Add
							With txtName
								.EditContents = setTxtName
								.MinWidth = 190
							End With
							Set txtSort = .TextEditboxes.Add
							With txtSort
								.EditContents = setSort
							End With
							Set autoFill = .TextEditboxes.Add
							With autoFill
								.EditContents = setAutoFill
								.MinWidth = 190
							End With
							Set dingbat = .TextEditboxes.Add
							With dingbat
								.EditContents = setDingbat
								.MinWidth = 190
							End With
							Set startOfLine = .TextEditboxes.Add
							With startOfLine
								.EditContents = setStartOfLine
								.MinWidth = 190
							End With
							Set defaultTxt = .TextEditboxes.Add
							With defaultTxt
								.EditContents = setDefaultTxt
								.MinWidth = 190
							End With
							Set fitMethod = .dropdowns.Add
							With fitMethod
								.StringList = fitMethodDropDown
								.selectedIndex = setFitMethod
							End With
							Set minPointSize = .TextEditboxes.Add
							With minPointSize
								.EditContents = setMinPointSize
							End With
							Set maxPointSize = .TextEditboxes.Add
							With maxPointSize
								.EditContents = setMaxPointSize
							End With
							Set searchReplace = .TextEditboxes.Add
							With searchReplace
								.EditContents = setSearchReplace
								.MinWidth = 190
							End With	
							Set disableSpellcheck = .checkboxControls.Add
							With disableSpellcheck
								.checkedState = setDisableSpellcheck                          
							End With
							Set allowWysiwyg = .checkboxControls.Add
							With allowWysiwyg
								.checkedState = setAllowWysiwyg
							End With
							Set subEdit = .checkboxControls.Add
							With subEdit
								.checkedState = setSubEdit
							End With				
						End With
					End With
				End With
			End With
			
			With .BorderPanels.Add
				With .DialogColumns.Add
					With .DialogRows.Add
						With .DialogColumns.Add
							With .StaticTexts.Add
								.staticLabel = "Number of Lines"
							End With
							With .StaticTexts.Add
								.staticLabel = "Character Width"
							End With						
							With .StaticTexts.Add
								.staticLabel = "Max Characters"
							End With
							With .StaticTexts.Add
								.staticLabel = "Hidden"
							End With
							With .StaticTexts.Add
								.staticLabel = "Variable Depth"
							End With							
						End With
						With .DialogColumns.Add
							Set numberOfLines = .TextEditboxes.Add
							With numberOfLines
								.EditContents = setNumberOfLines
							End With
							Set characterWidth = .TextEditboxes.Add
							With characterWidth
								.EditContents = setCharacterWidth
							End With
							Set maxChars = .TextEditboxes.Add
							With maxChars
								.EditContents = setMaxChars
							End With
							Set blind = .checkboxControls.Add
							With blind
								.checkedState = setBlind                          
							End With
							Set vd = .checkboxControls.Add
							With vd
								.checkedState = setVD                          
							End With
						End With
					End With
				End With
			End With
			
			
			if myObject.RotationAngle <> 0 then
				With .BorderPanels.Add
					With .DialogColumns.Add
						With .DialogRows.Add
							With .DialogColumns.Add
								With .StaticTexts.Add
									.staticLabel = "*PLEASE ROTATE ELEMENTS FROM THE LOWER LEFT CORNER"
								End With
							End With

						End With
					End With
				End With
			end if
	
	
			With .BorderPanels.Add
				With .DialogColumns.Add
					With .DialogRows.Add
						With .DialogColumns.Add
							With .StaticTexts.Add
								.staticLabel = "CLEAR ALL CONFIGURED DATA?"
							End With
						End With
						With .DialogColumns.Add
							Set clearData = .checkboxControls.Add
							With clearData
								.checkedState = false
							End With
						End With
					End With
				End With
			End With
		End With
	
		myReturn = myDialog.Show
		
		If myReturn = True Then
			'Get the values from the dialog box.
			
			if(clearData.checkedState = true) then
				
				clearIt = MsgBox("Are you sure you want to clear all of the configured data for this element?", vbYesNo, "Clear Data")
				continueOn = (clearIt = vbYes)
				
				if continueOn then
					myObject.Label = ""
					myObject.InsertLabel "type", ""
					myObject.InsertLabel "sort", ""
					myObject.InsertLabel "defaultTxt", ""
					myObject.InsertLabel "maxChars", ""
					myObject.InsertLabel "autoFill", ""
					myObject.InsertLabel "dingbat", ""
					myObject.InsertLabel "startOfLine", ""
					myObject.InsertLabel "numberOfLines", ""
					myObject.InsertLabel "characterWidth", ""
					myObject.InsertLabel "minPointSize", ""
					myObject.InsertLabel "maxPointSize", ""
					myObject.InsertLabel "fitMethod", ""
					myObject.InsertLabel "allowWysiwyg", ""
					myObject.InsertLabel "disableSpellcheck", ""
					myObject.InsertLabel "blind", ""
					myObject.InsertLabel "vd", ""
					myObject.InsertLabel "subEdit", ""
					myObject.InsertLabel "searchReplace", ""
				end if			
			else
				'Make sure text name has been filled in
				if (txtName.EditContents <> "") then
					if (txtSort.EditContents <> "") then
						myObject.Label = txtName.EditContents
						
						myObject.InsertLabel "type", "text"
						myObject.InsertLabel "sort", txtSort.EditContents
						myObject.InsertLabel "defaultTxt", defaultTxt.EditContents
						myObject.InsertLabel "maxChars", maxChars.EditContents
						myObject.InsertLabel "autoFill", autoFill.EditContents
						myObject.InsertLabel "dingbat", dingbat.EditContents
						myObject.InsertLabel "startOfLine", startOfLine.EditContents
						myObject.InsertLabel "numberOfLines", numberOfLines.EditContents
						myObject.InsertLabel "characterWidth", characterWidth.EditContents
						myObject.InsertLabel "minPointSize", minPointSize.EditContents
						myObject.InsertLabel "maxPointSize", maxPointSize.EditContents
						myObject.InsertLabel "fitMethod", fitMethodDropDown(fitMethod.selectedIndex)
						myObject.InsertLabel "searchReplace", searchReplace.EditContents
						
						
						if(allowWysiwyg.checkedState = true) then
							myObject.InsertLabel "allowWysiwyg", "true"
						else
							myObject.InsertLabel "allowWysiwyg", "false"
						end if
						
						
						if(disableSpellcheck.checkedState = true) then
							myObject.InsertLabel "disableSpellcheck", "true"
						else
							myObject.InsertLabel "disableSpellcheck", "false"
						end if
						
						
						if(subEdit.checkedState = true) then
							myObject.InsertLabel "subEdit", "true"
						else
							myObject.InsertLabel "subEdit", "false"
						end if
						
						
						if(blind.checkedState = true) then
							myObject.InsertLabel "blind", "true"
						else
							myObject.InsertLabel "blind", "false"
						end if

						if(vd.checkedState = true) then
							myObject.InsertLabel "vd", "true"
						else
							myObject.InsertLabel "vd", "false"
						end if
						
					else
						MsgBox ("Sort order cannot be blank.")
					end if
				else
					MsgBox ("Text name cannot be blank.")
				end if
			end if
		End If
	End Function
else
	MsgBox ("Please configure your scripts.")
end if


Function ReadPref(theKey)
	Dim wsh
	Dim returnMe
	Set wsh = CreateObject("WScript.Shell")
	
	On Error Resume Next
		returnMe = wsh.RegRead(pP2PrefsRegistryKey & theKey)
	On Error Goto 0
	
	ReadPref = returnMe
End Function


Function getNextSort (theType, myInDesign)
	dim finalSort, myCounter, elemType
	
	finalSort = 0
	
	'Loop through elements on current document
	For myCounter = 1 To myInDesign.ActiveDocument.PageItems.Count
		elemType = myInDesign.ActiveDocument.PageItems.Item(myCounter).ExtractLabel ("type")
		
		if(elemType = theType) then
			newSort = cInt(myInDesign.ActiveDocument.PageItems.Item(myCounter).ExtractLabel ("sort"))
			
			if (newSort > finalSort) then
				finalSort = newSort
			end if
		end if	
	Next
	
	finalSort = finalSort + 1
	
	getNextSort = CStr(finalSort)
End Function
