pP2PrefsRegistryKey = "HKCU\Software\DND\InDesign_ProMotor\"
'SET THE VERSION HERE:
theVersion = ""
'theVersion = "4"
'theVersion = "CC"
'theVersion = "CC.2014"

if(theVersion = "")then
	'Load the version
	theVersion = ReadPref("ID_Version")


	'first time install
	if(theVersion = "")then
		theVersion = InputBox("This is a new installation, what version of InDesign are you using?","InDesign Version","")
	end if
end if


on error resume next
Set myInDesign = CreateObject("InDesign.Application." & theVersion)

if err.number <> 0 then
	theVersion = InputBox("An error has occurred, what version of InDesign are you using?","InDesign Version","")
end if

if (theVersion <> "") then

	Set myInDesign = CreateObject("InDesign.Application." & theVersion)

	'Load the URL
	theURL = ReadPref("Server_URL")
	If (theURL = "") Then 
		theURL = "http://127.0.0.1/"
	End If

	
	setClientID = ReadPref("Server_BF")


	setUser = ReadPref("id_user")


	setZipPath = ReadPref("zip_path")


	'Load the Proxy
	theProxy = ReadPref("Server_Proxy")


	'Load the version
	theVersion = ReadPref("ID_Version")

	'Load Product
	theProduct = ReadPref("EzAdsPro_Product")
	
	Select Case theProduct
		Case ""
			theProduct = 0
		Case "1"
			theProduct = 1
		Case "2"
			theProduct = 2	
		Case Else
			theProduct = 0
	End Select

	'application dd
	dim applicationDropDown(2)
	applicationDropDown(0) = "Publisher"
	applicationDropDown(1) = "BlueFin"
	applicationDropDown(2) = "Knight Frank"

	'version dd
	dim versionDropDown(16)
	versionDropDown(0) = "CS2"
	versionDropDown(1) = "CS3"
	versionDropDown(2) = "CS4"
	versionDropDown(3) = "CS5"
	versionDropDown(4) = "CS5.5"
	versionDropDown(5) = "CS6"
	versionDropDown(6) = "CC"
	versionDropDown(7) = "CC 2014"
	versionDropDown(8) = "CC 2015"
	versionDropDown(9) = "CC 2017"
	versionDropDown(10) = "CC 2018"
	versionDropDown(11) = "CC 2019"
	versionDropDown(12) = "2020"
	versionDropDown(13) = "2021"
	versionDropDown(14) = "2022"
	versionDropDown(15) = "2023"
	versionDropDown(16) = "2024"

	Select Case theVersion
		Case "CC"
			theVersion = 6
		Case "CC.2014"
			theVersion = 7
		Case "CC.2015"
			theVersion = 8	
		Case "CC.2017"
			theVersion = 9
		Case "CC.2018"
			theVersion = 10	
		Case "CC.2019"
			theVersion = 11
		Case "2020"
			theVersion = 12
		Case "2021"
			theVersion = 13
		Case "2022"
			theVersion = 14	
		Case "2023"
			theVersion = 15
		Case "2024"
			theVersion = 16			
		Case "CS2"
			theVersion = 0
		Case "CS3"
			theVersion = 1
		Case "CS4"
			theVersion = 2
		Case "CS5"
			theVersion = 3
		Case "CS5.5"
			theVersion = 4
		Case "CS6"
			theVersion = 5
		Case Else
			theVersion = 0
	End Select


	setNonPrint = false
	if(ReadPref("nonprint") = "true") then
		setNonPrint = true
	end if


	'set form title
	Set myDialog = myInDesign.Dialogs.Add
	myDialog.Name = "Preferences"
	
	With myDialog.DialogColumns.Add
		With .BorderPanels.Add
			With .DialogColumns.Add
				With .DialogRows.Add
					With .DialogColumns.Add
						With .StaticTexts.Add
							.staticLabel = "Server Address"
						End With
						With .StaticTexts.Add
							.staticLabel = "Proxy Address"
						End With
						With .StaticTexts.Add
							.staticLabel = "Zip Path"
						End With
						With .StaticTexts.Add
							.staticLabel = "Application"
						End With
						With .StaticTexts.Add
							.staticLabel = "InDesign Version"
						End With
						With .StaticTexts.Add
							.staticLabel = "Client ID"
						End With
						With .StaticTexts.Add
							.staticLabel = "User"
						End With
						With .StaticTexts.Add
							.staticLabel = "Disable 'nonprinting'"
						End With
					End With
					With .DialogColumns.Add
						Set serverAddress = .TextEditboxes.Add
						With serverAddress
							.EditContents = theURL
							.MinWidth = 180
						End With
						
						Set serverProxy = .TextEditboxes.Add
						With serverProxy
							.EditContents = theProxy
							.MinWidth = 180
						End With

						Set zipPath = .TextEditboxes.Add
						With zipPath
							.EditContents = setZipPath
							.MinWidth = 180
						End With
						
						Set application = .dropdowns.Add
						With application
							.StringList = applicationDropDown
							.selectedIndex = theProduct
							.MinWidth = 180
						End With

						Set version = .dropdowns.Add
						With version
							.StringList = versionDropDown
							.selectedIndex = theVersion
							.MinWidth = 180
						End With

						Set clientID = .TextEditboxes.Add
						With clientID
							.EditContents = setClientID
							.MinWidth = 180
						End With

						Set user = .TextEditboxes.Add
						With user
							.EditContents = setUser
							.MinWidth = 180
						End With

						Set nonprint = .checkboxControls.Add
						With nonprint
							.checkedState = setNonPrint                          
						End With
					End With
				End With
			End With
		End With
	End With
	
	
	'show dialog
	myReturn = myDialog.Show


	'ok was clicked
	if(myReturn) then

		'format server address
		serverAddressVal = serverAddress.EditContents
		
		If((InStr(serverAddressVal, "http://") <> 1) AND (InStr(serverAddressVal, "https://") <> 1))then
			serverAddressVal = "http://" + serverAddressVal
		end if
		
		if(InStrRev(serverAddressVal,"/") <> len(serverAddressVal))then
			serverAddressVal = serverAddressVal + "/"
		end if
		
		
		'write values from dialog box to registry.
		writePref "Server_URL", serverAddressVal
		writePref "Server_Proxy", serverProxy.EditContents
		writePref "Server_BF", clientID.EditContents
		writePref "id_user", user.EditContents
		writePref "zip_path", zipPath.EditContents
		writePref "is_preview", ""


		if(nonprint.checkedState = true) then
			writePref "nonprint", "true"
		else
			writePref "nonprint", "false"
		end if


		Select Case application.selectedIndex
			Case "0"
				writePref "EzAdsPro_Product", ""
			Case "1"
				writePref "EzAdsPro_Product", "1"
			Case "2"
				writePref "EzAdsPro_Product", "2"

			Case Else
				writePref "EzAdsPro_Product", ""
		End Select


		Select Case version.selectedIndex
			Case "0"
				writePref "ID_Version", "CS2"
			Case "1"
				writePref "ID_Version", "CS3"
			Case "2"
				writePref "ID_Version", "CS4"
			Case "3"
				writePref "ID_Version", "CS5"
			Case "4"
				writePref "ID_Version", "CS5.5"
			Case "5"
				writePref "ID_Version", "CS6"
			Case "6"
				writePref "ID_Version", "CC"
			Case "7"
				writePref "ID_Version", "CC.2014"
			Case "8"
				writePref "ID_Version", "CC.2015"
			Case "9"
				writePref "ID_Version", "CC.2017"
			Case "10"
				writePref "ID_Version", "CC.2018"
			Case "11"
				writePref "ID_Version", "CC.2019"
			Case "12"
				writePref "ID_Version", "2020"
			Case "13"
				writePref "ID_Version", "2021"
			Case "14"
				writePref "ID_Version", "2022"
			Case "15"
				writePref "ID_Version", "2023"
			Case "16"
				writePref "ID_Version", "2024"				
			Case Else
				writePref "ID_Version", "CS2"
		End Select
	end if
end if


Function ReadPref(theKey)
	Dim wsh
	Dim returnMe
	Set wsh = CreateObject("WScript.Shell")
	
	On Error Resume Next
		returnMe = wsh.RegRead(pP2PrefsRegistryKey & theKey)
	On Error Goto 0
	
	ReadPref = returnMe
End Function


Sub WritePref(ByRef theKey, ByRef newValue)
		Dim wsh
		Set wsh = CreateObject("WScript.Shell")
	
		Call wsh.RegWrite(pP2PrefsRegistryKey & theKey, newValue)
End Sub
