pP2PrefsRegistryKey = "HKCU\Software\DND\InDesign_ProMotor\"
'SET THE VERSION HERE:
theVersion = ""
'theVersion = "4"
'theVersion = "CC"
'theVersion = "CC.2014"

if(theVersion = "")then
	'Load the version
	theVersion = ReadPref("ID_Version")
end if

vlFontsUploaded = 0
vlFontDuplicates = 0
theResult = ""

if (theVersion <> "") then

	Set myInDesign = CreateObject("InDesign.Application." & theVersion)
	
	'Check document is open.
	If myInDesign.Documents.Count <> 0 Then
		
		goOn = MsgBox("Are you sure you want to sync the fonts contained in this document?", vbYesNo, "Sync Document Fonts")
		if(goOn = vbYes) then
			
			MsgBox("Please check your font licence agreement")
			
			'Get users home directory
			set shell = CreateObject("WScript.Shell")
			docPath = shell.ExpandEnvironmentStrings("%APPDATA%")
	
			
			'Setup server path
			url = ReadPref("Server_URL") & "4dcgi/font_upload.a4d"
			
			
			'Font check data
			theFontData = DownloadLongText(ReadPref("Server_URL") & "u_get_font_list.a4d")
			
			
			'Setup paths
			tmpFilePath = folderPath & "FontData#.txt"
			tmpZipFilePath = docPath & "\FontData#.zip"
			
	
			For myCounter = 1 To myInDesign.ActiveDocument.Fonts.Count				
				'Get font filename
				fileName = myInDesign.ActiveDocument.Fonts(myCounter).Location
				vlPos = InStrRev(fileName,"\") + 1
				fileName = Mid(fileName,vlPos)
				
				'Get font name
				fontName = myInDesign.ActiveDocument.Fonts(myCounter).name
				
				'Get postscript name
				postscriptName = myInDesign.ActiveDocument.Fonts(myCounter).PostScriptName
				
				
				'Check T1 fonts have associated files
				continueOn = true
				newFilePath1 = ""
				newFilePath2 = ""
	
				if(InStr(1, fileName, ".pfb", 1) <> 0) then
					newFilePath1 = replace(myInDesign.ActiveDocument.Fonts(myCounter).Location,".pfb", ".afm", 1, -1, 1)
					If not checkFileExists(newFilePath1) Then
						continueOn = false
					end if
					
					newFilePath2 = replace(myInDesign.ActiveDocument.Fonts(myCounter).Location,".pfb", ".pfm", 1, -1, 1)
					If not checkFileExists(newFilePath2) Then
						continueOn = false
					end if				
				end if
				
	
				if (continueOn) then
				
					'Check fonts	
					'if(InStr(theFontData, fileName + ",") = 0) then	
						if(InStr(theFontData, "," + fontName + ",") = 0) then	
							if(InStr(theFontData, "," + postscriptName + ",") = 0) then	
								'Increment count
								vlFontsUploaded = vlFontsUploaded + 1
								
								
								'Unique paths
								FilePath = replace(tmpFilePath,"#", vlFontsUploaded)
								ZipFilePath = replace(tmpZipFilePath,"#", vlFontsUploaded)
				
								
								'Clear out data file
								DeleteTmpFile FilePath
								
								
								'Clear out zip file
								DeleteTmpFile ZipFilePath
								
								
								'Create zip
								Set fso = CreateObject("Scripting.FileSystemObject")
								commandLine = "zip -j " & chr(34) & ZipFilePath & chr(34) & " -@"
								Set WshShell = CreateObject("WScript.Shell")
								Set zipExec = WshShell.Exec(commandLine)
								errMsg = Err.Description
					
								If IsObject(zipExec) Then			
									'Create txt file
									Set objFSO = CreateObject("scripting.filesystemobject")
									Set objTextStream = objFSO.OpenTextFile(FilePath, 2, True)	
						
						
									'Write data to file
									objTextStream.WriteLine myInDesign.ActiveDocument.Fonts(myCounter).PostScriptName + "|" + replace(myInDesign.ActiveDocument.Fonts(myCounter).Name, chr(9)," ")
									
									
									'Include font file in zip
									If checkFileExists(myInDesign.ActiveDocument.Fonts(myCounter).Location) Then
										zipExec.StdIn.WriteLine(myInDesign.ActiveDocument.Fonts(myCounter).Location)
									end if
									
									
									'Include T1 associated files
									if (newFilePath1 <> "") then
										zipExec.StdIn.WriteLine(newFilePath1)
									end if
									
									if (newFilePath2 <> "") then
										zipExec.StdIn.WriteLine(newFilePath2)
									end if						
									
									
									'Include txt file in zip
									If checkFileExists(FilePath) Then
										zipExec.StdIn.WriteLine(FilePath)
									end if				
									
									
									zipExec.StdIn.Write(Chr(26))
					
									Do While zipExec.Status = 0
										SillySleep 1
									Loop
									
									SillySleep 2
									
									If checkFileExists(ZipFilePath) Then
										SillySleep 2
										theResult = PostFile (url, ZipFilePath)
									end if
								end if
							else
								vlFontDuplicates = vlFontDuplicates + 1
							end if
						else
							vlFontDuplicates = vlFontDuplicates + 1
						end if
					'else
						'vlFontDuplicates = vlFontDuplicates + 1
					'end if
				end if
			Next

			if(InStr(theResult, "outsourcing") = 0) then	
				msgbox("Sync Complete: " + CStr(vlFontsUploaded) + " Synced, " + CStr(vlFontDuplicates) + " Duplicates")
			else
				msgbox("You are uploading to an outsourcing server, please contact John Ford.")
			end if
		end if
	end if
else
	MsgBox ("Please configure your scripts.")
end if


Function ReadPref(theKey)
	Dim wsh
	Dim returnMe
	Set wsh = CreateObject("WScript.Shell")
	
	On Error Resume Next
		returnMe = wsh.RegRead(pP2PrefsRegistryKey & theKey)
	On Error Goto 0
	
	ReadPref = returnMe
End Function


Function DownloadLongText(ByVal url)
	Dim returnMe
	Dim errTemp
	Dim xmlhttp
	
	returnMe = ""

	On Error Resume Next
	Set xmlhttp = CreateObject("MSXML2.XMLHTTP")

	errTemp = Err.Number
	If errTemp <> 0 Then
		msgbox("Unable to create scripting object: MSXML2.XMLHTTP")
		msgbox(Err.Description )
	End If

	If errTemp = 0 Then
		Call xmlhttp.Open("GET", url, False)
		errTemp = Err.Number
	End If
	
	If errTemp = 0 Then
		xmlhttp.Send
		errTemp = Err.Number
	End If

	If errTemp = 0 Then
		returnMe = xmlhttp.ResponseText
	End If
	
	DownloadLongText = returnMe
End Function


Function checkFileExists(filePathToCheck)
	dim filesys
	dim returnVal
	
	Set filesys = CreateObject("Scripting.FileSystemObject") 

	If filesys.FileExists(filePathToCheck) Then
		returnVal = true
	else
		returnVal = false
	End If 
	
	checkFileExists = returnVal
End Function


Sub DeleteTmpFile(filePathToDelete)
	dim filesys
	
	Set filesys = CreateObject("Scripting.FileSystemObject")
	filesys.CreateTextFile filePathToDelete, True 
	If filesys.FileExists(filePathToDelete) Then
	   filesys.DeleteFile filePathToDelete 
	End If 
End Sub


Sub SillySleep(ByRef seconds)
	Dim WshShell, commandLine
	Set WshShell = CreateObject("Wscript.Shell")
	commandLine = "%COMSPEC% /c ping -n " & 1 + seconds & " 127.0.0.1>nul"
	Call WshShell.Run(commandLine, 0, 1)
End Sub



Function PostFile(ByRef url, ByRef fileObj)
	Dim returnMe
	Dim commandLine
	
	returnMe = ""
	commandLine = "-F upload=@" & chr(34) & fileObj & chr(34) & " " & url
	
	returnMe = CURL(commandLine)

	PostFile = returnMe
End Function



Function CURL(ByVal commandLine)
	Dim returnMe
	Dim errMsg
	Dim WshShell, curlExec, i
	
	returnMe = ""
	theProxy = ReadPref("Server_Proxy")
	
	if theProxy <> "" then
		commandLine = "-x " & theProxy & " " & commandLine
	end if
	
	commandLine = "curl " & commandLine
	Set WshShell = CreateObject("WScript.Shell")
	
	On Error Resume Next
	Set curlExec = WshShell.Exec(commandLine)


	errMsg = Err.Description
	On Error Goto 0
	
	If IsObject(curlExec) Then
		Dim timeLeft
		
		'Time left in seconds
		timeLeft = 120
		Do While (curlExec.Status = 0) And (timeLeft > 0)
			SillySleep(1)
			timeLeft = timeLeft - 1
		Loop

		If (timeLeft > 0) Then
			If (curlExec.ExitCode = 0) Then
				returnMe = curlExec.StdOut.ReadAll
			Else
				Dim errNum, errText
				errText = curlExec.StdOut.ReadAll
				errNum = curlExec.ExitCode
				returnMe = errText
			End If
		Else
			curlExec.Terminate
		End If
	Else
		DisplayError("Unable to find curl.exe")
	End If
	
	CURL = returnMe
End Function

