pP2PrefsRegistryKey = "HKCU\Software\DND\InDesign_ProMotor\"
'SET THE VERSION HERE:
theVersion = ""
'theVersion = "4"
'theVersion = "CC"
'theVersion = "CC.2014"

if(theVersion = "")then
	'Load the version
	theVersion = ReadPref("ID_Version")
end if

if (theVersion <> "") then

	Set myInDesign = CreateObject("InDesign.Application." & theVersion)


	'Set data type drop down values
	dim dataTypeDropDown(1)
	dataTypeDropDown(0)="Properties"
	dataTypeDropDown(1)="Vehicles"


	groupListText = GetGroupList()

	If (groupListText <> "") Then
		groupListText = "None," + groupListText
		groupListText = Replace(groupListText,chr(13),"")
		groupListText = Replace(groupListText,chr(10),"")

		groupList = Split(groupListText, ",")
	Else
		dim groupList(0)
		groupList(0) = "Unable to connect to server."
	End If

	
	Set myDialog = myInDesign.Dialogs.Add
	myDialog.Name = "Create Group"
	
	With myDialog.DialogColumns.Add
		With .BorderPanels.Add
			With .DialogColumns.Add
				With .DialogRows.Add
					With .DialogColumns.Add
						With .StaticTexts.Add
							.staticLabel = "Group Name"
						End With
						With .StaticTexts.Add
							.staticLabel = "Parent Group"
						End With
						With .StaticTexts.Add
							.staticLabel = "Data Type"
						End With
						With .StaticTexts.Add
							.staticLabel = "Black Box ID"
						End With												
					End With
					With .DialogColumns.Add
						Set groupName = .TextEditboxes.Add
						With groupName
							.EditContents = ""
							.MinWidth = 200
						End With
						Set parentGroup = .dropdowns.Add
						With parentGroup
							.StringList = groupList
							.selectedIndex = 0
							.MinWidth = 200
						End With
						Set dataType = .dropdowns.Add
						With dataType
							.StringList = dataTypeDropDown
							.selectedIndex = 0
							.MinWidth = 200
						End With
						Set bbid = .TextEditboxes.Add
						With bbid
							.EditContents = ""
							.MinWidth = 200
						End With
					End With
				End With
			End With
		End With
	End With
	
	'display dialog
	myReturn = myDialog.Show

	If(myReturn = True)Then
		theName = groupName.EditContents

		if(theName = "")then
			msgbox("Group name cannot be blank")
		else
			theParentGroup = groupList(parentGroup.selectedIndex)
			theBBID = bbid.EditContents

			if(dataType.selectedIndex = 0)then
				theDataType = "Properties"
			else
				theDataType = "Vehicles"
			end if

			encodedGroupName = Encode_UTF8(theName)
			encodedParentGroup = Encode_UTF8(theParentGroup)

			'the server url
			theURL = ReadPref("Server_URL")

			'do build and return preview url
			theFullURL = theURL & "4dcgi/create_group_from_id.a4d?group_name=" & encodedGroupName & "&parent_group_name=" & encodedParentGroup & "&bbid=" & theBBID & "&data_type=" & theDataType & "&unique=" & CreateGUID
			'msgbox(theFullURL)
			
			siteText = PostForm(theFullURL, "a=1")

			If(Len(siteText) < 200)Then
				msgbox(siteText)
			else
				msgbox("An error has occurred.")
			end if
		end if
	end if
else
	MsgBox ("Please configure your scripts.")
end if


Function CreateGUID
  Dim TypeLib
  Set TypeLib = CreateObject("Scriptlet.TypeLib")
  CreateGUID = Mid(TypeLib.Guid, 2, 36)
End Function


Function Encode_UTF8(astr)
    astr = Replace(astr, "’", "'")
    astr = Replace(astr, "–", "-")
	astr = Replace(astr, " ", "%20")

    Encode_UTF8 = astr
End Function


Function PostForm(ByRef url, ByRef formData)
	Dim returnMe, formText, commandLine
	
	returnMe = ""

	If IsArray(formData) Then
		formText = MakeFormText(formData)
	Else
		formText = formData
	End If

	commandLine = "-F " & formText & " " & url	
	
	returnMe = CURL(commandLine)

	PostForm = returnMe
End Function


Function ReadPref(theKey)
	Dim wsh
	Dim returnMe
	Set wsh = CreateObject("WScript.Shell")
	
	On Error Resume Next
		returnMe = wsh.RegRead(pP2PrefsRegistryKey & theKey)
	On Error Goto 0
	
	ReadPref = returnMe
End Function


Sub SillySleep(ByRef seconds)
	Dim WshShell, commandLine
	Set WshShell = CreateObject("Wscript.Shell")
	commandLine = "%COMSPEC% /c ping -n " & 1 + seconds & " 127.0.0.1>nul"
	Call WshShell.Run(commandLine, 0, 1)
End Sub



Function PostFile(ByRef url, ByRef fileObj)
	Dim returnMe
	Dim commandLine
	
	returnMe = ""
	commandLine = "-F upload=@" & chr(34) & fileObj & chr(34) & " " & url
	
	returnMe = CURL(commandLine)

	PostFile = returnMe
End Function



Function CURL(ByVal commandLine)
	Dim returnMe
	Dim errMsg
	Dim WshShell, curlExec, i
	
	returnMe = ""
	theProxy = ReadPref("Server_Proxy")
	
	if theProxy <> "" then
		commandLine = "-x " & theProxy & " " & commandLine
	end if
	
	commandLine = "curl " & commandLine
	Set WshShell = CreateObject("WScript.Shell")
	
	On Error Resume Next
	Set curlExec = WshShell.Exec(commandLine)


	errMsg = Err.Description
	On Error Goto 0
	
	If IsObject(curlExec) Then
		Dim timeLeft
		
		'Time left in seconds
		timeLeft = 120
		Do While (curlExec.Status = 0) And (timeLeft > 0)
			SillySleep(1)
			timeLeft = timeLeft - 1
		Loop

		If (timeLeft > 0) Then
			If (curlExec.ExitCode = 0) Then
				returnMe = curlExec.StdOut.ReadAll
			Else
				Dim errNum, errText
				errText = curlExec.StdOut.ReadAll
				errNum = curlExec.ExitCode
				returnMe = errText
			End If
		Else
			curlExec.Terminate
		End If
	Else
		DisplayError("Unable to find curl.exe")
	End If
	
	CURL = returnMe
End Function

Function GetGroupList()
	dim theURL, theResult

	theURL = ReadPref("Server_URL")
	
	if(theURL = "http://127.0.0.1/") then
		theResult = DownloadLongText(theURL & "ezp_engine/code/group_list.php")
	else
		theResult = DownloadLongText(theURL & "4dcgi/u_get_group_list.a4d")
	end if
	
	GetGroupList = theResult
End Function

Function DownloadLongText(ByVal url)
	Dim returnMe
	Dim errTemp
	Dim xmlhttp
	
	returnMe = ""

	On Error Resume Next
	Set xmlhttp = CreateObject("MSXML2.XMLHTTP")

	errTemp = Err.Number
	If errTemp <> 0 Then
		msgbox("Unable to create scripting object: MSXML2.XMLHTTP")
		msgbox(Err.Description )
	End If

	If errTemp = 0 Then
		Call xmlhttp.Open("GET", url, False)
		errTemp = Err.Number
	End If
	
	If errTemp = 0 Then
		xmlhttp.Send
		errTemp = Err.Number
	End If

	If errTemp = 0 Then
		returnMe = xmlhttp.ResponseText
	End If
	
	DownloadLongText = returnMe
End Function