pP2PrefsRegistryKey = "HKCU\Software\DND\InDesign_ProMotor\"
'SET THE VERSION HERE:
theVersion = ""
'theVersion = "4"
'theVersion = "CC"
'theVersion = "CC.2014"

if(theVersion = "")then
	'Load the version
	theVersion = ReadPref("ID_Version")
end if


'get user document path
set shell = CreateObject("WScript.Shell")
docPath = shell.ExpandEnvironmentStrings("%APPDATA%")


if (theVersion <> "") then

	Set myInDesign = CreateObject("InDesign.Application." & theVersion)
	
	'group list
	groupListText = GetGroupList()
	setGroup = 0
	If (groupListText <> "") Then
		groupListText = Replace(groupListText,chr(13),"")
		groupListText = Replace(groupListText,chr(10),"")
		
		groupList = Split(groupListText, ",")
	Else
		dim groupList(0)
		groupList(0) = "Unable to connect to server."
	End If


	Set myDialog = myInDesign.Dialogs.Add
	myDialog.Name = "Choose a group"
	
	With myDialog.DialogColumns.Add
		With .BorderPanels.Add
			With .DialogColumns.Add
				With .DialogRows.Add
					With .DialogColumns.Add
						With .StaticTexts.Add
							.staticLabel = "Group"
						End With
						With .StaticTexts.Add
							.staticLabel = "Search"
						End With
						With .StaticTexts.Add
							.staticLabel = "Child Groups"
						End With
						With .StaticTexts.Add
							.staticLabel = "Not PAO"
						End With
					End With
					With .DialogColumns.Add
						Set docGroup = .dropdowns.Add
						With docGroup
							.StringList = groupList
							.selectedIndex = setGroup                           
						End With
						Set search = .TextEditboxes.Add
						With search
							.EditContents = ""
							.MinWidth = 200
						End With
						Set childGroups = .checkboxControls.Add
						With childGroups
							.checkedState = false                          
						End With
						Set notPAO = .checkboxControls.Add
						With notPAO
							.checkedState = false                          
						End With
					End With
				End With
			End With
		End With
	End With

	myReturn = myDialog.Show
	
	If myReturn = True Then
		
		selectedGroup = groupList(docGroup.selectedIndex)

		if(selectedGroup = "")then
			msgbox("Please select a group")
		else
			'get the url
			theURL = ReadPref("Server_URL")

			if(search.EditContents = "")then
				searchVal = ""
			else
				searchVal = "&search=" & search.EditContents
			end if

			if(childGroups.checkedState = true) then
				childVal = "&child=true"
			else
				childVal = ""
			end if

			if(notPAO.checkedState = true) then
				notPAOVal = "&notpao=true"
			else
				notPAOVal = ""
			end if


			'escape group name
			selectedGroup = Replace(selectedGroup," ","%20")
			selectedGroup = Replace(selectedGroup,"&","%26")

			'Get document list
			'msgbox(theURL & "/get_doc_list.a4d?gn=" & selectedGroup & "&unique=" & CreateGUID & childVal & searchVal)
			theDocData = DownloadLongText(theURL & "/get_doc_list.a4d?gn=" & selectedGroup & "&unique=" & CreateGUID & childVal & searchVal & notPAOVal)
			'msgbox(theDocData)
			'theDocData = ""

			if(theDocData = "")then
				msgbox("No documents linked to the group.")
			else
				tmpFilePath = docPath & "\outsourcing_tmp\"

				'clear out
				Set objFSO = CreateObject("Scripting.FileSystemObject")
				If objFSO.FolderExists(tmpFilePath) Then
					Set objShell = CreateObject("WScript.Shell")  
					strRun = "cmd /c rd /s /q """ & tmpFilePath & """"  
					objShell.Run strRun, 1, True
				else
					
				end if

				'create top level
				On Error Resume Next
				objFSO.CreateFolder (tmpFilePath)

				
				'split and loop
				arrDocs = Split(theDocData, ";")

				For i = LBound(arrDocs) to UBound(arrDocs)
					tmpDocPath = tmpFilePath & i & "\"
					objFSO.CreateFolder (tmpDocPath)

					zipPath = tmpDocPath & i & ".zip"
					zipDocPath = Left(tmpDocPath,Len(tmpDocPath)-1)

					commandLine = "-L " & chr(34) & arrDocs(i) & chr(34) & " -o " & chr(34) & zipPath & chr(34)
					'msgbox(commandLine)
					returnMe = CURL(commandLine)

					'If objFSO.FolderExists(zipPath) Then
						commandLine = "unzip -j " & chr(34) & zipPath & chr(34) & " -d " & chr(34) & zipDocPath & chr(34)
						Set WshShell = CreateObject("WScript.Shell")
						Set zipExec = WshShell.Exec(commandLine)

						'wait
						SillySleep(1)


						'find indd file
						inddPath = ""

						Set objFolder = objFSO.GetFolder(tmpDocPath)
						Set colFiles = objFolder.Files


						For Each objFile in colFiles
						    If UCase(objFSO.GetExtensionName(objFile.name)) = "INDD" Then
						        inddPath = tmpDocPath & objFile.Name
						        exit for
						    End If
						Next

						'open the document
						if(inddPath <> "")then
							myInDesign.open inddPath
						end if
					'end if
				Next

				msgbox("Finished")
			end if
		end if
	end if
else
	MsgBox ("Please configure your scripts.")
end if


Function CreateGUID
  Dim TypeLib
  Set TypeLib = CreateObject("Scriptlet.TypeLib")
  CreateGUID = Mid(TypeLib.Guid, 2, 36)
End Function


Function ReadPref(theKey)
	Dim wsh
	Dim returnMe
	Set wsh = CreateObject("WScript.Shell")
	
	On Error Resume Next
		returnMe = wsh.RegRead(pP2PrefsRegistryKey & theKey)
	On Error Goto 0
	
	ReadPref = returnMe
End Function


Function GetGroupList()
	dim theURL, theResult

	theURL = ReadPref("Server_URL")
	theResult = DownloadLongText(theURL & "4dcgi/u_get_group_list.a4d?unique=" & CreateGUID)
	
	GetGroupList = theResult
End Function


Function DownloadLongText(ByVal url)
	Dim returnMe
	Dim errTemp
	Dim xmlhttp
	
	returnMe = ""

	On Error Resume Next
	Set xmlhttp = CreateObject("MSXML2.XMLHTTP")

	errTemp = Err.Number
	If errTemp <> 0 Then
		msgbox("Unable to create scripting object: MSXML2.XMLHTTP")
		msgbox(Err.Description )
	End If

	If errTemp = 0 Then
		Call xmlhttp.Open("GET", url, False)
		errTemp = Err.Number
	End If
	
	If errTemp = 0 Then
		xmlhttp.Send
		errTemp = Err.Number
	End If

	If errTemp = 0 Then
		returnMe = xmlhttp.ResponseText
	End If

	if(false)then
		Set objFSO=CreateObject("Scripting.FileSystemObject")
		outFile="c:\test.txt"
		Set objFile = objFSO.CreateTextFile(outFile,True)
		objFile.Write returnMe & vbCrLf
		objFile.Close
	end if
	
	DownloadLongText = returnMe
End Function


Function checkFileExists(filePathToCheck)
	dim filesys
	dim returnVal
	
	Set filesys = CreateObject("Scripting.FileSystemObject") 

	If filesys.FileExists(filePathToCheck) Then
		returnVal = true
	else
		returnVal = false
	End If 
	
	checkFileExists = returnVal
End Function


Sub DeleteTmpFile(filePathToDelete)
	dim filesys
	
	Set filesys = CreateObject("Scripting.FileSystemObject")
	filesys.CreateTextFile filePathToDelete, True 
	If filesys.FileExists(filePathToDelete) Then
	   filesys.DeleteFile filePathToDelete 
	End If 
End Sub


Sub SillySleep(ByRef seconds)
	dteWait = DateAdd("s", seconds, Now())
	Do Until (Now() > dteWait)
	Loop
End Sub



Function PostFile(ByRef url, ByRef fileObj)
	Dim returnMe
	Dim commandLine
	
	returnMe = ""
	commandLine = "-F upload=@" & chr(34) & fileObj & chr(34) & " " & url
	
	returnMe = CURL(commandLine)

	PostFile = returnMe
End Function



Function CURL(ByVal commandLine)
	Dim returnMe
	Dim errMsg
	Dim WshShell, curlExec, i
	
	returnMe = ""
	theProxy = ReadPref("Server_Proxy")
	
	if theProxy <> "" then
		commandLine = "-x " & theProxy & " " & commandLine
	end if
	
	commandLine = "curl " & commandLine
	Set WshShell = CreateObject("WScript.Shell")
	
	On Error Resume Next
	Set curlExec = WshShell.Exec(commandLine)


	errMsg = Err.Description
	On Error Goto 0
	
	If IsObject(curlExec) Then
		Dim timeLeft
		
		'Time left in seconds
		timeLeft = 120
		Do While (curlExec.Status = 0) And (timeLeft > 0)
			SillySleep(1)
			timeLeft = timeLeft - 1
		Loop

		If (timeLeft > 0) Then
			If (curlExec.ExitCode = 0) Then
				returnMe = curlExec.StdOut.ReadAll
			Else
				Dim errNum, errText
				errText = curlExec.StdOut.ReadAll
				errNum = curlExec.ExitCode
				returnMe = errText
			End If
		Else
			curlExec.Terminate
		End If
	Else
		DisplayError("Unable to find curl.exe")
	End If
	
	CURL = returnMe
End Function

