pP2PrefsRegistryKey = "HKCU\Software\DND\InDesign_ProMotor\"
'SET THE VERSION HERE:
theVersion = ""
'theVersion = "4"
'theVersion = "CC"
'theVersion = "CC.2014"

if(theVersion = "")then
	'Load the version
	theVersion = ReadPref("ID_Version")
end if

theDelimeter = "|"
theProxy = ""
docName = "inDesign"
nameSeperator = "|"


'get user document path
set shell = CreateObject("WScript.Shell")
docPath = shell.ExpandEnvironmentStrings("%APPDATA%")


'set local paths
tmpFilePath = docPath & "\" & docName & ".pdf"

tmpFlashFilePath = docPath & "\flash_#.pdf"
tmpOverlayFilePath = docPath & "\overlay_#.pdf"
tmpImageOverlayFilePath = docPath & "\imageoverlay_#.pdf"
tmpAreaOverlayFilePath = docPath & "\areaoverlay_#.pdf"
tmpDataFilePath = docPath & "\" & docName & ".data"
tmpZipFilePath = docPath & "\" & docName & ".zip"
tmpImageFilePath = docPath & "\" & docName & ".jpg"
tmpOverlayDocMove = docPath & "\move_tmp.pdf"


'get proxy address
theProxy = ReadPref("Server_Proxy")


'get the url
theURL = ReadPref("Server_URL")


'get the product
theProduct = ReadPref("EzAdsPro_Product")


'get client id
clientID = ReadPref("Server_BF")


'get zip path
zipPath = ReadPref("zip_path")


'are we previewing
is_preview = ReadPref("is_preview")


'if a proxy has been set then add it to the url
if (theProxy <> "") then
	url = "-x " & theProxy & " " & theURL & "4dcgi/admin_module_upload.a4d"
else
	url = theURL & "4dcgi/admin_module_upload.a4d"
end if



'test version has been set
if (theVersion <> "") then

	'get application object
	Set myInDesign = CreateObject("InDesign.Application." & theVersion)

	
	'test for active document
	If myInDesign.Documents.Count <> 0 Then	
		
		'set error flag
		vbUploaded = false
		
		
		'Save the document
		if (theVersion = "4") then
			myInDesign.ActiveDocument.Save, false, "", true
		else
			myInDesign.ActiveDocument.Save
		end if
		
		
		'get the saved document path
		tmpDocFilePath = myInDesign.ActiveDocument.FullName
		tmpIDMLFilePath = replace(tmpDocFilePath,".indd",".idml")
		
		
		'Clear out tmp file
		DeleteTmpFile tmpFilePath
		
		'Clear out data file
		DeleteTmpFile tmpDataFilePath
		
		'Clear out preview
		DeleteTmpFile tmpImageFilePath			
		
		'Clear out zip file
		DeleteTmpFile tmpZipFilePath
		
		'Clear tmp pdf
		DeleteTmpFile tmpOverlayDocMove
		
		
		'Clear out external files
		For myCounter = 1 To 100
			imagePath = replace(tmpImageOverlayFilePath,"#", myCounter)
			areaPath = replace(tmpAreaOverlayFilePath,"#", myCounter)
			overlayPath = replace(tmpOverlayFilePath,"#", myCounter)
			multiPagePreviewPath = replace(tmpImageFilePath,".jpg", myCounter & ".jpg")
			
			DeleteTmpFile multiPagePreviewPath
			DeleteTmpFile overlayPath
			DeleteTmpFile imagePath
			DeleteTmpFile areaPath
		Next

		'clear out flashes
		For myCounter = 1 To 450
			flashPath = replace(tmpFlashFilePath,"#", myCounter)
			DeleteTmpFile flashPath
		Next
		
		
		
		'get the document name
		templateName = myInDesign.ActiveDocument.Label
		
		
		
		'test document name has been configured
		if(templateName = "") Then
			msgbox("Please configure the document name")
		else
			
			'Check the group or the category has been configured
			if(ReadPref("Server_BF") <> "") then
				theGroup = myInDesign.ActiveDocument.ExtractLabel ("category")
			else
				theGroup = myInDesign.ActiveDocument.ExtractLabel ("group")
			end if
			
			
			if(theGroup = "") AND (theGroup = "Please Select") Then
				msgbox("Please configure the group")
			else
				
				'test for duplicate template
				if(is_preview = "1")then
					continueOn = true
				else
					if ModuleExists(templateName, theGroup, clientID) then
						replaceIt = MsgBox("The template " & Chr(34) & myInDesign.ActiveDocument.Label & Chr(34) & " already exists, would you like to overwrite?", vbYesNo, "Overwrite Template")
						continueOn = (replaceIt = vbYes)
					else
						continueOn = true
					end if
				end if
				
				
				'If the modules does not exist on the server or the user has chosen to replace the module then continue on.
				if continueOn then
					

					
					'Find PDF presets
					set myPagePreset = myInDesign.PDFExportPresets(1)
					set myItemPreset = myInDesign.PDFExportPresets(1)

					For myCounter = 1 To myInDesign.PDFExportPresets.Count
						presetName = myInDesign.PDFExportPresets(myCounter)
						
						'general page presets
						if(presetName = "ProMotor Page") OR (presetName = "promotor Page") OR (presetName = "EzAdsPro Page") OR (presetName = "ezadspro page") then
							set myPagePreset = myInDesign.PDFExportPresets(myCounter)
						end if
						
						if (presetName = "ProMotor") OR (presetName = "promotor") OR (presetName = "EzAdsPro") OR (presetName = "ezadspro") then
							set myItemPreset = myInDesign.PDFExportPresets(myCounter)
						end if
					Next


					'server specific page presets
					plain_url = ReadPref("Server_URL")
					plain_url = Replace(plain_url,"https://","")
					plain_url = Replace(plain_url,"http://","")
					plain_url = Replace(plain_url,".com","")
					plain_url = Replace(plain_url,".co.uk","")
					plain_url = Replace(plain_url,"/","")
					plain_url = Replace(plain_url,":","")

					cropPresetUsed = False

					For myCounter = 1 To myInDesign.PDFExportPresets.Count
						presetName = myInDesign.PDFExportPresets(myCounter)

						if(myInDesign.ActiveDocument.ExtractLabel ("forceCrop") = "true")then
							if(presetName = plain_url & " Page Crop") or (presetName = plain_url & " page crop")then
								set myPagePreset = myInDesign.PDFExportPresets(myCounter)
								set myItemPreset = myInDesign.PDFExportPresets(myCounter)
								cropPresetUsed = True
							end if
						else
							if(presetName = plain_url & " Page") or (presetName = plain_url & " page")then
								set myPagePreset = myInDesign.PDFExportPresets(myCounter)
							end if
							
							if(presetName = plain_url)then
								set myItemPreset = myInDesign.PDFExportPresets(myCounter)
							end if
						end if
					Next



					if(myInDesign.ActiveDocument.ExtractLabel ("forceCrop") = "true")then
						if(cropPresetUsed)then
							'all ok then
						else
							msgbox("'Force Crop PDF Preset' selected but not found")
						end if
					end if
					
					
					'to stop templates being uploaded with the wrong presets.
					if(theURL = "http://savills.ezadspro.co.uk/")then
						msgbox("Uploading using:" & chr(13) & chr(13) & "Page = " & myPagePreset.name & chr(13) & "Item = " & myItemPreset.name)
					end if


					'show all elems pref
					if(ReadPref("nonprint") = "true")then
						For myPageCount = 1 To myInDesign.ActiveDocument.Pages.Count
							set allElems = myInDesign.ActiveDocument.Pages(CInt(myPageCount)).PageItems

							For myElemCounter = 1 To allElems.Count
								set currentElem = allElems(myElemCounter)

								currentElem.Nonprinting = false
							Next
						Next
					end if


					'Export IDML
					if(is_preview = "")then
						if(ReadPref("Server_URL") <> "https://ukdev.ezadspro.co.uk/")then
							myInDesign.ActiveDocument.export 1768189292, tmpIDMLFilePath
						end if
					end if
					
					
					'Export jpeg preview
					if((ReadPref("ID_Version") = "CS2") OR (ReadPref("ID_Version") = "CS4"))then
						myInDesign.ActiveDocument.Export "JPEG", tmpImageFilePath, JPEGQuality=1701727351
					else
						myInDesign.JPEGExportPreferences.exportResolution = 120
						myInDesign.ActiveDocument.Export "JPEG", tmpImageFilePath, JPEGQuality=1701727351
					end if
					
					
					'Collect variable data from document
					collectVariableData myInDesign, tmpDataFilePath, myItemPreset
					
					
					


					'create image and area overlays
					set allPages = myInDesign.ActiveDocument.Pages

					if((ReadPref("Server_URL") = "http://ezp.dyndns.biz/") OR (ReadPref("Server_URL") = "http://savills.ezadspro.co.uk/")  OR (ReadPref("Server_URL") = "https://savills.ezadspro.co.uk/") OR (ReadPref("Server_URL") = "https://ukdev.ezadspro.co.uk/"))then
						'disable overlays for new Savills designs
					else
						For myPageCount = 1 To allPages.Count
							set allElems = myInDesign.ActiveDocument.Pages(CInt(myPageCount)).PageItems

							For myElemCounter = 1 To allElems.Count
								set currentElem = allElems(myElemCounter)

								if(currentElem.ExtractLabel ("type") = "image")then
									element_overlay myInDesign, allElems, currentElem, tmpImageOverlayFilePath
								end if

								if(currentElem.ExtractLabel ("type") = "area")then
									element_overlay myInDesign, allElems, currentElem, tmpAreaOverlayFilePath
								end if	
							Next
						Next
					end if

					

					'capture all elements
					set allElems = myInDesign.ActiveDocument.PageItems
					

					'Clear out text
					For myCounter = 1 To allElems.Count
						if ((allElems(myCounter).ExtractLabel ("type") = "text") OR (allElems(myCounter).ExtractLabel ("type") = "list")) then
							if (TypeName(allElems(myCounter)) = "TextFrame") then
								For myClearCounter = 1 To 50
									allElems(myCounter).Contents = ""
								Next
							end if
						end if	


						'clear tmp text elements from font errors
						if(TypeName(allElems(myCounter)) = "TextFrame")then
							if(allElems(myCounter).Contents = "a")then
								errorPos = allElems(myCounter).GeometricBounds
								
								if((errorPos(0) = 0) AND (errorPos(1) = 0))then
									allElems(myCounter).delete
								end if
							end if
						end if	
					Next				
					
					
					'Hide all the elements
					For myCounter = 1 To allElems.Count
						allElems(myCounter).Nonprinting = true
					Next
					
					
					'Clear out flashes
					For myCounter = 1 To allElems.Count
						if (allElems(myCounter).ExtractLabel ("type") = "flash") then
							if(TypeName(allElems(myCounter)) = "TextFrame")then
								'only clear out the text if the flash is variable
								if(allElems(myCounter).ExtractLabel("blind") = "true")then
									'do nothing
								else
									allElems(myCounter).contents = ""
								end if
								
								'show the flash
								allElems(myCounter).Nonprinting = false
							else
								
								'show the flash
								allElems(myCounter).Nonprinting = false
								
								'Remove the flash text
								if(allElems(myCounter).ExtractLabel("blind") = "true")then
									'do nothing
								else
									set allFlashElems = allElems(myCounter).PageItems
									
									For flashElems = 1 To allFlashElems.Count
										if (TypeName(allFlashElems(flashElems)) = "TextFrame") then
											allFlashElems(flashElems).Contents = ""
										end if
									Next
								end if
							end if
							
							'dont display the pdf after exporting
							myInDesign.PDFExportPreferences.ViewPDF=false
							
							'Export flash
							myInDesign.ActiveDocument.Export "Adobe PDF", replace(tmpFlashFilePath,"#", allElems(myCounter).ExtractLabel ("sort")), false, myItemPreset
							
							'hide the flash after we have exported it
							allElems(myCounter).Nonprinting = true
						end if
					Next
					
					
					
					
					'Hide the flashes and overlays, show everything else.
					For myCounter = 1 To allElems.Count
						theElemType = allElems(myCounter).ExtractLabel ("type")
						
						if ((theElemType = "flash") OR (theElemType = "overlay") OR (theElemType = "generic")) then
							allElems(myCounter).Nonprinting = true
						else
							allElems(myCounter).Nonprinting = false
						end if
					Next
					
					
					
					'Dont display the PDF and export all pages.
					myInDesign.PDFExportPreferences.ViewPDF=false
					myInDesign.PDFExportPreferences.PageRange=1886547553
					
					
					'Export PDF
					if(is_backing(myInDesign)) AND (InStr(templateName, "Container") = 0) AND (InStr(templateName, "container") = 0)then
						myInDesign.ActiveDocument.Export "Adobe PDF", tmpFilePath, false, myPagePreset
					else
						myInDesign.ActiveDocument.Export "Adobe PDF", tmpFilePath, false, myItemPreset
					end if
					
					
					
					'hide all
					For myCounter = 1 To allElems.Count
						allElems(myCounter).Nonprinting = true
					Next	
					
					
					'export overlays
					set allElems = myInDesign.ActiveDocument.PageItems
					
					For myCounter = 1 To allElems.Count
						if (allElems(myCounter).ExtractLabel ("type") = "overlay") then
							'capture document units
							userUnitsHoriz = myInDesign.ActiveDocument.viewPreferences.HorizontalMeasurementUnits
							userUnitsVert = myInDesign.ActiveDocument.viewPreferences.VerticalMeasurementUnits
							
							
							'capture overlay size
							overlayPos = allElems(myCounter).GeometricBounds
							
							
							'capture page size
							pageWidth = myInDesign.ActiveDocument.documentPreferences.PageWidth
							pageHeight = myInDesign.ActiveDocument.documentPreferences.PageHeight
							
							
							'show overlay
							allElems(myCounter).Nonprinting = false
							
							
							'export page as pdf
							myInDesign.PDFExportPreferences.ViewPDF=false
							myInDesign.ActiveDocument.Export "Adobe PDF", tmpOverlayDocMove, false, myItemPreset
							
							
							'create new page
							myInDesign.Documents.Add
							
							'set the units
							myInDesign.ActiveDocument.viewPreferences.HorizontalMeasurementUnits = userUnitsHoriz
							myInDesign.ActiveDocument.viewPreferences.VerticalMeasurementUnits = userUnitsVert
							
							
							'set margins
							myInDesign.ActiveDocument.MarginPreferences.Bottom = 0
							myInDesign.ActiveDocument.MarginPreferences.Left = 0
							myInDesign.ActiveDocument.MarginPreferences.Right = 0
							myInDesign.ActiveDocument.MarginPreferences.Top = 0
							myInDesign.ActiveDocument.Pages(1).MarginPreferences.Bottom = 0
							myInDesign.ActiveDocument.Pages(1).MarginPreferences.Left = 0
							myInDesign.ActiveDocument.Pages(1).MarginPreferences.Right = 0
							myInDesign.ActiveDocument.Pages(1).MarginPreferences.Top = 0
							
							For masterCounter = 1 To myInDesign.ActiveDocument.MasterSpreads.Count
								set masterSpread = myInDesign.ActiveDocument.MasterSpreads.Item(masterCounter)
								
								For masterPageCounter = 1 To masterSpread.Pages.Count
									set masterPage = masterSpread.Pages.Item(masterPageCounter)
									masterPage.MarginPreferences.Bottom = 0
									masterPage.MarginPreferences.Left = 0
									masterPage.MarginPreferences.Right = 0
									masterPage.MarginPreferences.Top = 0
								Next
							Next
							
							'turn off facing pages
							myInDesign.ActiveDocument.DocumentPreferences.FacingPages = false
							
							
							'set width/height
							theWidth = overlayPos(3) - overlayPos(1)
							theHeight = overlayPos(2) - overlayPos(0)
							
							
							'set page width/height
							myInDesign.ActiveDocument.documentPreferences.PageWidth = theWidth
							myInDesign.ActiveDocument.documentPreferences.PageHeight = theHeight
							
							
							'create a rectangle to import ther image into
							Set myOverlayBox = myInDesign.ActiveDocument.Rectangles.Add
							
							
							'set border to 0
							myOverlayBox.StrokeWeight = 0
							
							'change pasteboard size (or we error)
							if(theVersion = "5") OR (theVersion = "5.5")then
								setSize=Array((overlayPos(2) * 100), (overlayPos(2) * 100))
								myInDesign.ActiveDocument.pasteboardPreferences.pasteboardMargins = setSize
							else
								myInDesign.ActiveDocument.PasteboardPreferences.MinimumSpaceAboveAndBelow = (overlayPos(2) * 100)
							end if
							
							'work out positions
							topPos = -overlayPos(0)
							leftPos = -overlayPos(1)
							bottomPos = (pageHeight - overlayPos(0))
							rightPos= (pageWidth - overlayPos(1))
							
							
							'create position array
							setSize=Array(topPos, leftPos, bottomPos, rightPos)
							
							
							'set size and position
							myOverlayBox.GeometricBounds = setSize
							
							
							'import graphic
							myOverlayBox.Place tmpOverlayDocMove, false
							
							
							'fit image to the box
							if(theVersion = "4") then
								myOverlayBox.Fit idFitOptions.idContentToFrame
							else
								setSize=Array(0, 0, (overlayPos(2) - overlayPos(0)) , (overlayPos(3) - overlayPos(1)))
								
								myOverlayBox.GeometricBounds = setSize
								myOverlayBox.Fit idFitOptions.idCenterContent
								myOverlayBox.Fit idFitOptions.idContentToFrame
							end if
							
							'Export overlay PDF
							myInDesign.ActiveDocument.Export "Adobe PDF", replace(tmpOverlayFilePath,"#", allElems(myCounter).ExtractLabel ("sort")), false, myItemPreset
							
							'hide the overlay
							allElems(myCounter).Nonprinting = true
							
							'Close the overlay document without saving
							myInDesign.ActiveDocument.close idSaveOptions.idNo
						end if
					Next
					
					
					
					'Close the document without saving
					'myInDesign.ActiveDocument.close idSaveOptions.idNo
					myInDesign.ActiveDocument.close 1852776480
					
					
					'open the document back up again
					myInDesign.open tmpDocFilePath

					
					'check all the essentials have been created
					If checkFileExists(tmpFilePath) Then
						If checkFileExists(tmpDataFilePath) Then
							If checkFileExists(tmpImageFilePath) Then
								If checkFileExists(tmpDocFilePath) Then
									
									'layers warning
									layerCount = myInDesign.ActiveDocument.layers.count
									if(layerCount > 1)then
										msgbox("This document uses multiple layers, this may cause an ordering problem.")
									end if

									
									'check for unique sorts
									if(checkUniqueSorts(myInDesign))then
										
										'collect fonts for upload
										if(is_preview = "1")then
											allFontLocations = Array()
										else
											allFontLocations = collectFonts(myInDesign)
										end if
										
										'Gather linked files
										if((myInDesign.ActiveDocument.ExtractLabel ("dontLink") = "true") OR (is_preview = "1"))then
											allLinks = Array()
										else
											allLinks = collectLinked(myInDesign)
										end if
										
										
										'Check for missing links
										linksMissing = false
										For Each currentLink In allLinks
											if(currentLink <> "")then
												if(checkFileExists(currentLink)) then
													'all ok
												else
													linksMissing = true
												end if
											end if
										Next
										
										if(linksMissing)then
											if(InStr(1,theURL,"NPP",1) <> 0)then
												'always fail for NPP
												msgbox("This template contains missing media links.")
												linkContinue = false
											else
												continueWithMissing = MsgBox("This template contains missing media links, would you like to continue with the upload?", vbYesNo, "Missing media links")
												linkContinue = (continueWithMissing = vbYes)
											end if
										else
											linkContinue = true
										end if
										
										if(linkContinue)then
											'Zip contents
											CreateZipFile tmpZipFilePath, tmpFilePath, tmpDataFilePath, tmpImageFilePath, tmpDocFilePath, tmpFlashFilePath, tmpOverlayFilePath, allLinks, allFontLocations, tmpImageOverlayFilePath, tmpAreaOverlayFilePath, tmpIDMLFilePath, zipPath
											

											if(InStr(1,templateName,"filler",1) <> 0)then
												displayWarning = false
												set allElems = myInDesign.ActiveDocument.PageItems
												for myCounter = 1 To allElems.Count
													if (allElems(myCounter).ExtractLabel ("type") = "image") then
														displayWarning = true
													end if
												next

												if(displayWarning)then
													msgbox("The filler you are uploading contains configured image elements.")
												end if
											end if

											If checkFileExists(tmpZipFilePath) Then
												'Upload PDF
												theResult = PostFile (url, tmpZipFilePath)	
												

												if(InStr(theResult, "Imported") <> 0) or (InStr(theResult, "finished: OK") <> 0) and (false) then
													vbUploaded = true	
												else
													if(theURL = "http://127.0.0.1/ezadspro/") then
														msgbox("Error: " & VBCR & Replace(theResult, "<BR>", VBCR))
													else
														msgbox("Error: " & theResult)
													end if
												end if
											else
												MsgBox ("Error: Cannot create zip file")
											end if
										end if
									end if
								else
									MsgBox ("Error: Cannot save InDesign document")
								end if
							else
								MsgBox ("Error: Cannot export preview")
							end if
						else
							MsgBox ("Error: Cannot create data file")
						End if
					else
						MsgBox ("Error: Cannot create PDF file")
					End if
				End if
			End If
		End if
		
		if vbUploaded then
			if(is_preview = "")then
				MsgBox ("Your upload was successful")
			end if
		end if
	Else
		MsgBox ("Please open a document.")
	End If
else
	MsgBox ("Please configure your scripts.")
end if


Function is_backing(myInDesign)
	result = false
	
	set allPages = myInDesign.ActiveDocument.Pages

	For myPageCount = 1 To allPages.Count
				
		set allElems = myInDesign.ActiveDocument.Pages(CInt(myPageCount)).PageItems

		For myCounter = 1 To allElems.Count
			set currentElem = allElems(myCounter)
			
			if (currentElem.ExtractLabel ("type") = "area") then
				result = true
			end if
		Next
	Next
	
	is_backing = result
End function


Function checkUniqueSorts(myInDesign)
	
	errorMsg = ""
	
	set allElems = myInDesign.ActiveDocument.PageItems
	for myCounter = 1 To allElems.Count
		if(allElems(myCounter).ExtractLabel ("type") = "image") then
			currentSort = allElems(myCounter).ExtractLabel ("sort")
			currentID = allElems(myCounter).ID
			
			set allElems2 = myInDesign.ActiveDocument.PageItems
			for myCounter2 = 1 To allElems2.Count
				if(allElems2(myCounter2).ExtractLabel ("type") = "image") then
					newSort = allElems(myCounter2).ExtractLabel ("sort")
					newID = allElems(myCounter2).ID
					
					if((currentSort = newSort) AND (currentID <> newID))then
						errorMsg = "Multiple images share sort " & newSort
					end if
				end if
			next
		end if
		
		if(allElems(myCounter).ExtractLabel ("type") = "area") then
			currentAreaSort = allElems(myCounter).ExtractLabel ("sort")
			currentAreaID = allElems(myCounter).ID
			
			set allElems2 = myInDesign.ActiveDocument.PageItems
			for myCounter2 = 1 To allElems2.Count
				if(allElems2(myCounter2).ExtractLabel ("type") = "area") then
					newAreaSort = allElems(myCounter2).ExtractLabel ("sort")
					newAreaID = allElems(myCounter2).ID
					
					if((currentAreaSort = newAreaSort) AND (currentAreaID <> newAreaID))then
						errorMsg = "Multiple areas share sort " & newAreaSort
					end if
				end if
			next
		end if
	next
	
	if(errorMsg = "")then
		checkUniqueSorts = true
	else
		msgbox(errorMsg)
		checkUniqueSorts = false
	end if
End Function


Function collectFonts(myInDesign)
	dim allFonts(50)
	arrayCount = 0
	
	For myCounter = 1 To myInDesign.ActiveDocument.Fonts.Count
		
		on error resume next
		'add main font file
		fontName = LCase(myInDesign.ActiveDocument.Fonts(myCounter).name)

		'if we error then we have not got the font on the local machine
		if err.number = 0 then

			if(InStr(1, fontName, "gf1")) OR (InStr(1, fontName, "gf2")) OR (InStr(1, fontName, "gf3")) OR (InStr(1, fontName, "gf4")) OR (InStr(1, fontName, "gf5")) OR (InStr(1, fontName, "gf6")) OR (InStr(1, fontName, "gf7")) OR (InStr(1, fontName, "gf8")) OR (InStr(1, fontName, "gf9")) OR (InStr(1, fontName, "gf10")) OR (InStr(1, fontName, "primary")) OR (InStr(1, fontName, "secondary")) OR (InStr(1, fontName, "tertiary")) OR (InStr(1, fontName, "quaternary")) then
				'ignore generic fonts
			else
				'increment array count
				arrayCount = arrayCount +1

				allFonts(arrayCount) = myInDesign.ActiveDocument.Fonts(myCounter).Location
			end if


			if(InStr(1, fontName, "gf1")) OR (InStr(1, fontName, "gf2")) OR (InStr(1, fontName, "gf3")) OR (InStr(1, fontName, "gf4")) OR (InStr(1, fontName, "gf5")) OR (InStr(1, fontName, "gf6")) OR (InStr(1, fontName, "gf7")) OR (InStr(1, fontName, "gf8")) OR (InStr(1, fontName, "gf9")) OR (InStr(1, fontName, "gf10")) OR (InStr(1, fontName, "primary")) OR (InStr(1, fontName, "secondary")) OR (InStr(1, fontName, "tertiary")) OR (InStr(1, fontName, "quaternary")) then
				'ignore generic fonts
			else
				newFontPath = replace(myInDesign.ActiveDocument.Fonts(myCounter).Location,".pfb", ".afm", 1, -1, 1)
				If checkFileExists(newFontPath) Then
					'increment array count
					arrayCount = arrayCount +1
					
					allFonts(arrayCount) = newFontPath
				end if
				
				newFontPath = replace(myInDesign.ActiveDocument.Fonts(myCounter).Location,".pfb", ".pfm", 1, -1, 1)	
				If checkFileExists(newFontPath) Then
					'increment array count
					arrayCount = arrayCount +1
					
					allFonts(arrayCount) = newFontPath
				end if	
			end if
		end if
	Next


	
	set charStyles = myInDesign.ActiveDocument.CharacterStyles
	
	For myStyleCounter = 1 To charStyles.Count
		set currentStyle = charStyles(myStyleCounter)
		
		if(currentStyle.Name <> "[None]") then
			tmpLocation = returnStyleFullPathFontFace(currentStyle)

			if(tmpLocation <> "")then
				'increment array count
				arrayCount = arrayCount +1
				
				allFonts(arrayCount) = tmpLocation
			end if
		end if
	Next
	
	collectFonts = allFonts
End Function


Function collectLinked(myInDesign)
	dim allLinks(150)
	
	For myCounter = 1 To myInDesign.ActiveDocument.Links.Count
		thePath = myInDesign.ActiveDocument.Links(myCounter).FilePath

		'add link to array
		allLinks(myCounter) = thePath

		tmpSize = getFileSize(thePath)
		if(tmpSize > 2048)then
			tmpSize = Round(tmpSize / 1024, 2)
			msgbox("The file " & thePath & " is quite large: " & CStr(tmpSize) & "mb")
		end if
	Next
	
	collectLinked = allLinks
End Function


Function getFileSize(path)
	SET objFSO = CREATEOBJECT("Scripting.FileSystemObject")
	
	If objFSO.FileExists(path) Then
		SET objFile = objFSO.GetFile(path)
		theSize = objFile.Size / 1024
	else
		theSize = 0
	end if


	getFileSize = theSize
End Function


Function ReadPref(theKey)
	Dim wsh
	Dim returnMe
	Set wsh = CreateObject("WScript.Shell")
	
	On Error Resume Next
		returnMe = wsh.RegRead(pP2PrefsRegistryKey & theKey)
	On Error Goto 0
	
	ReadPref = returnMe
End Function


Sub DeleteTmpFile(filePathToDelete)
	dim filesys
	
	Set filesys = CreateObject("Scripting.FileSystemObject")
	filesys.CreateTextFile filePathToDelete, True 
	If filesys.FileExists(filePathToDelete) Then
	   filesys.DeleteFile filePathToDelete 
	End If 
End Sub


Function ModuleExists(theModule, groupName, clientID)
	Dim siteText, theURL, returnMe

	theModule = replace(theModule,"&", "2amp2", 1, -1, 1)
	theModule = replace(theModule,"-", "2hyph2", 1, -1, 1)	
	
	theURL = ReadPref("Server_URL")
	siteText = PostForm(theURL & "4dcgi/u_check_module_exists.a4d", "iName=""" & theModule & """")
	
	If Len(siteText) >= 3 Then
		returnMe = (UCase(Left(siteText,3)) = "YES")
	else
		returnMe = False
	End If
	
	ModuleExists = returnMe
End Function



Function PostForm(ByRef url, ByRef formData)
	Dim returnMe, formText, commandLine
	
	returnMe = ""

	If IsArray(formData) Then
		formText = MakeFormText(formData)
	Else
		formText = formData
	End If

	commandLine = "-F " & formText & " " & url	
	
	returnMe = CURL(commandLine)

	PostForm = returnMe
End Function




Function CURL(ByVal commandLine)
	Dim returnMe
	Dim errMsg
	Dim WshShell, curlExec, i
	
	returnMe = ""
	theProxy = ReadPref("Server_Proxy")
	
	if theProxy <> "" then
		commandLine = "-x " & theProxy & " " & commandLine
	end if
	
	commandLine = "curl " & commandLine
	Set WshShell = CreateObject("WScript.Shell")
	
	On Error Resume Next
	Set curlExec = WshShell.Exec(commandLine)


	errMsg = Err.Description
	On Error Goto 0
	
	If IsObject(curlExec) Then
		Dim timeLeft

		'test exec output error
		'msgbox(curlExec.StdErr.ReadAll)
		
		'Time left in seconds
		timeLeft = 240
		Do While (curlExec.Status = 0) And (timeLeft > 0)
			SillySleep(1)
			timeLeft = timeLeft - 1
		Loop

		If (timeLeft > 0) Then
			If (curlExec.ExitCode = 0) Then
				returnMe = curlExec.StdOut.ReadAll
			Else
				Dim errNum, errText
				errText = curlExec.StdOut.ReadAll
				errNum = curlExec.ExitCode
				returnMe = errText
			End If
		Else
			curlExec.Terminate
		End If
	Else
		msgbox("Unable to find curl.exe")
	End If
	
	CURL = returnMe
End Function



Sub SillySleep(ByRef seconds)
	'Dim WshShell, commandLine
	'Set WshShell = CreateObject("Wscript.Shell")
	'commandLine = "%COMSPEC% /c ping -n " & 1 + seconds & " 127.0.0.1>nul"
	'Call WshShell.Run(commandLine, 0, 1)

	dteWait = DateAdd("s", seconds, Now())
	Do Until (Now() > dteWait)
	Loop
End Sub


Sub CreateZipFile(ByRef zipFullPath, ByRef docPath, ByRef docData, ByRef docPreview, ByRef tmpDocFilePath, ByRef tmpFlashPath, ByRef tmpOverlayPath, ByRef allLinks, ByRef fontLocations, ByRef ImageOverlay, ByRef AreaOverlay, tmpIDMLFilePath, zipPath)
	
	Dim arrayFiles
	arrayFiles = Array("")

	Set objFSO=CreateObject("Scripting.FileSystemObject")


	if(zipPath = "") then
		zipCommand = "zip -j " & chr(34) & zipFullPath & chr(34) & " "
	else
		zipCommand = chr(34) & zipPath & chr(34) & " -j " & chr(34) & zipFullPath & chr(34) & " "
	end if
	

	zipCommand = addToZip(zipCommand, docPath, arrayFiles)
	zipCommand = addToZip(zipCommand, docData, arrayFiles)
	zipCommand = addToZip(zipCommand, docPreview, arrayFiles)
	zipCommand = addToZip(zipCommand, tmpDocFilePath, arrayFiles)
	zipCommand = addToZip(zipCommand, tmpIDMLFilePath, arrayFiles)
		
		
	'Multi page doc
	set allPages = myInDesign.ActiveDocument.Pages
	For myPageCount = 2 To allPages.Count
		thePath = replace(docPreview,".jpg",cStr(myPageCount) + ".jpg")
		zipCommand = addToZip(zipCommand, thePath, arrayFiles)
	Next

	
	'Include flashes
	if((ReadPref("Server_URL") = "http://ezp.dyndns.biz/") OR (ReadPref("Server_URL") = "http://savills.ezadspro.co.uk/") OR (ReadPref("Server_URL") = "https://savills.ezadspro.co.uk/") OR (ReadPref("Server_URL") = "https://ukdev.ezadspro.co.uk/"))then
		max_flash_count = 450
	else
		max_flash_count = 57
	end if

	For flashLoop = 1 To max_flash_count
		thePath = replace(tmpFlashPath,"#",cStr(flashLoop))
		
		if(checkFileExists(thePath)) then
			zipCommand = addToZip(zipCommand, thePath, arrayFiles)
		end if
	Next
		
		
	'include image overlays
	failCount = 0
	For overlayLoop = 1 To 50
		thePath = replace(ImageOverlay,"#",cStr(overlayLoop))
		
		if(checkFileExists(thePath)) then
			zipCommand = addToZip(zipCommand, thePath, arrayFiles)
		else
			failCount = failCount + 1
		end if

		If failCount=3 Then Exit For
	Next
		
		
	'include area overlays
	failCount = 0
	For overlayLoop = 1 To 50
		thePath = replace(AreaOverlay,"#",cStr(overlayLoop))
		
		if(checkFileExists(thePath)) then
			zipCommand = addToZip(zipCommand, thePath, arrayFiles)
		else
			failCount = failCount + 1
		end if

		If failCount=3 Then Exit For
	Next
		
		
	'Include overlays
	failCount = 0
	For overlayLoop = 1 To 50
		thePath = replace(tmpOverlayPath,"#",cStr(overlayLoop))
		
		if(checkFileExists(thePath)) then
			zipCommand = addToZip(zipCommand, thePath, arrayFiles)
		else
			failCount = failCount + 1
		end if
		
		If failCount=3 Then Exit For
	Next
		
		
	'Include linked files
	For Each currentLink In allLinks
		zipCommand = addToZip(zipCommand, currentLink, arrayFiles)
	Next

		
	'Include fonts
	For fontLoop = 1 To (UBOUND(fontLocations))
		if(fontLocations(fontLoop) <> "")then
			if(InStr(fontLocations(fontLoop), "Windows") = 0)then
				zipCommand = addToZip(zipCommand, fontLocations(fontLoop), arrayFiles)
			end if
		end if
	Next


	'bat path
	batPath = replace(zipFullPath,".zip",".bat")

	'Delete bat file
	DeleteTmpFile batPath	

	
	Set objFile = objFSO.CreateTextFile(batPath,True)
	objFile.Write zipCommand
	objFile.Close

	Set WshShell = CreateObject("WScript.Shell")
	WshShell.Run chr(34) & batPath & Chr(34), 1, true
	Set WshShell = Nothing
End Sub


Function addToZip(zipCommand, theFile, arrayFiles)
	if(theFile <> "") then
		if(checkFileExists(theFile)) then
			Set objFSO = CreateObject("Scripting.FileSystemObject")
			Set objFile = objFSO.GetFile(theFile)
			theName = objFSO.GetFileName(objFile)

			fileFound = findInArrayExact(arrayFiles, theName)

			if(fileFound = -1)then
				newSize = Ubound(arrayFiles) + 1
				ReDim Preserve arrayFiles(newSize)
				arrayFiles(newSize)=theName

				'escape chars
				'theFile = Replace(theFile,"[","\[")
				'theFile = Replace(theFile,"]","\]")

				zipCommand = zipCommand & chr(34) & theFile & chr(34) & " "
			end if
		end if
	end if

	addToZip = zipCommand
End Function


Function findInArrayExact(options, choice)
	thePos = -1

	For j=Lbound(options) to Ubound(options)
	    If(options(j) = choice) Then
	        thePos = j
	    End If
	Next

	findInArrayExact = thePos
End Function


Function Slashify(someString)
	Dim returnMe
	returnMe = someString
	
	If Right(returnMe, 1) <> "\" Then returnMe = returnMe & "\"
	
	Slashify = returnMe
End Function



function getBounds (theElem)	
	
	if(TypeName(theElem)="Group")then
		'groups do not have strokes
		borderAdjustment=0
	else
		select case theElem.StrokeAlignment
			case "1936998723"
				'stroke to the center
				borderAdjustment = (theElem.StrokeWeight / 2)
			case "1936998735"
				'stroke to the outside
				borderAdjustment = 0	
			case "1936998729"
				'stroke to the inside
				borderAdjustment = theElem.StrokeWeight	
			case else
				borderAdjustment = 0	
		end select
	end if
	

	'border fix, explains rounded arcing problem!
	if (TypeName(theElem) = "TextFrame") then
		
		on error resume next
		insetData = theElem.textFramePreferences.InsetSpacing
		
		if err.number <> 0 then
			insetTop = 0
			insetLeft = 0
			insetBottom = 0
			insetRight = 0
		else
			insetTop = insetData(0)
			insetLeft = insetData(1)
			insetBottom = insetData(2)
			insetRight = insetData(3)
		end if
	else
		insetTop = 0
		insetLeft = 0
		insetBottom = 0
		insetRight = 0
	end if
	
	
	if (theElem.RotationAngle = 0) then
		getBounds = (theElem.GeometricBounds(0) + borderAdjustment + insetTop) & "," & (theElem.GeometricBounds(1) + borderAdjustment + insetLeft) & "," & (theElem.GeometricBounds(2) - borderAdjustment - insetBottom) & "," & (theElem.GeometricBounds(3) - borderAdjustment - insetRight)
	else
		'get the rotation angle and set it to 0
		theRotationAngle = theElem.RotationAngle
		theElem.RotationAngle = 0
		
		getBounds = (theElem.GeometricBounds(0) + borderAdjustment + insetTop) & "," & (theElem.GeometricBounds(1) + borderAdjustment + insetLeft) & "," & (theElem.GeometricBounds(2) - borderAdjustment - insetBottom) & "," & (theElem.GeometricBounds(3) - borderAdjustment - insetRight)
		
		'set the angle to its original value
		theElem.RotationAngle = theRotationAngle
	end if
end function


function returnVerticalJustification (currentJustification, verticalOverride)
	dim returnVal
	
	select case currentJustification
		case "1953460256"
	 		returnVal = "top"
	 	case "1667591796"
	   		returnVal = "center"
	 	case "1651471469"
	   		returnVal = "bottom"
	 	case "1785951334"
	   		returnVal = "justify"
	 	case Else
	 		returnVal = "top"
	end select
	
	
	'vertical override from scripts
	if(verticalOverride <> "") and (verticalOverride <> "None")then
		if(verticalOverride = "Centre")then
			returnVal = "center"
		else
			returnVal = LCase(verticalOverride)
		end if
	end if
	
	returnVerticalJustification = returnVal
end function


function returnHorizontalJustification (currentJustification)
	
	select case currentJustification
		case "1818584692"
	 		returnVal = "left"
	 	case "1919379572"
	   		returnVal = "right"
	 	case "1667591796"
	   		returnVal = "center"
	 	case "1630691955"
	   		returnVal = "justify"			
	 	case "1718971500"
	   		returnVal = "justify"
	 	case "1667920756"
	   		returnVal = "justify"	
	 	case "1919578996"
	   		returnVal = "justify"	
	 	case "1818915700"
	   		returnVal = "justify"		
	 	case Else
	 		returnVal = "left"
	end select
	
	returnHorizontalJustification = returnVal
end function


function returnLastLineAlign (currentElem, currentJustification)	
	select case currentJustification
		case "1818584692"
			if(ReadPref("ID_Version") = "2")then
				returnVal = ""
			else
				returnVal = "left"
			end if
	 	case "1919379572"
	   		returnVal = "right"
	 	case "1667591796"
	   		returnVal = "center"
	 	case "1630691955"
	   		returnVal = "justify"			
	 	case "1718971500"
	   		returnVal = "justify"
	 	case "1667920756"
			returnVal = "center"
	 	case "1919578996"
	   		returnVal = "right"	
	 	case "1818915700"
	   		returnVal = "left"		
	 	case Else
	 		returnVal = ""
	end select


	'justification may be different
	theJustification = currentElem.characters(1).Justification

	For charLoop = 1 To currentElem.characters.count
		if(theJustification <> currentElem.characters(charLoop).Justification) then
			returnVal = "auto"
		end if
	Next
	
	returnLastLineAlign = returnVal
end function


function returnFontFace (currentElem)
	on error resume next
	
	returnVal = currentElem.characters(1).AppliedFont.Location
	
	if err.number <> 0 then 
		returnVal = "font error"
		msgbox("Missing Font Error")
	else
		vlPos = InStrRev(returnVal,"\") + 1
		returnVal = Mid(returnVal,vlPos)
	end if
	
	returnFontFace = returnVal
end function


function returnFontFace2 (currentElem)	
	on error resume next
	
	returnVal = currentElem.characters(1).AppliedFont.PostScriptName
	
	if err.number <> 0 then 
		returnVal = "font error"
	end if
	
	returnFontFace2 = returnVal
end function


function returnFontFace3 (currentElem)	
	on error resume next
	
	returnVal = replace(currentElem.characters(1).AppliedFont.Name, chr(9)," ")
	
	if err.number <> 0 then 
		returnVal = "font error"
	end if
	
	returnFontFace3 = returnVal
end function


function returnStyleFontFace (currentStyle)
	returnVal = ""
	
	if(currentStyle.AppliedFont <> "")then
		Set myTextFrame = myInDesign.ActiveDocument.TextFrames.Add
		
		'Fix for wrap round breaking the box
		theWidth = myInDesign.ActiveDocument.documentPreferences.PageWidth
		theHeight = myInDesign.ActiveDocument.documentPreferences.PageHeight
		
		setSize=Array(0,0,theHeight,theWidth)
		myTextFrame.GeometricBounds = setSize

		'disable text wrap because this might stop us placing a character
		theVersion = ReadPref("ID_Version")
		if (theVersion = "4") OR (theVersion = "5") OR (theVersion = "5.5") OR (theVersion = "6") OR (theVersion = "2020") OR (theVersion = "2021") OR (theVersion = "2022") OR (theVersion = "2023") OR (theVersion = "2024") OR (InStr(UCase(theVersion),"CC") > 0) then
			myTextFrame.textWrapPreferences.TextWrapMode = 1651729523
		else
			myTextFrame.textWrapPreferences.TextWrapType = 1651729523
		end if
		
		myTextFrame.Contents = "a"
		
		on error resume next
		myTextFrame.characters(1).AppliedCharacterStyle = currentStyle

		if err.number = 0 then 
			'if we error then we do not have the font on the local machine
			on error resume next
			returnVal = myTextFrame.characters(1).AppliedFont.Location
			
			if err.number = 0 then 
				vlPos = InStrRev(returnVal,"\") + 1
				returnVal = Mid(returnVal,vlPos)
			end if
		end if
		
		
		'delete the new frame
		myTextFrame.delete
	end if
	
	returnStyleFontFace = returnVal
end function



function returnStyleFullPathFontFace (currentStyle)
	returnVal = ""
	
	if(currentStyle.AppliedFont <> "")then
		Set myTextFrame = myInDesign.ActiveDocument.TextFrames.Add
		

		'Fix for wrap round breaking the box
		theWidth = myInDesign.ActiveDocument.documentPreferences.PageWidth
		theHeight = myInDesign.ActiveDocument.documentPreferences.PageHeight
		
		setSize=Array(0,0,theHeight,theWidth)
		myTextFrame.GeometricBounds = setSize

		'disable text wrap because this might stop us placing a character
		theVersion = ReadPref("ID_Version")
		if (theVersion = "4") OR (theVersion = "5") OR (theVersion = "5.5") OR (theVersion = "6") OR (theVersion = "2020") OR (theVersion = "2021") OR (theVersion = "2022") OR (theVersion = "2023") OR (theVersion = "2024") OR (InStr(UCase(theVersion),"CC") > 0) then
			myTextFrame.textWrapPreferences.TextWrapMode = 1651729523
		else
			myTextFrame.textWrapPreferences.TextWrapType = 1651729523
		end if
		
		myTextFrame.Contents = "a"
		
		'if we error then we do not have the font in the document
		on error resume next
		myTextFrame.characters(1).AppliedCharacterStyle = currentStyle
		
		if err.number <> 0 then
			returnVal = ""
		else
			on error resume next
			fontName = LCase(myTextFrame.characters(1).AppliedFont)

			if err.number <> 0 then
				returnVal = ""
			else
				if(InStr(1, fontName, "gf1")) OR (InStr(1, fontName, "gf2")) OR (InStr(1, fontName, "gf3")) OR (InStr(1, fontName, "gf4")) OR (InStr(1, fontName, "gf5")) OR (InStr(1, fontName, "gf6")) OR (InStr(1, fontName, "gf7")) OR (InStr(1, fontName, "gf8")) OR (InStr(1, fontName, "gf9")) OR (InStr(1, fontName, "gf10")) OR (InStr(1, fontName, "primary")) OR (InStr(1, fontName, "secondary")) OR (InStr(1, fontName, "tertiary")) OR (InStr(1, fontName, "quaternary")) then
					'ignore generic fonts
					returnVal = ""
				else
					'if we error then we do not have the font on the local machine
					on error resume next
					returnVal = myTextFrame.characters(1).AppliedFont.Location
					
					if err.number <> 0 then 
						returnVal = ""
					end if
				end if
			end if
		end if
		
		
		'delete the new frame
		myTextFrame.delete
	end if
	
	returnStyleFullPathFontFace = returnVal
end function


function returnStyleFontFace2 (currentStyle)
	returnVal = ""
	
	if(currentStyle.AppliedFont <> "")then
		Set myTextFrame = myInDesign.ActiveDocument.TextFrames.Add

		'Fix for wrap round breaking the box
		theWidth = myInDesign.ActiveDocument.documentPreferences.PageWidth
		theHeight = myInDesign.ActiveDocument.documentPreferences.PageHeight
		
		setSize=Array(0,0,theHeight,theWidth)
		myTextFrame.GeometricBounds = setSize

		'disable text wrap because this might stop us placing a character
		theVersion = ReadPref("ID_Version")
		if (theVersion = "4") OR (theVersion = "5") OR (theVersion = "5.5") OR (theVersion = "6") OR (theVersion = "2020") OR (theVersion = "2021") OR (theVersion = "2022") OR (theVersion = "2023") OR (theVersion = "2024") OR (InStr(UCase(theVersion),"CC") > 0) then
			myTextFrame.textWrapPreferences.TextWrapMode = 1651729523
		else
			myTextFrame.textWrapPreferences.TextWrapType = 1651729523
		end if
		
		myTextFrame.Contents = "a"
		
		on error resume next
		myTextFrame.characters(1).AppliedCharacterStyle = currentStyle
		if err.number = 0 then 
			on error resume next
			returnVal = myTextFrame.characters(1).AppliedFont.PostScriptName
		end if
		
		myTextFrame.delete
	end if
	
	returnStyleFontFace2 = returnVal
end function


function returnStyleFontFace3 (currentStyle)
	returnVal = ""
	
	if(currentStyle.AppliedFont <> "")then
		Set myTextFrame = myInDesign.ActiveDocument.TextFrames.Add
		
		'Fix for wrap round breaking the box
		theWidth = myInDesign.ActiveDocument.documentPreferences.PageWidth
		theHeight = myInDesign.ActiveDocument.documentPreferences.PageHeight
		
		setSize=Array(0,0,theHeight,theWidth)
		myTextFrame.GeometricBounds = setSize

		'disable text wrap because this might stop us placing a character
		theVersion = ReadPref("ID_Version")
		if (theVersion = "4") OR (theVersion = "5") OR (theVersion = "5.5") OR (theVersion = "6") OR (theVersion = "2020") OR (theVersion = "2021") OR (theVersion = "2022") OR (theVersion = "2023") OR (theVersion = "2024") OR (InStr(UCase(theVersion),"CC") > 0) then
			myTextFrame.textWrapPreferences.TextWrapMode = 1651729523
		else
			myTextFrame.textWrapPreferences.TextWrapType = 1651729523
		end if
		
		myTextFrame.Contents = "a"
		
		on error resume next
		myTextFrame.characters(1).AppliedCharacterStyle = currentStyle
		if err.number = 0 then 
			on error resume next
			returnVal = replace(myTextFrame.characters(1).AppliedFont.Name, chr(9)," ")
		end if
		
		myTextFrame.delete
	end if
	
	returnStyleFontFace3 = returnVal
end function


function returnCapitalization (currentCapitalization)
	dim returnVal
	
	select case currentCapitalization
		case 1852797549
	 		returnVal = "normal"
	 	case 1634493296
	   		returnVal = "all caps"
		case 1936548720
	   		returnVal = "small caps"
	 	case Else
	 		returnVal = "normal"
	end select
	
	returnCapitalization = returnVal
end function


function getTabAlignment (tabPosition)
	dim returnVal
	
	select case tabPosition
		case 1818584692
	 		returnVal = "left"
	 	case 1667591796
	   		returnVal = "center"
		case 1919379572
			returnVal = "right"
	 	case Else
	 		returnVal = "left"
	end select
	
	getTabAlignment = returnVal
end function


function returnCornerEffect (cornerEffect, theRadius)
	dim returnVal

	if(theRadius = 0)then
		returnVal = ""
	else
		select case cornerEffect
			case 1667592804
				'rounded
				returnVal = "1"
			case 1667591798
				'inverse rounded
				returnVal = "2"
			case 1667588726
				'bevel
				returnVal = "3"
			case 1667591795
				'inset
				returnVal = "4"						
			case Else
				'none
				returnVal = ""
		end select
	end if
	
	returnCornerEffect = returnVal
end function


function returnStrokeColour (currentElem)
	dim returnVal
	
	returnVal = ""

	if(currentElem.characters(1).StrokeColor <> "None") then
		'CMYK
		if(currentElem.characters(1).StrokeColor.Space = 1129142603) then
			returnVal = "CMYK " & cStr(round(currentElem.characters(1).StrokeColor.ColorValue(0)/100, 7) & " " & round(currentElem.characters(1).StrokeColor.ColorValue(1)/100, 7) & " " & round(currentElem.characters(1).StrokeColor.ColorValue(2)/100, 7) & " " & round(currentElem.characters(1).StrokeColor.ColorValue(3)/100, 7))
		end if
		
		'RGB
		if(currentElem.characters(1).StrokeColor.Space = 1666336578) then
			returnVal = "RGB " & cStr(round(currentElem.StrokeColor.ColorValue(0)/255, 7) & " " & round(currentElem.StrokeColor.ColorValue(1)/255, 7) & " " & round(currentElem.StrokeColor.ColorValue(2)/255, 7))
		end if
		
		'LAB
		if(currentElem.characters(1).StrokeColor.Space = 1665941826) then
			returnVal = "LAB " & cStr(round(currentElem.StrokeColor.ColorValue(0), 7) & " " & round(currentElem.StrokeColor.ColorValue(1), 7) & " " & round(currentElem.StrokeColor.ColorValue(2), 7))

			outsourcingLabError()
		end if
		
		if(currentElem.characters(1).StrokeColor.Name = "Black") then
			returnVal = "CMYK 0 0 0 1"
		end if
		
		if(currentElem.characters(1).StrokeColor.Name = "Paper") then
			returnVal = "CMYK 0 0 0 0"
		end if
		
		if(currentElem.characters(1).StrokeColor.Name = "Registration") then
			returnVal = "CMYK 0 0 0 1"
		end if
	end if

	returnStrokeColour = returnVal
end function



function returnStyleStrokeColour (currentStyle)
	dim returnVal
	
	returnVal = ""
	
	on error resume next
	if(currentStyle.StrokeColor <> "None") then
		if err.number = 0 then 
			'CMYK
			if(currentStyle.StrokeColor.Space = 1129142603) then
				returnVal = "CMYK " & cStr(round(currentStyle.StrokeColor.ColorValue(0)/100, 7) & " " & round(currentStyle.StrokeColor.ColorValue(1)/100, 7) & " " & round(currentStyle.StrokeColor.ColorValue(2)/100, 7) & " " & round(currentStyle.StrokeColor.ColorValue(3)/100, 7))
			end if
			
			'RGB
			if(currentStyle.StrokeColor.Space = 1666336578) then
				returnVal = "RGB " & cStr(round(currentStyle.StrokeColor.ColorValue(0)/255, 7) & " " & round(currentStyle.StrokeColor.ColorValue(1)/255, 7) & " " & round(currentStyle.StrokeColor.ColorValue(2)/255, 7))
			end if
			
			'LAB
			if(currentStyle.StrokeColor.Space = 1665941826) then
				returnVal = "LAB " & cStr(round(currentStyle.StrokeColor.ColorValue(0), 7) & " " & round(currentStyle.StrokeColor.ColorValue(1), 7) & " " & round(currentStyle.StrokeColor.ColorValue(2)/100, 7))

				outsourcingLabError()
			end if
			
			if(currentStyle.StrokeColor.Name = "Black") then
				returnVal = "CMYK 0 0 0 1"
			end if
			
			if(currentStyle.StrokeColor.Name = "Paper") then
				returnVal = "CMYK 0 0 0 0"
			end if
			
			if(currentStyle.StrokeColor.Name = "Registration") then
				returnVal = "CMYK 0 0 0 1"
			end if
		end if
	end if

	returnStyleStrokeColour = returnVal
end function



function returnUnderlineColour (currentElem)
	dim returnVal
	
	returnVal = ""

	if(currentElem.characters(1).Underline) then
		if(currentElem.characters(1).UnderlineColor = "Text Color") then
			'return colour of text
			returnVal = returnFillColour(currentElem)
		else
			'CMYK
			if(currentElem.characters(1).UnderlineColor.Space = 1129142603) then
				returnVal = "CMYK " & cStr(round(currentElem.characters(1).UnderlineColor.ColorValue(0)/100, 7) & " " & round(currentElem.characters(1).UnderlineColor.ColorValue(1)/100, 7) & " " & round(currentElem.characters(1).UnderlineColor.ColorValue(2)/100, 7) & " " & round(currentElem.characters(1).UnderlineColor.ColorValue(3)/100, 7))
			end if
			
			'RGB
			if(currentElem.characters(1).UnderlineColor.Space = 1666336578) then
				returnVal = "RGB " & cStr(round(currentElem.characters(1).UnderlineColor.ColorValue(0)/255, 7) & " " & round(currentElem.characters(1).UnderlineColor.ColorValue(1)/255, 7) & " " & round(currentElem.characters(1).UnderlineColor.ColorValue(2)/255, 7))
			end if
			
			'LAB
			if(currentElem.characters(1).UnderlineColor.Space = 1665941826) then
				returnVal = "LAB " & cStr(round(currentElem.characters(1).UnderlineColor.ColorValue(0), 7) & " " & round(currentElem.characters(1).UnderlineColor.ColorValue(1), 7) & " " & round(currentElem.characters(1).UnderlineColor.ColorValue(2), 7))

				outsourcingLabError()
			end if
			
			if(currentElem.characters(1).UnderlineColor.Name = "Black") then
				returnVal = "CMYK 0 0 0 1"
			end if
			
			if(currentElem.characters(1).UnderlineColor.Name = "Paper") then
				returnVal = "CMYK 0 0 0 0"
			end if
			
			if(currentElem.characters(1).UnderlineColor.Name = "Registration") then
				returnVal = "CMYK 0 0 0 1"
			end if
		end if
	end if

	returnUnderlineColour = returnVal
end function


function returnStyleUnderlineColour (currentElem)
	dim returnVal
	
	returnVal = ""

	if(currentElem.Underline) then	
		'check for error
		on error resume next
		errorTest = currentElem.UnderlineColor
		if err.number <> 0 then
			returnVal = "CMYK 0 0 0 1"
		else
			if(currentElem.UnderlineColor = "Text Color") then
				returnVal = "CMYK 0 0 0 1"
			else
				'CMYK
				if(currentElem.UnderlineColor.Space = 1129142603) then
					returnVal = "CMYK " & cStr(round(currentElem.UnderlineColor.ColorValue(0)/100, 7) & " " & round(currentElem.UnderlineColor.ColorValue(1)/100, 7) & " " & round(currentElem.UnderlineColor.ColorValue(2)/100, 7) & " " & round(currentElem.UnderlineColor.ColorValue(3)/100, 7))
				end if
				
				'RGB
				if(currentElem.UnderlineColor.Space = 1666336578) then
					returnVal = "RGB " & cStr(round(currentElem.UnderlineColor.ColorValue(0)/255, 7) & " " & round(currentElem.UnderlineColor.ColorValue(1)/255, 7) & " " & round(currentElem.UnderlineColor.ColorValue(2)/255, 7))
				end if
				
				'LAB
				if(currentElem.UnderlineColor.Space = 1665941826) then
					returnVal = "LAB " & cStr(round(currentElem.UnderlineColor.ColorValue(0), 7) & " " & round(currentElem.UnderlineColor.ColorValue(1), 7) & " " & round(currentElem.UnderlineColor.ColorValue(2), 7))
				
					outsourcingLabError()
				end if
				
				if(currentElem.UnderlineColor.Name = "Black") then
					returnVal = "CMYK 0 0 0 1"
				end if
				
				if(currentElem.UnderlineColor.Name = "Paper") then
					returnVal = "CMYK 0 0 0 0"
				end if
				
				if(currentElem.UnderlineColor.Name = "Registration") then
					returnVal = "CMYK 0 0 0 1"
				end if
			end if
		end if
	end if

	returnStyleUnderlineColour = returnVal
end function


function returnStyleStrikeColour (currentElem)
	dim returnVal
	
	returnVal = ""

	if(currentElem.StrikeThru) then	
		'check for error
		'on error resume next
		'errorTest = currentElem.StrikeThroughColor
		
		'if err.number <> 0 then 	
			if(currentElem.StrikeThroughColor = "Text Color") then
				returnVal = "CMYK 0 0 0 1"
			else
				'CMYK
				if(currentElem.StrikeThroughColor.Space = 1129142603) then
					returnVal = "CMYK " & cStr(round(currentElem.StrikeThroughColor.ColorValue(0)/100, 7) & " " & round(currentElem.StrikeThroughColor.ColorValue(1)/100, 7) & " " & round(currentElem.StrikeThroughColor.ColorValue(2)/100, 7) & " " & round(currentElem.StrikeThroughColor.ColorValue(3)/100, 7))
				end if
				
				'RGB
				if(currentElem.StrikeThroughColor.Space = 1666336578) then
					returnVal = "RGB " & cStr(round(currentElem.StrikeThroughColor.ColorValue(0)/255, 7) & " " & round(currentElem.StrikeThroughColor.ColorValue(1)/255, 7) & " " & round(currentElem.StrikeThroughColor.ColorValue(2)/255, 7))
				end if
				
				'LAB
				if(currentElem.StrikeThroughColor.Space = 1665941826) then
					returnVal = "LAB " & cStr(round(currentElem.StrikeThroughColor.ColorValue(0), 7) & " " & round(currentElem.StrikeThroughColor.ColorValue(1), 7) & " " & round(currentElem.StrikeThroughColor.ColorValue(2), 7))
				
					outsourcingLabError()
				end if
				
				if(currentElem.StrikeThroughColor.Name = "Black") then
					returnVal = "CMYK 0 0 0 1"
				end if
				
				if(currentElem.StrikeThroughColor.Name = "Paper") then
					returnVal = "CMYK 0 0 0 0"
				end if
				
				if(currentElem.StrikeThroughColor.Name = "Registration") then
					returnVal = "CMYK 0 0 0 1"
				end if
			end if
		'end if
	end if

	returnStyleStrikeColour = returnVal
end function


function returnStrikeColour (currentElem)
	dim returnVal
	
	returnVal = ""

	if(currentElem.characters(1).StrikeThru) then
		'CMYK
		if(currentElem.characters(1).StrikeThroughColor.Space = 1129142603) then
			returnVal = "CMYK " & cStr(round(currentElem.characters(1).StrikeThroughColor.ColorValue(0)/100, 7) & " " & round(currentElem.characters(1).StrikeThroughColor.ColorValue(1)/100, 7) & " " & round(currentElem.characters(1).StrikeThroughColor.ColorValue(2)/100, 7) & " " & round(currentElem.characters(1).StrikeThroughColor.ColorValue(3)/100, 7))
		end if
		
		'RGB
		if(currentElem.characters(1).StrikeThroughColor.Space = 1666336578) then
			returnVal = "RGB " & cStr(round(currentElem.characters(1).StrikeThroughColor.ColorValue(0)/255, 7) & " " & round(currentElem.characters(1).StrikeThroughColor.ColorValue(1)/255, 7) & " " & round(currentElem.characters(1).StrikeThroughColor.ColorValue(2)/255, 7))
		end if
		
		'LAB
		if(currentElem.characters(1).StrikeThroughColor.Space = 1665941826) then
			returnVal = "LAB " & cStr(round(currentElem.characters(1).StrikeThroughColor.ColorValue(0), 7) & " " & round(currentElem.characters(1).StrikeThroughColor.ColorValue(1), 7) & " " & round(currentElem.characters(1).StrikeThroughColor.ColorValue(2), 7))

			outsourcingLabError()
		end if
		
		if(currentElem.characters(1).StrikeThroughColor.Name = "Black") then
			returnVal = "CMYK 0 0 0 1"
		end if
		
		if(currentElem.characters(1).StrikeThroughColor.Name = "Paper") then
			returnVal = "CMYK 0 0 0 0"
		end if
		
		if(currentElem.characters(1).StrikeThroughColor.Name = "Registration") then
			returnVal = "CMYK 0 0 0 1"
		end if
	end if

	returnStrikeColour = returnVal
end function


function isDynamicColour(theName)
	select case theName
		case "Primary Colour"
			returnVal = true
	 	case "primary colour"
			returnVal = true
	 	case "Secondary Colour"
			returnVal = true
	 	case "secondary colour"
			returnVal = true
		case "Tertiary Colour"
			returnVal = true
		case "tertiary colour"
			returnVal = true
		case "Quaternary Colour"
			returnVal = true
		case "quaternary colour"
			returnVal = true
		case "gc1"
			returnVal = true
		case "gc2"
			returnVal = true
		case "gc3"
			returnVal = true
		case "gc4"
			returnVal = true
		case "gc5"
			returnVal = true
		case "gc6"
			returnVal = true
		case "gc7"
			returnVal = true
		case "gc8"
			returnVal = true
		case "gc9"
			returnVal = true
		case "gc10"
			returnVal = true
		case "GC1"
			returnVal = true
		case "GC2"
			returnVal = true
		case "GC3"
			returnVal = true
		case "GC4"
			returnVal = true
		case "GC5"
			returnVal = true
		case "GC6"
			returnVal = true
		case "GC7"
			returnVal = true
		case "GC8"
			returnVal = true
		case "GC9"
			returnVal = true
		case "GC10"
			returnVal = true
	 	case Else
			returnVal = false
	end select

	isDynamicColour = returnVal
end function


function returnCMYKFormatted(theValue, theTint)
	if(theValue = 0) then
		theValue = 0
	else
		if(theTint = 100) then
			theValue = theValue/100
			theValue = Round(theValue, 7)
		else
			if(theTint = -1) then
				theValue = theValue/100
				theValue = Round(theValue, 7)
			else
				'the tint
				theValue = (theValue/100) * theTint
				theValue = Round(theValue, 7)
				
				'convert to pdfl
				theValue = theValue/100
			end if
		end if
	end if

	theValue = cStr(theValue)

	returnCMYKFormatted = theValue
end function


function returnFillColour (currentElem)
	dim returnVal

	set theChar = currentElem.characters(1)
	
	if(isDynamicColour(theChar.FillColor.name))then
		returnVal = theChar.FillColor.name
	else
		returnVal = "CMYK 0 0 0 1"

		
		
		if(theChar.FillColor <> "None") then
			'CMYK
			if(theChar.FillColor.Space = 1129142603) then
				returnVal = "CMYK " & returnCMYKFormatted(theChar.FillColor.ColorValue(0), theChar.FillTint) & " " & returnCMYKFormatted(theChar.FillColor.ColorValue(1), theChar.FillTint) & " " & returnCMYKFormatted(theChar.FillColor.ColorValue(2), theChar.FillTint) & " " & returnCMYKFormatted(theChar.FillColor.ColorValue(3), theChar.FillTint)
			end if
			
			'RGB
			if(currentElem.characters(1).FillColor.Space = 1666336578) then
				returnVal = "RGB " & cStr(round(currentElem.characters(1).FillColor.ColorValue(0)/255, 7) & " " & round(currentElem.characters(1).FillColor.ColorValue(1)/255, 7) & " " & round(currentElem.characters(1).FillColor.ColorValue(2)/255, 7))
			end if
			
			'LAB
			if(currentElem.characters(1).FillColor.Space = 1665941826) then
				returnVal = "LAB " & cStr(round(currentElem.characters(1).FillColor.ColorValue(0), 7) & " " & round(currentElem.characters(1).FillColor.ColorValue(1), 7) & " " & round(currentElem.characters(1).FillColor.ColorValue(2), 7))

				outsourcingLabError()
			end if
			
			
			if(currentElem.characters(1).FillColor.Name = "Black") then
				returnVal = "CMYK 0 0 0 " & returnCMYKFormatted(100, theChar.FillTint)
			end if
			
			if(currentElem.characters(1).FillColor.Name = "Paper") then
				returnVal = "CMYK 0 0 0 0"
			end if
			
			if(currentElem.characters(1).FillColor.Name = "Registration") then
				returnVal = "CMYK 0 0 0 " & returnCMYKFormatted(100, theChar.FillTint)
			end if
		end if
	end if
	
	returnFillColour = returnVal
end function


function outsourcingLabError
	'get the url
	theURL = ReadPref("Server_URL")

	'LW test
	if(InStr(1,theURL,"NPP",1) <> 0)then
		msgbox("This template contains LAB colours, please use CMYK.")
	end if

	'TM test
	if(InStr(1,theURL,"TM",1) <> 0)then
		msgbox("This template contains LAB colours, please use CMYK.")
	end if
end function


function returnCharacterFillColour (currentElem)
	dim returnVal
	
	returnVal = ""
	
	'check for error
	on error resume next
	set errorTest = currentElem.FillColor
	
	
	if err.number = 0 then 
		if(currentElem.FillColor <> "None") then
			if(isDynamicColour(currentElem.FillColor.name))then
				returnVal = currentElem.FillColor.name
			else
				'CMYK
				if(currentElem.FillColor.Space = 1129142603) then
					returnVal = "CMYK " & cStr(round(currentElem.FillColor.ColorValue(0)/100, 7) & " " & round(currentElem.FillColor.ColorValue(1)/100, 7) & " " & round(currentElem.FillColor.ColorValue(2)/100, 7) & " " & round(currentElem.FillColor.ColorValue(3)/100, 7))
				end if
				
				'RGB
				if(currentElem.FillColor.Space = 1666336578) then
					returnVal = "RGB " & cStr(round(currentElem.FillColor.ColorValue(0)/255, 7) & " " & round(currentElem.FillColor.ColorValue(1)/255, 7) & " " & round(currentElem.FillColor.ColorValue(2)/255, 7))
				end if
				
				'LAB
				if(currentElem.FillColor.Space = 1665941826) then
					returnVal = "LAB " & cStr(round(currentElem.FillColor.ColorValue(0)/100, 7) & " " & round(currentElem.FillColor.ColorValue(1)/100, 7) & " " & round(currentElem.FillColor.ColorValue(2)/100, 7))

					outsourcingLabError()
				end if
				
				
				if(currentElem.FillColor.Name = "Black") then
					returnVal = "CMYK 0 0 0 1"
				end if
				
				if(currentElem.FillColor.Name = "Paper") then
					returnVal = "CMYK 0 0 0 0"
				end if
				
				if(currentElem.FillColor.Name = "Registration") then
					returnVal = "CMYK 0 0 0 1"
				end if
			end if
		end if
	end if
	
	returnCharacterFillColour = returnVal
end function



function returnStrokeWeight (strokeWeight)
	returnVal = 0
	
	if((strokeWeight <> "") and (strokeWeight <> 1851876449)) then
		if(InStr(UCase(ReadPref("ID_Version")),"CC") > 0)then
			returnVal = strokeWeight
		else
			returnVal = CDbl(strokeWeight) / 2
		end if
	end if
	

	returnStrokeWeight = returnVal
end function



function returnUnderlineWeight (weightValue)
	
	if (weightValue = -9999) then
		returnVal = 0.6
	else
		returnVal = weightValue
	end if

	if (returnVal = "1851876449") then
		returnVal = 0.6
	end if
	
	if (returnVal = "") then
		returnVal = "auto"
	end if
	
	returnUnderlineWeight = returnVal
end function


function returnStyleStrikeWeight(weightValue)
	
	if (weightValue = -9999) then
		returnVal = 0.6
	else
		returnVal = weightValue
	end if

	if (returnVal = "1851876449") then
		returnVal = 0.6
	end if
	
	if (returnVal = "") then
		returnVal = "auto"
	end if

	returnStyleStrikeWeight = returnVal
end function


function returnUnderlinePosition (positionValue)
	if (positionValue = -9999) then
		returnVal = "auto"
	else
		returnVal = "-" & positionValue
	end if
	
	if (returnVal = "-1851876449") then
		returnVal = "auto"
	end if
	
	returnUnderlinePosition = returnVal
end function


function returnStrikePosition (positionValue)
	
	if (positionValue = -9999) then
		returnVal = "auto"
	else
		returnVal = positionValue
	end if
	
	if (returnVal = "1851876449") then
		returnVal = "auto"
	end if

	returnStrikePosition = returnVal
end function


Function returnFirstBaseline(baselineOption, baselineMin)

	select case baselineOption
		case 1296255087
	 		'cap height
			returnVal = "capheight"
	 	case 1296852079
	   		'leading
			returnVal = "leading"
	 	case 1299728495
	   		'bevel
			returnVal = "xheight"
	 	case 1313228911
	   		'fixed
			returnVal = CStr(baselineMin)	
		case 1296135023
	   		'ascent
			returnVal = "ascender"
	 	case Else
	 		'default cap height
			returnVal = "capheight"
	end select
	
	returnFirstBaseline = returnVal
End Function


function returnSuperscript (thePosition)
	if(thePosition = 1936749411) then
		returnVal = "true"
	else
		returnVal = ""
	end if

	returnSuperscript = returnVal
end function


function returnSubscript (thePosition)
	if(thePosition = 1935831907) then
		returnVal = "true"
	else
		returnVal = ""
	end if

	returnSubscript = returnVal
end function


function stripTags(defaultText)
	defaultText = replace(defaultText,"|","#bar")
	defaultText = replace(defaultText,chr(13),"#return")
	defaultText = replace(defaultText,chr(10),"")
	
	stripTags = defaultText
end function



function getWrapData(allElems, currentConfiguredElem)

	'set default
	wrapData = ""
	theVersion = ReadPref("ID_Version")
	continueOn = false

	
	'make sure the configured text field has wrapping enabled.
	if (currentConfiguredElem.ExtractLabel ("type") = "text")then
		if (theVersion = "4") OR (theVersion = "5") OR (theVersion = "5.5") OR (theVersion = "6") OR (theVersion = "2020") OR (theVersion = "2021") OR (theVersion = "2022") OR (theVersion = "2023") OR (theVersion = "2024") OR (InStr(UCase(theVersion),"CC") > 0) then
			wrapType = currentConfiguredElem.TextWrapPreferences.TextWrapMode
		else
			wrapType = currentConfiguredElem.TextWrapPreferences.TextWrapType
		end if
		
		if(wrapType <> 1852796517) then
			continueOn = true
		end if
	end if
	
	
	'see if ignore option is set
	if(continueOn) then
		if(TypeName(currentConfiguredElem) = "TextFrame") then
			if(currentConfiguredElem.TextFramePreferences.IgnoreWrap = true) then
				continueOn = false
			end if
		end if
	end if
	
	
	if(continueOn) then
		'Loop through elements looking for wrapping elements
		For wrapCounter = 1 To allElems.Count
			set currentElem = allElems(wrapCounter)
			
			'dont add the box we are wrapping with
			if(currentConfiguredElem.id <> currentElem.id) then
				'dont wrap flashes
				if(TypeName(currentElem) = "Rectangle") OR (TypeName(currentElem) = "Polygon") OR (TypeName(currentElem) = "TextFrame")then
					vlLeftOffset = 0
					vlTopOffset = 0
					vlWidthOffset = 0
					vlHeightOffset = 0
					
					
					select case currentElem.StrokeAlignment
						case "1936998723"
							'stroke to the center
							borderAdjustment = (currentElem.StrokeWeight / 2)
						case "1936998735"
							'stroke to the outside
							borderAdjustment = currentElem.StrokeWeight
						case "1936998729"
							'stroke to the inside
							borderAdjustment = 0	
						case else
							borderAdjustment = 0	
					end select
					
					
					'CC4 and up has changed
					if (version = "CS2") OR (version = "CS3")then
						wrapType = currentElem.TextWrapPreferences.TextWrapType
					else
						wrapType = currentElem.TextWrapPreferences.TextWrapMode
					end if
					
					'if wrap around is bounding box or object shape
					if(wrapType = 1651729523) OR (wrapType = 1650552420) then
						
						if(currentElem.TextWrapPreferences.TextWrapOffset(0) <> 1851876449) then
							vlTopOffset = currentElem.TextWrapPreferences.TextWrapOffset(0)
						else
							vlTopOffset = 0
						end if
						
						if(currentElem.TextWrapPreferences.TextWrapOffset(1) <> 1851876449) then
							vlLeftOffset = currentElem.TextWrapPreferences.TextWrapOffset(1)
						else
							vlLeftOffset = 0
						end if
						
						if(currentElem.TextWrapPreferences.TextWrapOffset(2) <> 1851876449) then
							vlBottomtOffset = currentElem.TextWrapPreferences.TextWrapOffset(2)
						else
							vlBottomtOffset = 0
						end if
						
						
						if(currentElem.TextWrapPreferences.TextWrapOffset(3) <> 1851876449) then
							vlRightOffset = currentElem.TextWrapPreferences.TextWrapOffset(3)
						else
							vlRightOffset = 0
						end if
						
						
						'work out values
						vlTopVal = (currentElem.GeometricBounds(0) - vlTopOffset) - borderAdjustment
						vlLeftVal = (currentElem.GeometricBounds(1) - vlLeftOffset) - borderAdjustment
						vlBottomVal = ((currentElem.GeometricBounds(2) - currentElem.GeometricBounds(0)) + (vlBottomtOffset * 2)) + (borderAdjustment*2)
						vlRightVal = ((currentElem.GeometricBounds(3) - currentElem.GeometricBounds(1)) + (vlRightOffset * 2)) + (borderAdjustment*2)
						
						'invert
						if(currentElem.TextWrapPreferences.Inverse)then
							invertVal = "true"
						else
							invertVal = "false"
						end if
						
						'collect data
						wrapData = wrapData + "<wrap><left>" & vlLeftVal & "</left><top>" & vlTopVal & "</top><height>" & vlBottomVal & "</height><width>" & vlRightVal & "</width><invert>" & invertVal & "</invert></wrap>"
						
					end if
				end if
			end if
		Next
	end if
	
	
	getWrapData = wrapData

end function



function GetItemIndex(myInDesign, item)
	returnVal = 0
	
	'get indesign version
	theVersion = ReadPref("ID_Version")
	
	
	For pageCount = 1 To myInDesign.ActiveDocument.Pages.Count
		
		if(theVersion = "5") OR (theVersion = "5.5") OR (theVersion = "6") OR (theVersion = "2020") OR (theVersion = "2021") OR (theVersion = "2022") OR (theVersion = "2023") OR (theVersion = "2024") OR (InStr(UCase(theVersion),"CC") > 0)then
			set allIndexElems = myInDesign.ActiveDocument.Pages(pageCount).AllPageItems
		else
			set allIndexElems = myInDesign.ActiveDocument.Pages(pageCount).PageItems
		end if
		
		'loop through all elements
		For indexCounter = 1 To allIndexElems.Count
			set currentIndexElem = allIndexElems(indexCounter)
			
			if(currentIndexElem.id = item.id)then
				returnVal = indexCounter
			end if
		next
	next
	
	GetItemIndex = returnVal
end function

function dnd_tmp
	dnd_tmp = "1.0.8"
end function

function returnTracking(theTracking)
	returnTracking = 0
	
	if(theTracking <> 0) AND (theTracking <> 1851876449) then
		returnTracking = theTracking * 0.012
	end if

	returnTracking = returnTracking
end function


function returnHorizontalScale(theScale)
	returnScale = 0
	
	if(theScale <> 0) AND (theScale <> 1851876449) then
		returnScale = theScale
	end if

	returnHorizontalScale = returnScale
end function


function pointData(currentElem)
	returnValue = ""
	
	'offset rotation
	originalRotation = currentElem.RotationAngle
	currentElem.RotationAngle = 0

	
	if(currentElem.Paths.count > 0)then
		'only collect points if the shape is irregular
		collectData = true
		
		totalPoints = currentElem.Paths(1).PathPoints.Count
		
		if(totalPoints = 4)then
			'cs2 weird bug
			tolerance = 0.1
			
			'top left is same as top right
			if(currentElem.Paths(1).PathPoints(1).anchor(0) > currentElem.Paths(1).PathPoints(2).anchor(0))then
				difference = currentElem.Paths(1).PathPoints(1).anchor(0) - currentElem.Paths(1).PathPoints(2).anchor(0)
			else
				difference = currentElem.Paths(1).PathPoints(2).anchor(0) - currentElem.Paths(1).PathPoints(1).anchor(0)
			end if
			
			if(difference < tolerance)then
				
				'top right is same as bottom right
				if(currentElem.Paths(1).PathPoints(2).anchor(1) > currentElem.Paths(1).PathPoints(3).anchor(1))then
					difference = currentElem.Paths(1).PathPoints(2).anchor(1) - currentElem.Paths(1).PathPoints(3).anchor(1)
				else
					difference = currentElem.Paths(1).PathPoints(3).anchor(1) - currentElem.Paths(1).PathPoints(2).anchor(1)
				end if
				
				if(difference < tolerance)then
					
					'bottom left is same as bottom right
					if(currentElem.Paths(1).PathPoints(3).anchor(0) > currentElem.Paths(1).PathPoints(4).anchor(0))then
						difference = currentElem.Paths(1).PathPoints(3).anchor(0) - currentElem.Paths(1).PathPoints(4).anchor(0)
					else
						difference = currentElem.Paths(1).PathPoints(4).anchor(0) - currentElem.Paths(1).PathPoints(3).anchor(0)
					end if
					
					if(difference < tolerance)then
						
						'top left is same as bottom left
						if(currentElem.Paths(1).PathPoints(1).anchor(1) > currentElem.Paths(1).PathPoints(4).anchor(1))then
							difference = currentElem.Paths(1).PathPoints(1).anchor(1) - currentElem.Paths(1).PathPoints(4).anchor(1)
						else
							difference = currentElem.Paths(1).PathPoints(4).anchor(1) - currentElem.Paths(1).PathPoints(1).anchor(1)
						end if
						
						if(difference < tolerance)then
							collectData = false
						end if
					end if
				end if
			end if
		end if
		
		
		'always collect points for generic elements
		if(currentElem.ExtractLabel ("type") = "generic") then
			collectData=true
		end if
		
		
		if(collectData)then
			For pointCounter = 1 To totalPoints
				
				currentPoint = currentElem.Paths(1).PathPoints(pointCounter).anchor
				
				returnValue = returnValue & currentPoint(0) & "," & currentPoint(1) & ";"
			Next
		end if
	end if
	
	
	'use original bounds
	'currentElem.GeometricBounds = originlBounds
	
	'rotate element back
	currentElem.RotationAngle = originalRotation
	
	pointData = returnValue
end function


function groupTextFieldCount(myElem)
	flashTextCount = 0
	
	set allFlashElems = myElem.AllPageItems
	
	For flashElems = 1 To allFlashElems.Count
		if (TypeName(allFlashElems(flashElems)) = "TextFrame") then
			flashTextCount = flashTextCount + 1
		end if
	Next
	
	groupTextFieldCount = flashTextCount
end function

function highestElementIndex(myInDesign, allPages)
	highestIndex = 0
	
	For myPageCount = 1 To allPages.Count
		
		set allElems = myInDesign.ActiveDocument.Pages(CInt(myPageCount)).AllPageItems
		
		For myCounter = 1 To allElems.Count
			
			set currentElem = allElems(myCounter)
			
			theIndex = GetItemIndex(myInDesign, currentElem)
			
			if(theIndex > highestIndex) then
				highestIndex = theIndex
			end if
		next
	next
	
	'increment highest index
	highestIndex = highestIndex + 1
	
	highestElementIndex = highestIndex
end function


function returnCornerRadius(currentElem, cornerRadius)
	
	if(cornerRadius = "")then
		cornerRadius = 0
	end if

	select case currentElem.StrokeAlignment
		case "1936998723"
			'stroke to the center
			borderAdjustment = (currentElem.StrokeWeight / 2)
		case "1936998735"
			'stroke to the outside
			borderAdjustment = 0	
		case "1936998729"
			'stroke to the inside
			borderAdjustment = currentElem.StrokeWeight	
		case else
			borderAdjustment = 0	
	end select

	
	if(borderAdjustment = 0)then
		'borderAdjustment = 1
	end if

	borderAdjustment = borderAdjustment * 2
	libLineAdjustment = 0.5

	
	'only for large corners
	if((borderAdjustment + libLineAdjustment) > cornerRadius)then
		theResult = cornerRadius - borderAdjustment
	else
		theResult = cornerRadius - (borderAdjustment + libLineAdjustment)
	end if
	
	'dont return negative numbers
	if(theResult < 0)then
		theResult = 0
	end if

	returnCornerRadius = theResult
end function


Function HTMLEncode(ByVal StringVal)

    if(true)then
    	sReturn = StringVal
    else
	    sReturn = ""

	      StringLen = Len(StringVal)


		  For i = 1 To StringLen
		    Char = Mid(StringVal, i, 1)
		    CharCode = AscW(Char)
		    If 97 <= CharCode And CharCode <= 122 _
		    Or 64 <= CharCode And CharCode <= 90 _
		    Or 48 <= CharCode And CharCode <= 57 _
		    Or 45 = CharCode _
		    Or 46 = CharCode _
		    Or 95 = CharCode _
		    Or 126 = CharCode Then
		      tmp = Char
		    ElseIf 32 = CharCode Then
		      tmp = " "
		    Else
		      tmp = "&#" & CharCode & ";"
		    End If

		    sReturn = sReturn + tmp
		  Next
	end if
    
    HTMLEncode = sReturn
End Function


Sub collectVariableData (myInDesign, tmpDataFilePath, myItemPreset)
	
	'Set page count
	set allPages = myInDesign.ActiveDocument.Pages
	
	'Create tmp file
	Set objFSO = CreateObject("scripting.filesystemobject")
	Set objTextStream = objFSO.OpenTextFile(tmpDataFilePath, 2, True)
	
	
	'change reference point
	'myInDesign.ActiveDocument.LayoutWindows(1).TransformReferencePoint = idAnchorPoint.idBottomLeftAnchor
	myInDesign.ActiveDocument.LayoutWindows(1).TransformReferencePoint = 1095656044
	
	
	'change zero point to 0,0
	myInDesign.ActiveDocument.zeroPoint = Array(0,0)
	
	
	'Change units to points
	userUnitsHoriz = myInDesign.ActiveDocument.viewPreferences.HorizontalMeasurementUnits
	userUnitsVert = myInDesign.ActiveDocument.viewPreferences.VerticalMeasurementUnits
	
	myInDesign.ActiveDocument.viewPreferences.HorizontalMeasurementUnits = 2054188905
	myInDesign.ActiveDocument.viewPreferences.VerticalMeasurementUnits = 2054188905
	
	'Check file was created
	If checkFileExists(tmpDataFilePath) Then
		
		'Set document options
		set theDocument = myInDesign.ActiveDocument
		
		
		'get highest index so we know how many elements to loop
		highestIndex = highestElementIndex(myInDesign, allPages)
		
		
		'Collect document info and write it to disk
		elemData = setData("Type", "Document") & setData("engine version", "2.0") & setData("engine total elements", highestIndex) & setData("name", theDocument.Label) & setData("total pages", theDocument.pages.count) & setData("group", theDocument.ExtractLabel ("group")) & setData("Rows", theDocument.ExtractLabel ("rows")) & setData("Columns", theDocument.ExtractLabel ("cols")) & setData("split and zip", theDocument.ExtractLabel ("splitPages")) & setData("white text", theDocument.ExtractLabel ("whiteText"))
		
		elemData = elemData & setData("style code", UCase(theDocument.ExtractLabel ("styleCode"))) & setData("production access enabled", theDocument.ExtractLabel ("prodAccess")) & setData("hot folder", theDocument.ExtractLabel ("hotFolder")) & setData("height", theDocument.documentPreferences.PageHeight) & setData("width", theDocument.documentPreferences.PageWidth) & setData("Category", theDocument.ExtractLabel ("category")) & setData("key word", theDocument.ExtractLabel ("keyWord")) & setData("dnd tmp", dnd_tmp) & setData("Client ID", ReadPref("Server_BF")) & setData("sub category", theDocument.ExtractLabel ("sub category")) & setData("company", clientID) & setData("display title", theDocument.ExtractLabel ("displayName")) & setData("multi page listing", theDocument.ExtractLabel ("multiPageListing")) & setData("jpg export", theDocument.ExtractLabel ("jpgExport"))

		elemData = elemData & setData("bleed top", theDocument.ExtractLabel ("bleedTop"))
		elemData = elemData & setData("bleed bottom", theDocument.ExtractLabel ("bleedBottom"))
		elemData = elemData & setData("bleed left", theDocument.ExtractLabel ("bleedLeft"))
		elemData = elemData & setData("bleed right", theDocument.ExtractLabel ("bleedRight"))

		elemData = elemData & setData("script os", "windows")
		elemData = elemData & setData("script cs", ReadPref("ID_Version"))
		elemData = elemData & setData("script version", "1.0.8")
		elemData = elemData & setData("script user", ReadPref("id_user"))


		if(myInDesign.ActiveDocument.ExtractLabel ("dontLink") = "true")then
			elemData = elemData & setData("dont link artwork", "true")
		end if
		
		
		'text preferences
		elemData = elemData & setData("small caps", returnSmallCapsPref(myInDesign)) 
		elemData = elemData & setData("superscript size", returnSuperscriptSize(myInDesign)) 
		elemData = elemData & setData("superscript position", returnSuperscriptPos(myInDesign)) 
		elemData = elemData & setData("subscript size", returnSubscriptSize(myInDesign)) 
		elemData = elemData & setData("subscript position", returnSubscriptPos(myInDesign)) 
		
		'write document data to disc
		objTextStream.WriteLine elemData
		
		
		'Loop through pages
		For myPageCount = 1 To allPages.Count
			
			'Set element count
			set allElems = myInDesign.ActiveDocument.Pages(CInt(myPageCount)).PageItems
			'set allElems = myInDesign.ActiveDocument.Pages(CInt(myPageCount)).AllPageItems
			
			
			'loop through all elements
			For myCounter = 1 To allElems.Count
				elemData = ""
				set currentElem = allElems(myCounter)
				currentElem.select
				
				'Variable text
				if ((currentElem.ExtractLabel ("type") = "text") OR (currentElem.ExtractLabel ("type") = "list")) then
					
					'make sure the element content type has not been changed after it has been configured.
					if (TypeName(currentElem) = "TextFrame") then
					
						'only collect first text frame data
						if(currentElem.TextFrameIndex = 1) then
							
							'set different options if we are dealing with a list
							if (currentElem.ExtractLabel ("type") = "text") then
								elemData = setData("Type", "Text") & setData("set blind", currentElem.ExtractLabel ("blind")) & setData("allow wysiwyg", currentElem.ExtractLabel ("allowWysiwyg"))
							else
								elemData = setData("Type", "List") & setData("heading style", currentElem.ExtractLabel ("headingStyle")) & setData("heading field", currentElem.ExtractLabel ("headingField"))  & setData("list style", currentElem.ExtractLabel ("listStyle")) & setData("list sort", currentElem.ExtractLabel ("listSort"))
							end if

							'msgbox(HTMLEncode("The image tag: <img>"))

							
							'add rest of typography values
							elemData = elemData & setData("autofill", HTMLEncode(currentElem.ExtractLabel("autoFill"))) & setData("z index", GetItemIndex(myInDesign, currentElem))
							elemData = elemData & setData("name", currentElem.Label) & setData("Bounds", getBounds(currentElem)) & setData("spread", myPageCount) & setData("dingbat", currentElem.ExtractLabel("dingbat")) & setData("default text", HTMLEncode(currentElem.ExtractLabel ("defaultTxt"))) & setData("searchReplace", currentElem.ExtractLabel ("searchReplace"))
							elemData = elemData & setData("Sort", currentElem.ExtractLabel ("sort")) & setData("maximum chars", currentElem.ExtractLabel ("maxChars")) & setData("number of lines", currentElem.ExtractLabel ("numberOfLines")) & setData("character width", currentElem.ExtractLabel ("characterWidth"))
							elemData = elemData & setData("start of line", currentElem.ExtractLabel ("startOfLine")) & setData("sub edit", currentElem.ExtractLabel ("subEdit")) & setData("Disable SpellCheck", currentElem.ExtractLabel ("disableSpellcheck")) & setData("wrap data", getWrapData(allElems, currentElem)) & setData("change case", currentElem.ExtractLabel ("changeCase"))

							'variable depth
							elemData = elemData & setData("variable depth", currentElem.ExtractLabel ("vd"))
							
							'text options
							elemData = elemData & textOptions(currentElem, myInDesign)
							
							'fit method
							fitMethod = currentElem.ExtractLabel ("fitMethod")
							elemData = elemData & setData("fit minimum", returnFitMethodSize(fitMethod, currentElem.ExtractLabel ("minPointSize")))
							elemData = elemData & setData("fit maximum", returnFitMethodSize(fitMethod, currentElem.ExtractLabel ("maxPointSize")))
							elemData = elemData & setData("fit method", fitMethod)
						end if
					else
						msgbox("The selected element has been configured as a text box but changed to an image box.")
					end if
				end if
				
				
				
				'Variable flash
				if (currentElem.ExtractLabel ("type") = "flash") then
					elemData = setData("Type", "Flash") & setData("z index", GetItemIndex(myInDesign, currentElem)) & setData("name", currentElem.Label) & setData("spread", myPageCount)
					elemData = elemData + setData("Sort", currentElem.ExtractLabel ("sort")) & setData("Disable SpellCheck", currentElem.ExtractLabel ("disableSpellcheck")) & setData("autofill", currentElem.ExtractLabel ("autoFill"))
					elemData = elemData & setData("change case", currentElem.ExtractLabel ("changeCase"))

					if(ReadPref("EzAdsPro_Product") = "1") OR (ReadPref("EzAdsPro_Product") = "2") then
						elemData = elemData & setData("maximum chars", currentElem.GeometricBounds(0)) & setData("number of lines", currentElem.GeometricBounds(1)) & setData("character width", currentElem.GeometricBounds(2)) &  setData("searchReplace", currentElem.ExtractLabel ("searchReplace")) & setData("fit minimum", currentElem.ExtractLabel ("minPointSize")) & setData("fit maximum", currentElem.ExtractLabel ("maxPointSize"))
					else
						elemData = elemData & setData("maximum chars", currentElem.ExtractLabel ("maxChars")) & setData("number of lines", currentElem.ExtractLabel ("numberOfLines")) & setData("character width", currentElem.ExtractLabel ("characterWidth")) & setData("searchReplace", currentElem.ExtractLabel ("searchReplace")) 
					end if
					
					'what type of flash?
					Select Case TypeName(currentElem)
						Case "Group"
							if(currentElem.ExtractLabel("blind") = "true")then
								elemData = elemData & setData("set blind", "true")
							else
								'test how many textframes we have inside the flash
								flashTextCount = groupTextFieldCount(currentElem)
								
								'only variable if the group contains ONE text field
								if(flashTextCount = 1) then
									
									'get all elements inside the flash group
									set allFlashElems = currentElem.AllPageItems
									
									'loop through elements
									For flashElems = 1 To allFlashElems.Count
										'find first text box
										if (TypeName(allFlashElems(flashElems)) = "TextFrame") then
											'get text field
											set textElem = allFlashElems(flashElems)
											
											'flash text bounds
											elemData = elemData & setData("Bounds", getBounds(textElem))
											
											'text options
											elemData = elemData & textOptions(textElem, myInDesign)
											
											'fit method
											fitMethod = currentElem.ExtractLabel ("fitMethod")
											elemData = elemData & setData("fit minimum", returnFitMethodSize(fitMethod, currentElem.ExtractLabel ("minPointSize")))
											elemData = elemData & setData("fit maximum", returnFitMethodSize(fitMethod, currentElem.ExtractLabel ("maxPointSize")))
											elemData = elemData & setData("fit method", fitMethod)
										end if
									Next
								else
									elemData = elemData & setData("set blind", "true")
								end if
							end if
							
						Case "Rectangle", "Oval", "Polygon"
							'image flash
							elemData = elemData & setData("set blind", "true")
							
						Case "TextFrame"
							'text flash
							
							if(currentElem.ExtractLabel("blind") = "true")then
								'just display text
								elemData = elemData & setData("set blind", "true")
							else
								'variable text flash
								elemData = elemData & textOptions(currentElem, myInDesign)
								elemData = elemData & setData("Bounds", getBounds(currentElem))
								
								'fit method
								fitMethod = currentElem.ExtractLabel ("fitMethod")
								elemData = elemData & setData("fit minimum", returnFitMethodSize(fitMethod, currentElem.ExtractLabel ("minPointSize")))
								elemData = elemData & setData("fit maximum", returnFitMethodSize(fitMethod, currentElem.ExtractLabel ("maxPointSize")))
								elemData = elemData & setData("fit method", fitMethod)
							end if
							
						Case Else
							elemData = elemData & setData("set blind", "true")
					End Select
				end if	
				
				
				'Variable image
				if (currentElem.ExtractLabel ("type") = "image") then
					elemData = setData("Type", "Image") & setData("z index", GetItemIndex(myInDesign, currentElem)) & setData("name", currentElem.Label) & setData("Bounds", getBounds(currentElem)) & setData("spread", myPageCount) & setData("shape", TypeName(currentElem))
					elemData = elemData + setData("Sort", currentElem.ExtractLabel ("sort")) & setData("fit method", currentElem.ExtractLabel ("fitMethod")) & setData("image type", currentElem.ExtractLabel ("imageType")) & setData("allow cropping", currentElem.ExtractLabel ("allowCropping")) & setData("image action", currentElem.ExtractLabel ("imageAction")) & setData("rotation", currentElem.AbsoluteRotationAngle) & setData("set blind", currentElem.ExtractLabel ("blind"))
					
					
					correctPathData = true
					
					
					'has third party plugin or polygon type been used
					if(TypeName(currentElem) = "Polygon") then
						if(currentElem.ExtractLabel ("third party used") = "true") then
							'dont correct path data
							correctPathData = false
							
							'has third party plugin been used
							elemData = elemData & setData("corner effect 1", currentElem.ExtractLabel ("first corner type")) & setData("corner radius 1", returnCornerRadius(currentElem, currentElem.ExtractLabel ("first corner radius")))
							elemData = elemData & setData("corner effect 2", currentElem.ExtractLabel ("second corner type")) & setData("corner radius 2", returnCornerRadius(currentElem, currentElem.ExtractLabel ("second corner radius")))
							elemData = elemData & setData("corner effect 3", currentElem.ExtractLabel ("third corner type")) & setData("corner radius 3", returnCornerRadius(currentElem, currentElem.ExtractLabel ("third corner radius")))
							elemData = elemData & setData("corner effect 4", currentElem.ExtractLabel ("last corner type")) & setData("corner radius 4", returnCornerRadius(currentElem, currentElem.ExtractLabel ("last corner radius")))
						else
							'polygon shape has been used so all corners are bevelled
							
							theRadius = (currentElem.GeometricBounds(3) - currentElem.GeometricBounds(1)) / 4
							
							if(theRadius = 0)then
								'do nothing
							else
								elemData = elemData & setData("corner effect 1", "5") & setData("corner radius 1", theRadius)
								elemData = elemData & setData("corner effect 2", "5") & setData("corner radius 2", theRadius)
								elemData = elemData & setData("corner effect 3", "5") & setData("corner radius 3", theRadius)
								elemData = elemData & setData("corner effect 4", "5") & setData("corner radius 4", theRadius)
							end if
						end if
						
					else
						'all corners are the same
						select case UCase(ReadPref("ID_Version"))
							case "CS2"
								theRadius = returnCornerRadius(currentElem, currentElem.CornerRadius)
								
								if(theRadius = 0)then
									'do nothing
								else
									elemData = elemData & setData("corner effect 1", returnCornerEffect(currentElem.cornerEffect, theRadius)) & setData("corner radius 1", theRadius)
									elemData = elemData & setData("corner effect 2", returnCornerEffect(currentElem.cornerEffect, theRadius)) & setData("corner radius 2", theRadius)
									elemData = elemData & setData("corner effect 3", returnCornerEffect(currentElem.cornerEffect, theRadius)) & setData("corner radius 3", theRadius)
									elemData = elemData & setData("corner effect 4", returnCornerEffect(currentElem.cornerEffect, theRadius)) & setData("corner radius 4", theRadius)
								end if

							case "CS5"
								elemData = elemData & setData("corner effect 1", returnCornerEffect(currentElem.topLeftCornerOption, currentElem.topLeftCornerRadius)) & setData("corner radius 1", returnCornerRadius(currentElem, currentElem.topLeftCornerRadius))
								elemData = elemData & setData("corner effect 4", returnCornerEffect(currentElem.topRightCornerOption, currentElem.topRightCornerRadius)) & setData("corner radius 4", returnCornerRadius(currentElem, currentElem.topRightCornerRadius))
								elemData = elemData & setData("corner effect 3", returnCornerEffect(currentElem.bottomRightCornerOption, currentElem.bottomRightCornerRadius)) & setData("corner radius 3", returnCornerRadius(currentElem, currentElem.bottomRightCornerRadius))
								elemData = elemData & setData("corner effect 2", returnCornerEffect(currentElem.bottomLeftCornerOption, currentElem.bottomLeftCornerRadius)) & setData("corner radius 2", returnCornerRadius(currentElem, currentElem.bottomLeftCornerRadius))
								
							case "CS5.5"
								elemData = elemData & setData("corner effect 1", returnCornerEffect(currentElem.topLeftCornerOption, currentElem.topLeftCornerRadius)) & setData("corner radius 1", returnCornerRadius(currentElem, currentElem.topLeftCornerRadius))
								elemData = elemData & setData("corner effect 4", returnCornerEffect(currentElem.topRightCornerOption, currentElem.topRightCornerRadius)) & setData("corner radius 4", returnCornerRadius(currentElem, currentElem.topRightCornerRadius))
								elemData = elemData & setData("corner effect 3", returnCornerEffect(currentElem.bottomRightCornerOption, currentElem.bottomRightCornerRadius)) & setData("corner radius 3", returnCornerRadius(currentElem, currentElem.bottomRightCornerRadius))
								elemData = elemData & setData("corner effect 2", returnCornerEffect(currentElem.bottomLeftCornerOption, currentElem.bottomLeftCornerRadius)) & setData("corner radius 2", returnCornerRadius(currentElem, currentElem.bottomLeftCornerRadius))
							
							case "CS6"
								elemData = elemData & setData("corner effect 1", returnCornerEffect(currentElem.topLeftCornerOption, currentElem.topLeftCornerRadius)) & setData("corner radius 1", returnCornerRadius(currentElem, currentElem.topLeftCornerRadius))
								elemData = elemData & setData("corner effect 4", returnCornerEffect(currentElem.topRightCornerOption, currentElem.topRightCornerRadius)) & setData("corner radius 4", returnCornerRadius(currentElem, currentElem.topRightCornerRadius))
								elemData = elemData & setData("corner effect 3", returnCornerEffect(currentElem.bottomRightCornerOption, currentElem.bottomRightCornerRadius)) & setData("corner radius 3", returnCornerRadius(currentElem, currentElem.bottomRightCornerRadius))
								elemData = elemData & setData("corner effect 2", returnCornerEffect(currentElem.bottomLeftCornerOption, currentElem.bottomLeftCornerRadius)) & setData("corner radius 2", returnCornerRadius(currentElem, currentElem.bottomLeftCornerRadius))
							
							case "CC"
								elemData = elemData & setData("corner effect 1", returnCornerEffect(currentElem.topLeftCornerOption, currentElem.topLeftCornerRadius)) & setData("corner radius 1", returnCornerRadius(currentElem, currentElem.topLeftCornerRadius))
								elemData = elemData & setData("corner effect 4", returnCornerEffect(currentElem.topRightCornerOption, currentElem.topRightCornerRadius)) & setData("corner radius 4", returnCornerRadius(currentElem, currentElem.topRightCornerRadius))
								elemData = elemData & setData("corner effect 3", returnCornerEffect(currentElem.bottomRightCornerOption, currentElem.bottomRightCornerRadius)) & setData("corner radius 3", returnCornerRadius(currentElem, currentElem.bottomRightCornerRadius))
								elemData = elemData & setData("corner effect 2", returnCornerEffect(currentElem.bottomLeftCornerOption, currentElem.bottomLeftCornerRadius)) & setData("corner radius 2", returnCornerRadius(currentElem, currentElem.bottomLeftCornerRadius))

							case "CC.2014"
								elemData = elemData & setData("corner effect 1", returnCornerEffect(currentElem.topLeftCornerOption, currentElem.topLeftCornerRadius)) & setData("corner radius 1", returnCornerRadius(currentElem, currentElem.topLeftCornerRadius))
								elemData = elemData & setData("corner effect 4", returnCornerEffect(currentElem.topRightCornerOption, currentElem.topRightCornerRadius)) & setData("corner radius 4", returnCornerRadius(currentElem, currentElem.topRightCornerRadius))
								elemData = elemData & setData("corner effect 3", returnCornerEffect(currentElem.bottomRightCornerOption, currentElem.bottomRightCornerRadius)) & setData("corner radius 3", returnCornerRadius(currentElem, currentElem.bottomRightCornerRadius))
								elemData = elemData & setData("corner effect 2", returnCornerEffect(currentElem.bottomLeftCornerOption, currentElem.bottomLeftCornerRadius)) & setData("corner radius 2", returnCornerRadius(currentElem, currentElem.bottomLeftCornerRadius))
							
							case "CC.2015"
								elemData = elemData & setData("corner effect 1", returnCornerEffect(currentElem.topLeftCornerOption, currentElem.topLeftCornerRadius)) & setData("corner radius 1", returnCornerRadius(currentElem, currentElem.topLeftCornerRadius))
								elemData = elemData & setData("corner effect 4", returnCornerEffect(currentElem.topRightCornerOption, currentElem.topRightCornerRadius)) & setData("corner radius 4", returnCornerRadius(currentElem, currentElem.topRightCornerRadius))
								elemData = elemData & setData("corner effect 3", returnCornerEffect(currentElem.bottomRightCornerOption, currentElem.bottomRightCornerRadius)) & setData("corner radius 3", returnCornerRadius(currentElem, currentElem.bottomRightCornerRadius))
								elemData = elemData & setData("corner effect 2", returnCornerEffect(currentElem.bottomLeftCornerOption, currentElem.bottomLeftCornerRadius)) & setData("corner radius 2", returnCornerRadius(currentElem, currentElem.bottomLeftCornerRadius))

							case "CC.2017"
								elemData = elemData & setData("corner effect 1", returnCornerEffect(currentElem.topLeftCornerOption, currentElem.topLeftCornerRadius)) & setData("corner radius 1", returnCornerRadius(currentElem, currentElem.topLeftCornerRadius))
								elemData = elemData & setData("corner effect 4", returnCornerEffect(currentElem.topRightCornerOption, currentElem.topRightCornerRadius)) & setData("corner radius 4", returnCornerRadius(currentElem, currentElem.topRightCornerRadius))
								elemData = elemData & setData("corner effect 3", returnCornerEffect(currentElem.bottomRightCornerOption, currentElem.bottomRightCornerRadius)) & setData("corner radius 3", returnCornerRadius(currentElem, currentElem.bottomRightCornerRadius))
								elemData = elemData & setData("corner effect 2", returnCornerEffect(currentElem.bottomLeftCornerOption, currentElem.bottomLeftCornerRadius)) & setData("corner radius 2", returnCornerRadius(currentElem, currentElem.bottomLeftCornerRadius))

							case "CC.2018"
								elemData = elemData & setData("corner effect 1", returnCornerEffect(currentElem.topLeftCornerOption, currentElem.topLeftCornerRadius)) & setData("corner radius 1", returnCornerRadius(currentElem, currentElem.topLeftCornerRadius))
								elemData = elemData & setData("corner effect 4", returnCornerEffect(currentElem.topRightCornerOption, currentElem.topRightCornerRadius)) & setData("corner radius 4", returnCornerRadius(currentElem, currentElem.topRightCornerRadius))
								elemData = elemData & setData("corner effect 3", returnCornerEffect(currentElem.bottomRightCornerOption, currentElem.bottomRightCornerRadius)) & setData("corner radius 3", returnCornerRadius(currentElem, currentElem.bottomRightCornerRadius))
								elemData = elemData & setData("corner effect 2", returnCornerEffect(currentElem.bottomLeftCornerOption, currentElem.bottomLeftCornerRadius)) & setData("corner radius 2", returnCornerRadius(currentElem, currentElem.bottomLeftCornerRadius))

							case "CC.2019"
								elemData = elemData & setData("corner effect 1", returnCornerEffect(currentElem.topLeftCornerOption, currentElem.topLeftCornerRadius)) & setData("corner radius 1", returnCornerRadius(currentElem, currentElem.topLeftCornerRadius))
								elemData = elemData & setData("corner effect 4", returnCornerEffect(currentElem.topRightCornerOption, currentElem.topRightCornerRadius)) & setData("corner radius 4", returnCornerRadius(currentElem, currentElem.topRightCornerRadius))
								elemData = elemData & setData("corner effect 3", returnCornerEffect(currentElem.bottomRightCornerOption, currentElem.bottomRightCornerRadius)) & setData("corner radius 3", returnCornerRadius(currentElem, currentElem.bottomRightCornerRadius))
								elemData = elemData & setData("corner effect 2", returnCornerEffect(currentElem.bottomLeftCornerOption, currentElem.bottomLeftCornerRadius)) & setData("corner radius 2", returnCornerRadius(currentElem, currentElem.bottomLeftCornerRadius))

							case "2020"
								elemData = elemData & setData("corner effect 1", returnCornerEffect(currentElem.topLeftCornerOption, currentElem.topLeftCornerRadius)) & setData("corner radius 1", returnCornerRadius(currentElem, currentElem.topLeftCornerRadius))
								elemData = elemData & setData("corner effect 4", returnCornerEffect(currentElem.topRightCornerOption, currentElem.topRightCornerRadius)) & setData("corner radius 4", returnCornerRadius(currentElem, currentElem.topRightCornerRadius))
								elemData = elemData & setData("corner effect 3", returnCornerEffect(currentElem.bottomRightCornerOption, currentElem.bottomRightCornerRadius)) & setData("corner radius 3", returnCornerRadius(currentElem, currentElem.bottomRightCornerRadius))
								elemData = elemData & setData("corner effect 2", returnCornerEffect(currentElem.bottomLeftCornerOption, currentElem.bottomLeftCornerRadius)) & setData("corner radius 2", returnCornerRadius(currentElem, currentElem.bottomLeftCornerRadius))

							case "2021"
								elemData = elemData & setData("corner effect 1", returnCornerEffect(currentElem.topLeftCornerOption, currentElem.topLeftCornerRadius)) & setData("corner radius 1", returnCornerRadius(currentElem, currentElem.topLeftCornerRadius))
								elemData = elemData & setData("corner effect 4", returnCornerEffect(currentElem.topRightCornerOption, currentElem.topRightCornerRadius)) & setData("corner radius 4", returnCornerRadius(currentElem, currentElem.topRightCornerRadius))
								elemData = elemData & setData("corner effect 3", returnCornerEffect(currentElem.bottomRightCornerOption, currentElem.bottomRightCornerRadius)) & setData("corner radius 3", returnCornerRadius(currentElem, currentElem.bottomRightCornerRadius))
								elemData = elemData & setData("corner effect 2", returnCornerEffect(currentElem.bottomLeftCornerOption, currentElem.bottomLeftCornerRadius)) & setData("corner radius 2", returnCornerRadius(currentElem, currentElem.bottomLeftCornerRadius))

							case "2022"
								elemData = elemData & setData("corner effect 1", returnCornerEffect(currentElem.topLeftCornerOption, currentElem.topLeftCornerRadius)) & setData("corner radius 1", returnCornerRadius(currentElem, currentElem.topLeftCornerRadius))
								elemData = elemData & setData("corner effect 4", returnCornerEffect(currentElem.topRightCornerOption, currentElem.topRightCornerRadius)) & setData("corner radius 4", returnCornerRadius(currentElem, currentElem.topRightCornerRadius))
								elemData = elemData & setData("corner effect 3", returnCornerEffect(currentElem.bottomRightCornerOption, currentElem.bottomRightCornerRadius)) & setData("corner radius 3", returnCornerRadius(currentElem, currentElem.bottomRightCornerRadius))
								elemData = elemData & setData("corner effect 2", returnCornerEffect(currentElem.bottomLeftCornerOption, currentElem.bottomLeftCornerRadius)) & setData("corner radius 2", returnCornerRadius(currentElem, currentElem.bottomLeftCornerRadius))
							
							case "2023"
								elemData = elemData & setData("corner effect 1", returnCornerEffect(currentElem.topLeftCornerOption, currentElem.topLeftCornerRadius)) & setData("corner radius 1", returnCornerRadius(currentElem, currentElem.topLeftCornerRadius))
								elemData = elemData & setData("corner effect 4", returnCornerEffect(currentElem.topRightCornerOption, currentElem.topRightCornerRadius)) & setData("corner radius 4", returnCornerRadius(currentElem, currentElem.topRightCornerRadius))
								elemData = elemData & setData("corner effect 3", returnCornerEffect(currentElem.bottomRightCornerOption, currentElem.bottomRightCornerRadius)) & setData("corner radius 3", returnCornerRadius(currentElem, currentElem.bottomRightCornerRadius))
								elemData = elemData & setData("corner effect 2", returnCornerEffect(currentElem.bottomLeftCornerOption, currentElem.bottomLeftCornerRadius)) & setData("corner radius 2", returnCornerRadius(currentElem, currentElem.bottomLeftCornerRadius))
								
							case "2024"
								elemData = elemData & setData("corner effect 1", returnCornerEffect(currentElem.topLeftCornerOption, currentElem.topLeftCornerRadius)) & setData("corner radius 1", returnCornerRadius(currentElem, currentElem.topLeftCornerRadius))
								elemData = elemData & setData("corner effect 4", returnCornerEffect(currentElem.topRightCornerOption, currentElem.topRightCornerRadius)) & setData("corner radius 4", returnCornerRadius(currentElem, currentElem.topRightCornerRadius))
								elemData = elemData & setData("corner effect 3", returnCornerEffect(currentElem.bottomRightCornerOption, currentElem.bottomRightCornerRadius)) & setData("corner radius 3", returnCornerRadius(currentElem, currentElem.bottomRightCornerRadius))
								elemData = elemData & setData("corner effect 2", returnCornerEffect(currentElem.bottomLeftCornerOption, currentElem.bottomLeftCornerRadius)) & setData("corner radius 2", returnCornerRadius(currentElem, currentElem.bottomLeftCornerRadius))

							case Else
								'All other CS's
								
								theRadius = returnCornerRadius(currentElem, currentElem.CornerRadius)
								
								if(theRadius = 0)then
									'do nothing
								else
									elemData = elemData & setData("corner effect 1", returnCornerEffect(currentElem.cornerOption, theRadius)) & setData("corner radius 1", theRadius)
									elemData = elemData & setData("corner effect 2", returnCornerEffect(currentElem.cornerOption, theRadius)) & setData("corner radius 2", theRadius)
									elemData = elemData & setData("corner effect 3", returnCornerEffect(currentElem.cornerOption, theRadius)) & setData("corner radius 3", theRadius)
									elemData = elemData & setData("corner effect 4", returnCornerEffect(currentElem.cornerOption, theRadius)) & setData("corner radius 4", theRadius)
								end if
						end select
					end if
					
					
					if(correctPathData)then
						'points
						elemData = elemData & setData("point data", pointData(currentElem))
					end if
				end if
				
				
				
				'Variable area
				if (currentElem.ExtractLabel ("type") = "area") then
					elemData = setData("Type", "Area") & setData("z index", GetItemIndex(myInDesign, currentElem)) & setData("name", currentElem.Label) & setData("Bounds", getBounds(currentElem)) & setData("spread", myPageCount)
					elemData = elemData & setData("Sort", currentElem.ExtractLabel ("sort")) & setData("rows", currentElem.ExtractLabel ("rows")) & setData("columns", currentElem.ExtractLabel ("cols")) & setData("style code", UCase(currentElem.ExtractLabel ("styleCode")))
				end if
				
				
				
				'Overlay
				if (currentElem.ExtractLabel ("type") = "overlay") then
					elemData = setData("Type", "Overlay") & setData("Name", currentElem.Label) & setData("spread", myPageCount) & setData("Sort", currentElem.ExtractLabel ("sort")) & setData("Bounds", getBounds(currentElem)) 
				end if					
				
				
				'Generic
				if (currentElem.ExtractLabel ("type") = "generic") then
					elemData = setData("Type", "Generic") & setData("spread", myPageCount)  & setData("Bounds", getBounds(currentElem)) & setData("z index", GetItemIndex(myInDesign, currentElem))

					elemData = elemData & setData("path", pointData(currentElem)) & setData("colour type", returnColourType(currentElem.FillColor.name))
				end if
				
				
				'if data has been collected then send it to the file
				if(elemData <> "") then
					objTextStream.WriteLine elemData
				end if
			Next
			'Pages
		Next
		
		
		
		'Capture text style data
		set charStyles = myInDesign.ActiveDocument.CharacterStyles
		
		For myCounter = 1 To charStyles.Count
			set currentStyle = charStyles(myCounter)
			
			'only capture user created character styles
			if(currentStyle.Name <> "[None]") then
				'we do not want the point size to change, used for wysiwyg
				if(currentStyle.PointSize = 0.1) then
					thePointSize = ""
				else
					thePointSize = currentStyle.PointSize
				end if
				
				
				elemData = setData("Type", "Character Style") & setData("Name", currentStyle.Name) & setData("font face1", returnStyleFontFace(currentStyle)) & setData("font face2", returnStyleFontFace2(currentStyle)) & setData("font face3", returnStyleFontFace3(currentStyle)) & setData("fill colour", returnCharacterFillColour(currentStyle)) & setData("baseline shift", currentStyle.BaselineShift)
				
				elemData = elemData & setData("capitalization", returnCapitalization(currentStyle.Capitalization)) & setData("superscript", returnSuperscript(currentStyle.position)) & setData("subscript", returnSubscript(currentStyle.position)) & setData("skew", returnStyleSkew(currentStyle.skew)) & setData("tracking", returnTracking(currentStyle.Tracking)) & setData("horizontal scale", returnHorizontalScale(currentStyle.horizontalScale))

				'if(currentStyle.Name = "drop caps")then
					'no font size
				'else
					elemData = elemData & setData("font size", thePointSize)
				'end if
				
				'stroke
				if(currentStyle.StrokeWeight <> 1851876449)then
					elemData = elemData & setData("stroke colour", returnStyleStrokeColour(currentStyle)) & setData("stroke weight", returnStrokeWeight(currentStyle.StrokeWeight))
				end if
				
				'only set leading if assigned
				if(currentStyle.Leading = 1635019116)then
					elemData = elemData & setData("leading", "100%")
				else
					elemData = elemData & setData("leading", currentStyle.Leading)
				end if
				
				
				'underline
				if(currentStyle.Underline = true)then
					elemData = elemData & setData("underline enabled", "true") & setData("underline weight", returnUnderlineWeight(currentStyle.UnderlineWeight)) & setData("underline position", returnUnderlinePosition(currentStyle.UnderlineOffset)) & setData("underline colour", returnStyleUnderlineColour(currentStyle))
				else
					if(currentStyle.Underline = false)then
						elemData = elemData & setData("underline enabled", "false")
					end if
				end if
				
				
				'strike through
				if(currentStyle.StrikeThru = true)then
					elemData = elemData & setData("strike enabled", "true") & setData("strike weight", returnStyleStrikeWeight(currentStyle.StrikethroughWeight)) & setData("strike colour", returnStyleStrikeColour(currentStyle))
					'& setData("strike position", returnStrikePosition(currentStyle.StrikethroughOffset))
				end if
				
				
				'if an option is not set then set it as blank
				elemData = replace(elemData,"1851876449","")
				
				objTextStream.WriteLine elemData
			end if
		Next
		
	end if
	
	
	'Change units back to user defined
	myInDesign.ActiveDocument.viewPreferences.HorizontalMeasurementUnits = userUnitsHoriz
	myInDesign.ActiveDocument.viewPreferences.VerticalMeasurementUnits = userUnitsVert
	
End Sub


function returnColourType(colourName)
	select case colourName
		case "Primary Colour"
			returnVal = "primary"
	 	case "primary colour"
			returnVal = "primary"
		case "Secondary Colour"
			returnVal = "secondary"
	 	case "secondary colour"
			returnVal = "secondary"	
		case "Tertiary Colour"
			returnVal = "tertiary"
	 	case "tertiary colour"
			returnVal = "tertiary"
		case "Quaternary Colour"
			returnVal = "quaternary"
	 	case "quaternary colour"
			returnVal = "quaternary"
		case "gc1"
			returnVal = "gc1"
		case "GC1"
			returnVal = "GC1"
		case "gc2"
			returnVal = "gc2"
		case "GC2"
			returnVal = "GC2"
		case "gc3"
			returnVal = "gc3"
		case "GC3"
			returnVal = "GC3"
		case "gc4"
			returnVal = "gc4"
		case "GC4"
			returnVal = "GC4"
		case "gc5"
			returnVal = "gc5"
		case "GC5"
			returnVal = "GC5"
		case "gc6"
			returnVal = "gc6"
		case "GC6"
			returnVal = "GC6"
		case "gc7"
			returnVal = "gc7"
		case "GC7"
			returnVal = "GC7"
		case "gc8"
			returnVal = "gc8"
		case "GC8"
			returnVal = "GC8"
		case "gc9"
			returnVal = "gc9"
		case "GC9"
			returnVal = "GC9"
		case "gc10"
			returnVal = "gc10"
		case "GC10"
			returnVal = "GC10"
	 	case Else
	 		'default to primary
			returnVal = "primary"
	end select

	returnColourType = returnVal
end function


function element_overlay(myInDesign, allElems, currentElem, tmpFilePath)
	'work out if image has unconfigured elements over it.
	needToExport = false
	
	'hide all elements
	For myIndexCounter = 1 To allElems.Count
		set currentIndexElem = allElems(myIndexCounter)
		currentIndexElem.Nonprinting = true
		
		if(currentIndexElem.ExtractLabel ("type") = "text") then
			'remove current text from box as we will be placing text over this
			currentIndexElem.Contents = ""
		end if
	Next
	
	'currentElem.select
	'msgbox("Name: " & currentElem.label)
	
	For myIndexCounter = 1 To allElems.Count
		'set the current element
		set currentIndexElem = allElems(myIndexCounter)
		
		'dont show flash as they will be removed
		if (currentIndexElem.ExtractLabel ("type") <> "flash")then
			'element index is less than current image
			if(GetItemIndex(myInDesign, currentIndexElem) < GetItemIndex(myInDesign, currentElem)) then
				
				'currentIndexElem.select

				if(currentIndexElem.ExtractLabel ("type") = "text") then
					'remove current text from box as we will be placing text over this
					Do
						currentIndexElem.contents = ""
					Loop While currentIndexElem.contents <> ""
				end if
				
				
				'position of element is over current image
				vertFits = false
				horizFits = false
				
				'changed due to ticket 7043957
				'bounds = split(getBounds(currentElem),",")
				'config_top = CInt(bounds(0))
				'config_bottom = CInt(bounds(2))
				'config_left = CInt(bounds(1))
				'config_right = CInt(bounds(3))

				config_top = currentElem.GeometricBounds(0)
				config_bottom = currentElem.GeometricBounds(2)
				config_left = currentElem.GeometricBounds(1)
				config_right = currentElem.GeometricBounds(3)
				
				
				'changed due to ticket 7043957
				'bounds = split(getBounds(currentIndexElem),",")
				'elem_top = CInt(bounds(0))
				'elem_bottom = CInt(bounds(2))
				'elem_left = CInt(bounds(1))
				'elem_right = CInt(bounds(3))

				elem_top = currentIndexElem.GeometricBounds(0)
				elem_bottom = currentIndexElem.GeometricBounds(2)
				elem_left = currentIndexElem.GeometricBounds(1)
				elem_right = currentIndexElem.GeometricBounds(3)
				
				
				'msgbox(elem_top & " " & config_top  & " " & config_bottom)
				if(elem_top >= config_top) AND (elem_top <= config_bottom)then
					vertFits = true
				end if
				
				if(elem_bottom >= config_top) AND (elem_bottom <= config_bottom)then
					vertFits = true
				end if
				
				'the element covers the entire configured element
				if(elem_top <= config_top) AND (elem_bottom >= config_bottom)then
					vertFits = true
				end if
				
				'msgbox(elem_left & " " & config_left  & " " & config_right)
				'msgbox((elem_left >= config_left) & " " & (elem_left <= config_right))
				if(elem_left >= config_left) AND (elem_left <= config_right)then
					horizFits = true
				end if
				
				if(elem_right >= config_left) AND (elem_right <= config_right)then
					horizFits = true
				end if
				
				'the element covers the entire configured element
				if(elem_left <= config_left) AND (elem_right >= config_right)then
					horizFits = true
				end if
				
				'msgbox(vertFits & "AND" & horizFits)
				if(vertFits AND horizFits)then
					'set export flag
					needToExport = true
					
					'display the element
					allElems(myIndexCounter).Nonprinting = false
				end if
			end if
		end if
	Next
	
	'do we need to export a pdf
	if(needToExport) then
		myInDesign.ActiveDocument.Export "Adobe PDF", replace(tmpFilePath,"#", currentElem.ExtractLabel ("sort")), false, myItemPreset
	end if
	
	'show all elements
	For myIndexCounter = 1 To allElems.Count
		allElems(myIndexCounter).Nonprinting = false
	Next
end function


function returnStyleSkew(skewValue)
	if(skewValue=1851876449)then
		skewValue = "0"
	else
		skewValue = "-" & skewValue
	end if
	
	returnStyleSkew = skewValue
end function

Function returnSmallCapsPref(myInDesign)
	returnSmallCapsPref = myInDesign.ActiveDocument.TextPreferences.SmallCap
end function


Function returnSuperscriptSize(myInDesign)
	returnSuperscriptSize = myInDesign.ActiveDocument.TextPreferences.SuperscriptSize
end function


Function returnSuperscriptPos(myInDesign)
	returnSuperscriptPos = myInDesign.ActiveDocument.TextPreferences.SuperscriptPosition
end function


Function returnSubscriptSize(myInDesign)
	returnSubscriptSize = myInDesign.ActiveDocument.TextPreferences.SubscriptSize
end function


Function returnSubscriptPos(myInDesign)
	returnSubscriptPos = myInDesign.ActiveDocument.TextPreferences.SubscriptPosition
end function


Function returnSkew(currentElem)
	
	if(currentElem.characters(1).Skew = 0)then
		returnVal = "-" & currentElem.ShearAngle
	else
		returnVal = "-" & currentElem.characters(1).Skew
	end if
	
	returnSkew = returnVal
end function


Function textOptions(currentElem, myInDesign)
	
	if(currentElem.contents="")then
		currentElem.contents = "a"
	end if
	
	if(currentElem.Overflows)then
		currentElem.select
		msgbox("Text box contains overflowing copy and cannot be configured.")
	else
		'if leading is set to auto then make it 120%
		if(currentElem.characters(1).Leading = 1635019116) then
			vtLeading = currentElem.characters(1).AutoLeading & "%"
			'vtLeading = "120%"
		else
			'vtLeading = (round((currentElem.characters(1).Leading/currentElem.characters(1).PointSize),2) * 100) & "%"
			vtLeading = currentElem.characters(1).Leading
		end if
		

		'collect data
		elemData = elemData & setData("font face1", returnFontFace(currentElem)) & setData("font face2", returnFontFace2(currentElem)) & setData("font face3", returnFontFace3(currentElem)) & setData("font size", currentElem.characters(1).PointSize) & setData("horizontal justification", returnHorizontalJustification(currentElem.characters(1).Justification)) & setData("leading", vtLeading) & setData("fill colour", returnFillColour(currentElem)) & setData("horizontal scaling", currentElem.characters(1).HorizontalScale) & setData("strike through enabled", currentElem.characters(1).StrikeThru) & setData("strike through weight", currentElem.characters(1).StrikeThroughWeight) & setData("strike through offset", currentElem.characters(1).StrikeThroughOffset) & setData("strike through colour", returnStrikeColour(currentElem))
		elemData = elemData & setData("capitalization", returnCapitalization(currentElem.characters(1).Capitalization)) & setData("baseline shift", currentElem.characters(1).BaselineShift) & setData("tracking", returnTracking(currentElem.characters(1).Tracking))
		elemData = elemData & setData("left indent", currentElem.characters(1).LeftIndent) & setData("first line indent", currentElem.characters(1).FirstLineIndent) & setData("last line align", returnLastLineAlign(currentElem, currentElem.characters(1).Justification)) & setData("right indent", currentElem.characters(1).rightIndent) & setData("last line right indent", currentElem.characters(1).LastLineIndent)
		elemData = elemData & setData("rotation", currentElem.RotationAngle) & setData("italic angle", returnSkew(currentElem)) & setData("vertical justification", returnVerticalJustification(currentElem.textFramePreferences.verticalJustification, currentElem.ExtractLabel ("vertOverride"))) & setData("first baseline offset", returnFirstBaseline(currentElem.textFramePreferences.FirstBaselineOffset, currentElem.textFramePreferences.MinimumFirstBaselineOffset)) 
		
		'paragraph data
		elemData = elemData & setData("space after", currentElem.Paragraphs(1).SpaceAfter)
		elemData = elemData & setData("drop caps", currentElem.Paragraphs(1).DropCapLines)


		if(currentElem.characters(1).OverprintFill)then
			elemData = elemData & setData("overprint fill", "true")
		else
			elemData = elemData & setData("overprint fill", "false")
		end if


		'stroke
		elemData = elemData & setData("stroke colour", returnStrokeColour(currentElem)) & setData("stroke weight", returnStrokeWeight(currentElem.characters(1).StrokeWeight)) & setData("miter limit", currentElem.characters(1).MiterLimit)

		
		'Linked text frames
		linkedData = ""
		if(currentElem.id <> currentElem.EndTextFrame.id) then
			lastLinkedFrame = currentElem.EndTextFrame.TextFrameIndex
			currentLinkedId = currentElem.id
			
			set currentFrame = currentElem.NextTextFrame
			For linkedLoop = 2 To lastLinkedFrame
				originalRotation = currentFrame.RotationAngle
				currentFrame.RotationAngle = 0

				linkedData = linkedData & "<column top='" + CStr(currentFrame.GeometricBounds(0)) + "' left='" + CStr(currentFrame.GeometricBounds(1)) + "' width='" + CStr(currentFrame.GeometricBounds(3)-currentFrame.GeometricBounds(1)) + "' height='" + CStr(currentFrame.GeometricBounds(2)-currentFrame.GeometricBounds(0)) + "'></column>"
				
				currentFrame.RotationAngle=originalRotation

				'select next column
				set currentFrame = currentFrame.NextTextFrame
			Next
		end if
		elemData = elemData & setData("linked text frame data", linkedData)
		
		
		'points
		elemData = elemData & setData("point data", pointData(currentElem))
		
		
		'Tabs
		tabData = ""
		for i = 1 to currentElem.Paragraphs(1).TabStops.Count
			set myTab = currentElem.Paragraphs(1).TabStops(i)
			tabData = tabData & myTab.Position & "_" & myTab.Leader & "_" & getTabAlignment(myTab.Alignment) & ";"
		next
		elemData = elemData + setData("tab Pos", tabData)
		
		
		'underline
		if(currentElem.characters(1).Underline)then
			elemData = elemData & setData("underline enabled", "true") & setData("underline weight", returnUnderlineWeight(currentElem.characters(1).UnderlineWeight)) & setData("underline position", returnUnderlinePosition(currentElem.characters(1).UnderlineOffset)) & setData("underline colour", returnUnderlineColour(currentElem))
		end if
	end if
	
	textOptions = elemData
end function


function returnFitMethodSize (fitMethod, fitSize)
	returnValue = ""
	
	select case fitMethod
		case "Adjust By Size"
			returnValue = fitSize
		case "Adjust By Leading"
			returnValue = fitSize
		case "Adjust by Horizontal Scale"
			returnValue = fitSize
		case "Adjust by Word Spacing"
			returnValue = fitSize
		case "Adjust by Tracking"
			fitSize = CInt(fitSize)
			
			if(fitSize = 0)then
				returnValue = 0
			else
				returnValue = fitSize * 0.012
			end if
	end select
	
	returnFitMethodSize = returnValue
end function


Function checkFileExists(filePathToCheck)
	dim filesys
	dim returnVal
	
	Set filesys = CreateObject("Scripting.FileSystemObject") 

	If filesys.FileExists(filePathToCheck) Then
		returnVal = true
	else
		returnVal = false
	End If 
	
	checkFileExists = returnVal
End Function


function setData (elemName, elemValue)
	'setData = elemName & theDelimeter & elemValue & theDelimeter
	
	'strip bad chars
	elemValue = stripTags(elemValue)
	
	setData = elemName & " value121" & theDelimeter & elemValue & theDelimeter
end function


Function PostFile(ByRef url, ByRef fileObj)
	Dim returnMe
	Dim commandLine
	
	returnMe = ""
	commandLine = "-F upload=@" & chr(34) & fileObj & chr(34) & " " & url
	
	

	tmpSize = getFileSize(fileObj)
	if(tmpSize > 6144)then
		returnMe = CurlLarge(commandLine)
	else
		returnMe = CURL(commandLine)
	end if

	PostFile = returnMe
End Function


Function CurlLarge(ByVal commandLine)
	Dim returnMe
	Dim errMsg
	Dim WshShell, curlExec, i
	
	returnMe = ""
	theProxy = ReadPref("Server_Proxy")
	
	if theProxy <> "" then
		commandLine = "-x " & theProxy & " " & commandLine
	end if
	
	commandLine = "curl " & commandLine
	Set WshShell = CreateObject("WScript.Shell")
	
	On Error Resume Next
	Set curlExec = WshShell.Exec(commandLine)


	errMsg = Err.Description
	On Error Goto 0
	
	If IsObject(curlExec) Then
		Dim timeLeft
		
		'Time left in seconds
		timeLeft = 600
		Do While (curlExec.Status = 0) And (timeLeft > 0)
			SillySleep(1)
			timeLeft = timeLeft - 1
		Loop

		If (timeLeft > 0) Then
			If (curlExec.ExitCode = 0) Then
				returnMe = curlExec.StdOut.ReadAll
			Else
				Dim errNum, errText
				errText = curlExec.StdOut.ReadAll
				errNum = curlExec.ExitCode
				returnMe = errText
			End If
		Else
			curlExec.Terminate
		End If
	Else
		msgbox("Unable to find curl.exe")
	End If
	
	CurlLarge = returnMe
End Function